var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: !0, configurable: !0, writable: !0, value }) : obj[key] = value;
var __name = (target, value) => __defProp(target, "name", { value, configurable: !0 });
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key != "symbol" ? key + "" : key, value);
import { CommandType, ICommandService, IUniverInstanceService, IUndoRedoService, ObjectMatrix, Range, sequenceExecute, Inject, LocaleService, Disposable, ColorKit, BooleanNumber, useDependency, Injector, UniverInstanceType, Rectangle, Tools, get, set, createInterceptorKey, InterceptorManager, generateRandomId, toDisposable, InterceptorEffectEnum, DependentOn, Plugin, merge as merge$1, IConfigService, registerDependencies, touchDependencies } from "@univerjs/core";
import { ConditionalFormattingRuleModel, CFRuleType, CFSubRuleType, AddConditionalRuleMutation, AddConditionalRuleMutationUndoFactory, CFNumberOperator, setConditionalRuleMutationUndoFactory, SetConditionalRuleMutation, DeleteConditionalRuleMutationUndoFactory, DeleteConditionalRuleMutation, transformSupportSymmetryAnchor, MoveConditionalRuleMutationUndoFactory, MoveConditionalRuleMutation, getColorScaleFromValue, iconMap, DEFAULT_BG_COLOR, DEFAULT_FONT_COLOR, defaultDataBarPositiveColor, defaultDataBarNativeColor, CFValueType, createDefaultValueByValueType, removeUndefinedAttr, createDefaultValue, CFTextOperator, CFTimePeriodOperator, iconGroup, getOppositeOperator, compareWithNumber, EMPTY_ICON_TYPE, createDefaultRule, ConditionalFormattingViewModel, SHEET_CONDITIONAL_FORMATTING_PLUGIN, isRangesEqual, ConditionalFormattingService, DEFAULT_PADDING, DEFAULT_WIDTH, UniverSheetsConditionalFormattingPlugin, CONDITIONAL_FORMATTING_VIEWPORT_CACHE_LENGTH } from "@univerjs/sheets-conditional-formatting";
import { getSheetCommandTarget, SheetsSelectionsService, findAllRectangle, createTopMatrixFromMatrix, SetWorksheetActiveOperation, SetSelectionsOperation, checkRangesEditablePermission, RemoveSheetMutation, setEndForRange, SheetPermissionCheckController, WorkbookEditablePermission, RangeProtectionPermissionEditPoint, WorksheetEditPermission, WorksheetSetCellStylePermission, RefRangeService, handleDefaultRangeChangeWithEffectRefCommands, SheetInterceptorService, INTERCEPTOR_POINT, ClearSelectionFormatCommand, ClearSelectionAllCommand, RangeMergeUtil, AFTER_CELL_EDIT } from "@univerjs/sheets";
import { useObservable, ComponentManager, useSidebarClick, ILayoutService, useScrollYOverContainer, ISidebarService, MenuItemType, getMenuHiddenObservable, RibbonStartGroup, IMenuManagerService } from "@univerjs/ui";
import { jsx, jsxs, Fragment } from "react/jsx-runtime";
import require$$0, { forwardRef, useRef, createElement, useMemo, useState, useEffect } from "react";
import { Select, Tooltip, DropdownLegacy, ColorPicker as ColorPicker$1, InputNumber, RadioGroup, Radio, Checkbox, Input, Button } from "@univerjs/design";
import { serializeRange, deserializeRangeWithSheet } from "@univerjs/engine-formula";
import { useHighlightRange, ISheetClipboardService, COPY_TYPE, rangeToDiscreteRange, PREDEFINED_HOOK_NAME, virtualizeDiscreteRanges, getRepeatRange, SheetSkeletonManagerService, IAutoFillService, APPLY_TYPE, getAutoFillRepeatRange, getCurrentRangeDisable$, IFormatPainterService, FormatPainterStatus } from "@univerjs/sheets-ui";
import require$$2$1 from "react-dom";
import { Observable, debounceTime, merge } from "rxjs";
import { FormulaEditor, RangeSelector } from "@univerjs/sheets-formula-ui";
import { IRenderManagerService } from "@univerjs/engine-render";
import { bufferTime, filter, debounceTime as debounceTime$1 } from "rxjs/operators";
const AddAverageCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-average-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, style, stopIfTrue, operator } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.highlightCell,
        subType: CFSubRuleType.average,
        operator,
        style
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { rule } = params, undoRedoService = accessor.get(IUndoRedoService), commandService = accessor.get(ICommandService), conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), config = { unitId, subUnitId, rule: { ...rule, cfId: rule.cfId || cfId } }, undo = AddConditionalRuleMutationUndoFactory(accessor, config), result = commandService.syncExecuteCommand(AddConditionalRuleMutation.id, config);
    return result && undoRedoService.pushUndoRedo({
      unitID: unitId,
      redoMutations: [{ id: AddConditionalRuleMutation.id, params: config }],
      undoMutations: [undo]
    }), result;
  }
}, AddColorScaleConditionalRuleCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-color-scale-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, config, stopIfTrue } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.colorScale,
        config
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddDataBarConditionalRuleCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-data-bar-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, min, max, nativeColor, positiveColor, isGradient, stopIfTrue, isShowValue } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, commandService = accessor.get(ICommandService), cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.dataBar,
        isShowValue,
        config: {
          min,
          max,
          nativeColor,
          positiveColor,
          isGradient
        }
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddDuplicateValuesCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-duplicate-values-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, style, stopIfTrue } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.highlightCell,
        subType: CFSubRuleType.duplicateValues,
        style
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddNumberCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-number-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, style, stopIfTrue, operator, value } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId);
    let rule;
    if ([CFNumberOperator.between, CFNumberOperator.notBetween].includes(operator)) {
      const _value = value;
      if (_value.length !== 2 || !Array.isArray(_value))
        return !1;
      rule = {
        ranges,
        cfId,
        stopIfTrue: !!stopIfTrue,
        rule: {
          type: CFRuleType.highlightCell,
          subType: CFSubRuleType.number,
          operator,
          style,
          value: _value
        }
      };
    } else {
      const _value = value;
      if (typeof _value != "number")
        return !1;
      rule = {
        ranges,
        cfId,
        stopIfTrue: !!stopIfTrue,
        rule: {
          type: CFRuleType.highlightCell,
          subType: CFSubRuleType.number,
          operator,
          style,
          value: _value
        }
      };
    }
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddRankCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-rank-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, style, stopIfTrue, isPercent, isBottom, value } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), commandService = accessor.get(ICommandService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.highlightCell,
        subType: CFSubRuleType.rank,
        isPercent,
        isBottom,
        style,
        value
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddTextCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-text-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, style, stopIfTrue, operator, value } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, commandService = accessor.get(ICommandService), cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.highlightCell,
        subType: CFSubRuleType.text,
        operator,
        style,
        value
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddTimePeriodCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-time-period-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, style, stopIfTrue, operator } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), commandService = accessor.get(ICommandService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.highlightCell,
        subType: CFSubRuleType.timePeriod,
        operator,
        style
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, AddUniqueValuesCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.add-uniqueValues-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const { ranges, style, stopIfTrue } = params, conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), commandService = accessor.get(ICommandService), target = getSheetCommandTarget(univerInstanceService);
    if (!target) return !1;
    const { unitId, subUnitId } = target, cfId = conditionalFormattingRuleModel.createCfId(unitId, subUnitId), rule = {
      ranges,
      cfId,
      stopIfTrue: !!stopIfTrue,
      rule: {
        type: CFRuleType.highlightCell,
        subType: CFSubRuleType.uniqueValues,
        style
      }
    };
    return commandService.executeCommand(AddConditionalRuleMutation.id, { unitId, subUnitId, rule });
  }
}, ClearRangeCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.clear-range-conditional-rule",
  handler(accessor, params) {
    var _a15;
    if (!params)
      return !1;
    const conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), commandService = accessor.get(ICommandService), undoRedoService = accessor.get(IUndoRedoService), selectionManagerService = accessor.get(SheetsSelectionsService), target = getSheetCommandTarget(univerInstanceService, params);
    if (!target) return !1;
    const { unitId, subUnitId } = target, ranges = ((_a15 = selectionManagerService.getCurrentSelections()) == null ? void 0 : _a15.map((selection) => selection.range)) || [], allRuleList = conditionalFormattingRuleModel.getSubunitRules(unitId, subUnitId);
    if (!(allRuleList != null && allRuleList.length) || !ranges.length)
      return !1;
    const redos = [], undos = [];
    allRuleList.forEach((oldRule) => {
      const matrix = new ObjectMatrix();
      oldRule.ranges.forEach((range) => {
        Range.foreach(range, (row, col) => {
          matrix.setValue(row, col, 1);
        });
      }), ranges.forEach((range) => {
        Range.foreach(range, (row, col) => {
          matrix.realDeleteValue(row, col);
        });
      });
      const newRanges = findAllRectangle(createTopMatrixFromMatrix(matrix));
      if (newRanges.length) {
        const rule = { ...oldRule, ranges: newRanges }, params2 = { unitId, subUnitId, rule }, undo = setConditionalRuleMutationUndoFactory(accessor, params2);
        redos.push({ id: SetConditionalRuleMutation.id, params: params2 }), undos.push(...undo);
      } else {
        const params2 = { unitId, subUnitId, cfId: oldRule.cfId }, undo = DeleteConditionalRuleMutationUndoFactory(accessor, params2);
        redos.push({ id: DeleteConditionalRuleMutation.id, params: params2 }), undos.push(...undo);
      }
    });
    const result = sequenceExecute(redos, commandService).result;
    return result && undoRedoService.pushUndoRedo({
      unitID: unitId,
      redoMutations: redos,
      undoMutations: undos
    }), result;
  }
}, ClearWorksheetCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.clear-worksheet-conditional-rule",
  handler(accessor, params) {
    const conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), univerInstanceService = accessor.get(IUniverInstanceService), commandService = accessor.get(ICommandService), undoRedoService = accessor.get(IUndoRedoService), target = getSheetCommandTarget(univerInstanceService, params);
    if (!target) return !1;
    const { unitId, subUnitId } = target, ruleList = conditionalFormattingRuleModel.getSubunitRules(unitId, subUnitId);
    if (!(ruleList != null && ruleList.length))
      return !1;
    const configList = ruleList.map((rule) => ({ cfId: rule.cfId, unitId, subUnitId })), redos = configList.map((config) => ({ id: DeleteConditionalRuleMutation.id, params: config })), undos = configList.map((config) => DeleteConditionalRuleMutationUndoFactory(accessor, config)[0]), result = sequenceExecute(redos, commandService).result;
    return result && undoRedoService.pushUndoRedo({
      unitID: unitId,
      redoMutations: redos,
      undoMutations: undos
    }), result;
  }
}, DeleteCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.delete-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const undoRedoService = accessor.get(IUndoRedoService), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService, params);
    if (!target) return !1;
    const { unitId, subUnitId } = target, config = { unitId, subUnitId, cfId: params.cfId }, undos = DeleteConditionalRuleMutationUndoFactory(accessor, config), result = commandService.syncExecuteCommand(DeleteConditionalRuleMutation.id, config);
    return result && undoRedoService.pushUndoRedo({ unitID: unitId, undoMutations: undos, redoMutations: [{ id: DeleteConditionalRuleMutation.id, params: config }] }), result;
  }
}, MoveCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.move-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const undoRedoService = accessor.get(IUndoRedoService), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), target = getSheetCommandTarget(univerInstanceService, params);
    if (!target) return !1;
    const { unitId, subUnitId } = target, anchorList = transformSupportSymmetryAnchor(params.start, params.end, conditionalFormattingRuleModel.getSubunitRules(unitId, subUnitId) || [], (rule) => rule.cfId);
    if (!anchorList)
      return !1;
    const [start, end] = anchorList, config = { unitId, subUnitId, start, end }, undos = MoveConditionalRuleMutationUndoFactory(config), result = commandService.syncExecuteCommand(MoveConditionalRuleMutation.id, config);
    return result && undoRedoService.pushUndoRedo({
      unitID: unitId,
      redoMutations: [{ id: MoveConditionalRuleMutation.id, params: config }],
      undoMutations: undos
    }), result;
  }
}, SetCfCommand = {
  type: CommandType.COMMAND,
  id: "sheet.command.set-conditional-rule",
  handler(accessor, params) {
    if (!params)
      return !1;
    const undoRedoService = accessor.get(IUndoRedoService), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), target = getSheetCommandTarget(univerInstanceService, params);
    if (!target) return !1;
    const { unitId, subUnitId } = target, config = { unitId, subUnitId, rule: params.rule }, undos = setConditionalRuleMutationUndoFactory(accessor, config), result = commandService.syncExecuteCommand(SetConditionalRuleMutation.id, config);
    return result && undoRedoService.pushUndoRedo({ unitID: unitId, undoMutations: undos, redoMutations: [{ id: SetConditionalRuleMutation.id, params: config }] }), result;
  }
}, conditionalFormattingWrap = "univer-conditional-formatting-wrap", cfRuleItem = "univer-cf-rule-item", preview = "univer-preview", createRule = "univer-create-rule", button = "univer-button", title$1 = "univer-title", label = "univer-label", labelContainer = "univer-label-container", inputWidth = "univer-input-width", mTBase = "univer-m-t-base", mTSm = "univer-m-t-sm", mTXl = "univer-m-t-xl", mLSm = "univer-m-l-sm", mLXl = "univer-m-l-xl", mLXxs = "univer-m-l-xxs", mL0 = "univer-m-l-0", mR0 = "univer-m-r-0", styles$5 = {
  conditionalFormattingWrap,
  cfRuleItem,
  preview,
  createRule,
  button,
  title: title$1,
  label,
  labelContainer,
  inputWidth,
  mTBase,
  mTSm,
  mTXl,
  mLSm,
  mLXl,
  mLXxs,
  mL0,
  mR0
};
var __assign = function() {
  return __assign = Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) Object.prototype.hasOwnProperty.call(s, p) && (t[p] = s[p]);
    }
    return t;
  }, __assign.apply(this, arguments);
}, __rest = function(s, e) {
  var t = {};
  for (var p in s) Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0 && (t[p] = s[p]);
  if (s != null && typeof Object.getOwnPropertySymbols == "function")
    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++)
      e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]) && (t[p[i]] = s[p[i]]);
  return t;
}, IconBase = forwardRef(function(props, ref) {
  var icon2 = props.icon, id = props.id, className = props.className, extend = props.extend, restProps = __rest(props, ["icon", "id", "className", "extend"]), cls = "univerjs-icon univerjs-icon-".concat(id, " ").concat(className || "").trim(), idSuffix = useRef("_".concat(generateShortUuid()));
  return render(icon2, "".concat(id), { defIds: icon2.defIds, idSuffix: idSuffix.current }, __assign({ ref, className: cls }, restProps), extend);
});
function render(node, id, runtimeProps, rootProps, extend) {
  return createElement(node.tag, __assign(__assign({ key: id }, replaceRuntimeIdsAndExtInAttrs(node, runtimeProps, extend)), rootProps), (replaceRuntimeIdsInDefs(node, runtimeProps).children || []).map(function(child, index2) {
    return render(child, "".concat(id, "-").concat(node.tag, "-").concat(index2), runtimeProps, void 0, extend);
  }));
}
__name(render, "render");
function replaceRuntimeIdsAndExtInAttrs(node, runtimeProps, extend) {
  var attrs = __assign({}, node.attrs);
  extend != null && extend.colorChannel1 && attrs.fill === "colorChannel1" && (attrs.fill = extend.colorChannel1);
  var defIds = runtimeProps.defIds;
  return !defIds || defIds.length === 0 || (node.tag === "use" && attrs["xlink:href"] && (attrs["xlink:href"] = attrs["xlink:href"] + runtimeProps.idSuffix), Object.entries(attrs).forEach(function(_a15) {
    var key = _a15[0], value = _a15[1];
    typeof value == "string" && (attrs[key] = value.replace(/url\(#(.*)\)/, "url(#$1".concat(runtimeProps.idSuffix, ")")));
  })), attrs;
}
__name(replaceRuntimeIdsAndExtInAttrs, "replaceRuntimeIdsAndExtInAttrs");
function replaceRuntimeIdsInDefs(node, runtimeProps) {
  var _a15, defIds = runtimeProps.defIds;
  return !defIds || defIds.length === 0 ? node : node.tag === "defs" && (!((_a15 = node.children) === null || _a15 === void 0) && _a15.length) ? __assign(__assign({}, node), { children: node.children.map(function(child) {
    return typeof child.attrs.id == "string" && defIds && defIds.indexOf(child.attrs.id) > -1 ? __assign(__assign({}, child), { attrs: __assign(__assign({}, child.attrs), { id: child.attrs.id + runtimeProps.idSuffix }) }) : child;
  }) }) : node;
}
__name(replaceRuntimeIdsInDefs, "replaceRuntimeIdsInDefs");
function generateShortUuid() {
  return Math.random().toString(36).substring(2, 8);
}
__name(generateShortUuid, "generateShortUuid");
IconBase.displayName = "UniverIcon";
var element$4 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M5.3313 1.4667C5.3313 1.13533 5.59993.866699 5.9313.866699H10.069C10.4004.866699 10.669 1.13533 10.669 1.4667 10.669 1.79807 10.4004 2.0667 10.069 2.0667H5.9313C5.59993 2.0667 5.3313 1.79807 5.3313 1.4667zM1.09985 3.64443C1.09985 3.31306 1.36848 3.04443 1.69985 3.04443H14.2999C14.6312 3.04443 14.8999 3.31306 14.8999 3.64443 14.8999 3.9758 14.6312 4.24443 14.2999 4.24443H1.69985C1.36848 4.24443 1.09985 3.9758 1.09985 3.64443zM6.12398 8.30171C6.35829 8.0674 6.73819 8.0674 6.97251 8.30171L8.00007 9.32928 9.02764 8.30171C9.26195 8.0674 9.64185 8.0674 9.87617 8.30171 10.1105 8.53603 10.1105 8.91593 9.87617 9.15024L8.8486 10.1778 9.87617 11.2054C10.1105 11.4397 10.1105 11.8196 9.87617 12.0539 9.64185 12.2882 9.26195 12.2882 9.02764 12.0539L8.00007 11.0263 6.97251 12.0539C6.73819 12.2882 6.35829 12.2882 6.12398 12.0539 5.88966 11.8196 5.88966 11.4397 6.12398 11.2054L7.15154 10.1778 6.12398 9.15024C5.88966 8.91593 5.88966 8.53603 6.12398 8.30171z" } }, { tag: "path", attrs: { fill: "currentColor", d: "M4.75332 5.22217C3.86966 5.22217 3.15332 5.93851 3.15332 6.82217V12.5331C3.15332 13.9691 4.31738 15.1332 5.75332 15.1332H10.2465C11.6825 15.1332 12.8465 13.9691 12.8465 12.5331V6.82217C12.8465 5.93851 12.1302 5.22217 11.2465 5.22217H4.75332ZM4.35332 6.82217C4.35332 6.60125 4.53241 6.42217 4.75332 6.42217H11.2465C11.4674 6.42217 11.6465 6.60125 11.6465 6.82217V12.5331C11.6465 13.3063 11.0197 13.9332 10.2465 13.9332H5.75332C4.98012 13.9332 4.35332 13.3063 4.35332 12.5331V6.82217Z", fillRule: "evenodd", clipRule: "evenodd" } }] }, DeleteSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "delete-single",
    ref,
    icon: element$4
  }));
});
DeleteSingle.displayName = "DeleteSingle";
var element$3 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M8.6 1.99991C8.60001 1.66854 8.33138 1.39991 8.00001 1.3999C7.66864 1.3999 7.40001 1.66853 7.4 1.9999L7.39996 7.3999H1.9999C1.66853 7.3999 1.3999 7.66853 1.3999 7.9999C1.3999 8.33127 1.66853 8.5999 1.9999 8.5999H7.39995L7.3999 13.9999C7.3999 14.3313 7.66853 14.5999 7.9999 14.5999C8.33127 14.5999 8.5999 14.3313 8.5999 13.9999L8.59995 8.5999H13.9999C14.3313 8.5999 14.5999 8.33127 14.5999 7.9999C14.5999 7.66853 14.3313 7.3999 13.9999 7.3999H8.59996L8.6 1.99991Z" } }] }, IncreaseSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "increase-single",
    ref,
    icon: element$3
  }));
});
IncreaseSingle.displayName = "IncreaseSingle";
var element$2 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M11.3536 6.14645C11.5488 6.34171 11.5488 6.65829 11.3536 6.85355L8.35355 9.85355C8.15829 10.0488 7.84171 10.0488 7.64645 9.85355L4.64645 6.85355C4.45118 6.65829 4.45118 6.34171 4.64645 6.14645C4.84171 5.95118 5.15829 5.95118 5.35355 6.14645L8 8.79289L10.6464 6.14645C10.8417 5.95118 11.1583 5.95118 11.3536 6.14645Z", fillRule: "evenodd", clipRule: "evenodd" } }] }, MoreDownSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "more-down-single",
    ref,
    icon: element$2
  }));
});
MoreDownSingle.displayName = "MoreDownSingle";
var element$1 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "mask", attrs: { id: "mask0_622_8", style: { maskType: "alpha" }, width: 16, height: 16, x: 0, y: 0, maskUnits: "userSpaceOnUse" }, children: [{ tag: "path", attrs: { fill: "#D9D9D9", d: "M0 0H16V16H0z" } }] }, { tag: "g", attrs: { fill: "currentColor", mask: "url(#mask0_622_8)" }, children: [{ tag: "path", attrs: { d: "M6 5C6.55228 5 7 4.55228 7 4 7 3.44772 6.55228 3 6 3 5.44772 3 5 3.44772 5 4 5 4.55228 5.44772 5 6 5zM6 9C6.55228 9 7 8.55229 7 8 7 7.44772 6.55228 7 6 7 5.44772 7 5 7.44772 5 8 5 8.55229 5.44772 9 6 9zM7 12C7 12.5523 6.55228 13 6 13 5.44772 13 5 12.5523 5 12 5 11.4477 5.44772 11 6 11 6.55228 11 7 11.4477 7 12zM10 5C10.5523 5 11 4.55228 11 4 11 3.44772 10.5523 3 10 3 9.44771 3 9 3.44772 9 4 9 4.55228 9.44771 5 10 5zM11 8C11 8.55229 10.5523 9 10 9 9.44771 9 9 8.55229 9 8 9 7.44772 9.44771 7 10 7 10.5523 7 11 7.44772 11 8zM10 13C10.5523 13 11 12.5523 11 12 11 11.4477 10.5523 11 10 11 9.44771 11 9 11.4477 9 12 9 12.5523 9.44771 13 10 13z" } }] }] }, SequenceSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "sequence-single",
    ref,
    icon: element$1
  }));
});
SequenceSingle.displayName = "SequenceSingle";
var element = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 17 17", width: "1em", height: "1em" }, children: [{ tag: "mask", attrs: { id: "mask0_436_41", style: { maskType: "alpha" }, width: 17, height: 17, x: 0, y: 0, maskUnits: "userSpaceOnUse" }, children: [{ tag: "path", attrs: { fill: "#D9D9D9", d: "M0.35 0.48H16.35V16.48H0.35z" } }] }, { tag: "g", attrs: { mask: "url(#mask0_436_41)", fillRule: "evenodd", clipRule: "evenodd" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M2.27177 13.714L13.5855 2.40025L14.434 3.24878L3.1203 14.5625L2.27177 13.714Z" } }, { tag: "path", attrs: { fill: "#E5E5E5", d: "M4.2603 1.82495L2.89617 1.82495C2.23343 1.82495 1.69617 2.36221 1.69617 3.02495L1.69617 4.38908L3.02617 4.38908L3.02617 3.15495L4.2603 3.15495L4.2603 1.82495ZM15.0092 4.38908L15.0092 3.02495C15.0092 2.36221 14.4719 1.82495 13.8092 1.82495L12.4451 1.82495L12.4451 3.15495L13.6792 3.15495L13.6792 4.38908L15.0092 4.38908ZM6.98856 1.82495L6.98856 3.15495L9.71681 3.15495L9.71681 1.82495L6.98856 1.82495ZM15.0092 7.11734L13.6792 7.11734L13.6792 9.84559L15.0092 9.84559L15.0092 7.11734ZM15.0092 12.5739L13.6792 12.5739L13.6792 13.808L12.4451 13.808L12.4451 15.138L13.8092 15.138C14.4719 15.138 15.0092 14.6007 15.0092 13.938L15.0092 12.5739ZM9.71681 15.138L9.71681 13.808L6.98856 13.808L6.98856 15.138L9.71681 15.138ZM4.2603 15.138L4.2603 13.808L3.02617 13.808L3.02617 12.5739L1.69617 12.5739L1.69617 13.938C1.69617 14.6007 2.23343 15.138 2.89617 15.138L4.2603 15.138ZM1.69617 9.8456L3.02617 9.8456L3.02617 7.11734L1.69617 7.11734L1.69617 9.8456Z" } }] }] }, SlashSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "slash-single",
    ref,
    icon: element
  }));
});
SlashSingle.displayName = "SlashSingle";
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x.default : x;
}
__name(getDefaultExportFromCjs, "getDefaultExportFromCjs");
function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var f = n.default;
  if (typeof f == "function") {
    var a = /* @__PURE__ */ __name(function a2() {
      return this instanceof a2 ? Reflect.construct(f, arguments, this.constructor) : f.apply(this, arguments);
    }, "a");
    a.prototype = f.prototype;
  } else a = {};
  return Object.defineProperty(a, "__esModule", { value: !0 }), Object.keys(n).forEach(function(k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: !0,
      get: /* @__PURE__ */ __name(function() {
        return n[k];
      }, "get")
    });
  }), a;
}
__name(getAugmentedNamespace, "getAugmentedNamespace");
var reactGridLayout = { exports: {} }, ReactGridLayout = {}, fastEquals$1 = { exports: {} }, fastEquals = fastEquals$1.exports, hasRequiredFastEquals;
function requireFastEquals() {
  return hasRequiredFastEquals || (hasRequiredFastEquals = 1, function(module, exports) {
    (function(global2, factory) {
      factory(exports);
    })(fastEquals, function(exports2) {
      function createDefaultIsNestedEqual(comparator) {
        return /* @__PURE__ */ __name(function(a, b, _indexOrKeyA, _indexOrKeyB, _parentA, _parentB, meta) {
          return comparator(a, b, meta);
        }, "isEqual");
      }
      __name(createDefaultIsNestedEqual, "createDefaultIsNestedEqual");
      function createIsCircular(areItemsEqual) {
        return /* @__PURE__ */ __name(function(a, b, isEqual, cache) {
          if (!a || !b || typeof a != "object" || typeof b != "object")
            return areItemsEqual(a, b, isEqual, cache);
          var cachedA = cache.get(a), cachedB = cache.get(b);
          if (cachedA && cachedB)
            return cachedA === b && cachedB === a;
          cache.set(a, b), cache.set(b, a);
          var result = areItemsEqual(a, b, isEqual, cache);
          return cache.delete(a), cache.delete(b), result;
        }, "isCircular");
      }
      __name(createIsCircular, "createIsCircular");
      function merge2(a, b) {
        var merged = {};
        for (var key in a)
          merged[key] = a[key];
        for (var key in b)
          merged[key] = b[key];
        return merged;
      }
      __name(merge2, "merge");
      function isPlainObject(value) {
        return value.constructor === Object || value.constructor == null;
      }
      __name(isPlainObject, "isPlainObject");
      function isPromiseLike(value) {
        return typeof value.then == "function";
      }
      __name(isPromiseLike, "isPromiseLike");
      function sameValueZeroEqual(a, b) {
        return a === b || a !== a && b !== b;
      }
      __name(sameValueZeroEqual, "sameValueZeroEqual");
      var ARGUMENTS_TAG = "[object Arguments]", BOOLEAN_TAG = "[object Boolean]", DATE_TAG = "[object Date]", REG_EXP_TAG = "[object RegExp]", MAP_TAG = "[object Map]", NUMBER_TAG = "[object Number]", OBJECT_TAG = "[object Object]", SET_TAG = "[object Set]", STRING_TAG = "[object String]", toString = Object.prototype.toString;
      function createComparator(_a15) {
        var areArraysEqual2 = _a15.areArraysEqual, areDatesEqual2 = _a15.areDatesEqual, areMapsEqual2 = _a15.areMapsEqual, areObjectsEqual2 = _a15.areObjectsEqual, areRegExpsEqual2 = _a15.areRegExpsEqual, areSetsEqual2 = _a15.areSetsEqual, createIsNestedEqual = _a15.createIsNestedEqual, isEqual = createIsNestedEqual(comparator);
        function comparator(a, b, meta) {
          if (a === b)
            return !0;
          if (!a || !b || typeof a != "object" || typeof b != "object")
            return a !== a && b !== b;
          if (isPlainObject(a) && isPlainObject(b))
            return areObjectsEqual2(a, b, isEqual, meta);
          var aArray = Array.isArray(a), bArray = Array.isArray(b);
          if (aArray || bArray)
            return aArray === bArray && areArraysEqual2(a, b, isEqual, meta);
          var aTag = toString.call(a);
          return aTag !== toString.call(b) ? !1 : aTag === DATE_TAG ? areDatesEqual2(a, b, isEqual, meta) : aTag === REG_EXP_TAG ? areRegExpsEqual2(a, b, isEqual, meta) : aTag === MAP_TAG ? areMapsEqual2(a, b, isEqual, meta) : aTag === SET_TAG ? areSetsEqual2(a, b, isEqual, meta) : aTag === OBJECT_TAG || aTag === ARGUMENTS_TAG ? isPromiseLike(a) || isPromiseLike(b) ? !1 : areObjectsEqual2(a, b, isEqual, meta) : aTag === BOOLEAN_TAG || aTag === NUMBER_TAG || aTag === STRING_TAG ? sameValueZeroEqual(a.valueOf(), b.valueOf()) : !1;
        }
        return __name(comparator, "comparator"), comparator;
      }
      __name(createComparator, "createComparator");
      function areArraysEqual(a, b, isEqual, meta) {
        var index2 = a.length;
        if (b.length !== index2)
          return !1;
        for (; index2-- > 0; )
          if (!isEqual(a[index2], b[index2], index2, index2, a, b, meta))
            return !1;
        return !0;
      }
      __name(areArraysEqual, "areArraysEqual");
      var areArraysEqualCircular = createIsCircular(areArraysEqual);
      function areDatesEqual(a, b) {
        return sameValueZeroEqual(a.valueOf(), b.valueOf());
      }
      __name(areDatesEqual, "areDatesEqual");
      function areMapsEqual(a, b, isEqual, meta) {
        var isValueEqual = a.size === b.size;
        if (!isValueEqual)
          return !1;
        if (!a.size)
          return !0;
        var matchedIndices = {}, indexA = 0;
        return a.forEach(function(aValue, aKey) {
          if (isValueEqual) {
            var hasMatch = !1, matchIndexB = 0;
            b.forEach(function(bValue, bKey) {
              !hasMatch && !matchedIndices[matchIndexB] && (hasMatch = isEqual(aKey, bKey, indexA, matchIndexB, a, b, meta) && isEqual(aValue, bValue, aKey, bKey, a, b, meta)) && (matchedIndices[matchIndexB] = !0), matchIndexB++;
            }), indexA++, isValueEqual = hasMatch;
          }
        }), isValueEqual;
      }
      __name(areMapsEqual, "areMapsEqual");
      var areMapsEqualCircular = createIsCircular(areMapsEqual), OWNER = "_owner", hasOwnProperty = Object.prototype.hasOwnProperty;
      function areObjectsEqual(a, b, isEqual, meta) {
        var keysA = Object.keys(a), index2 = keysA.length;
        if (Object.keys(b).length !== index2)
          return !1;
        for (var key; index2-- > 0; ) {
          if (key = keysA[index2], key === OWNER) {
            var reactElementA = !!a.$$typeof, reactElementB = !!b.$$typeof;
            if ((reactElementA || reactElementB) && reactElementA !== reactElementB)
              return !1;
          }
          if (!hasOwnProperty.call(b, key) || !isEqual(a[key], b[key], key, key, a, b, meta))
            return !1;
        }
        return !0;
      }
      __name(areObjectsEqual, "areObjectsEqual");
      var areObjectsEqualCircular = createIsCircular(areObjectsEqual);
      function areRegExpsEqual(a, b) {
        return a.source === b.source && a.flags === b.flags;
      }
      __name(areRegExpsEqual, "areRegExpsEqual");
      function areSetsEqual(a, b, isEqual, meta) {
        var isValueEqual = a.size === b.size;
        if (!isValueEqual)
          return !1;
        if (!a.size)
          return !0;
        var matchedIndices = {};
        return a.forEach(function(aValue, aKey) {
          if (isValueEqual) {
            var hasMatch = !1, matchIndex = 0;
            b.forEach(function(bValue, bKey) {
              !hasMatch && !matchedIndices[matchIndex] && (hasMatch = isEqual(aValue, bValue, aKey, bKey, a, b, meta)) && (matchedIndices[matchIndex] = !0), matchIndex++;
            }), isValueEqual = hasMatch;
          }
        }), isValueEqual;
      }
      __name(areSetsEqual, "areSetsEqual");
      var areSetsEqualCircular = createIsCircular(areSetsEqual), DEFAULT_CONFIG = Object.freeze({
        areArraysEqual,
        areDatesEqual,
        areMapsEqual,
        areObjectsEqual,
        areRegExpsEqual,
        areSetsEqual,
        createIsNestedEqual: createDefaultIsNestedEqual
      }), DEFAULT_CIRCULAR_CONFIG = Object.freeze({
        areArraysEqual: areArraysEqualCircular,
        areDatesEqual,
        areMapsEqual: areMapsEqualCircular,
        areObjectsEqual: areObjectsEqualCircular,
        areRegExpsEqual,
        areSetsEqual: areSetsEqualCircular,
        createIsNestedEqual: createDefaultIsNestedEqual
      }), isDeepEqual = createComparator(DEFAULT_CONFIG);
      function deepEqual(a, b) {
        return isDeepEqual(a, b, void 0);
      }
      __name(deepEqual, "deepEqual");
      var isShallowEqual = createComparator(merge2(DEFAULT_CONFIG, { createIsNestedEqual: /* @__PURE__ */ __name(function() {
        return sameValueZeroEqual;
      }, "createIsNestedEqual") }));
      function shallowEqual(a, b) {
        return isShallowEqual(a, b, void 0);
      }
      __name(shallowEqual, "shallowEqual");
      var isCircularDeepEqual = createComparator(DEFAULT_CIRCULAR_CONFIG);
      function circularDeepEqual(a, b) {
        return isCircularDeepEqual(a, b, /* @__PURE__ */ new WeakMap());
      }
      __name(circularDeepEqual, "circularDeepEqual");
      var isCircularShallowEqual = createComparator(merge2(DEFAULT_CIRCULAR_CONFIG, {
        createIsNestedEqual: /* @__PURE__ */ __name(function() {
          return sameValueZeroEqual;
        }, "createIsNestedEqual")
      }));
      function circularShallowEqual(a, b) {
        return isCircularShallowEqual(a, b, /* @__PURE__ */ new WeakMap());
      }
      __name(circularShallowEqual, "circularShallowEqual");
      function createCustomEqual(getComparatorOptions) {
        return createComparator(merge2(DEFAULT_CONFIG, getComparatorOptions(DEFAULT_CONFIG)));
      }
      __name(createCustomEqual, "createCustomEqual");
      function createCustomCircularEqual(getComparatorOptions) {
        var comparator = createComparator(merge2(DEFAULT_CIRCULAR_CONFIG, getComparatorOptions(DEFAULT_CIRCULAR_CONFIG)));
        return function(a, b, meta) {
          return meta === void 0 && (meta = /* @__PURE__ */ new WeakMap()), comparator(a, b, meta);
        };
      }
      __name(createCustomCircularEqual, "createCustomCircularEqual"), exports2.circularDeepEqual = circularDeepEqual, exports2.circularShallowEqual = circularShallowEqual, exports2.createCustomCircularEqual = createCustomCircularEqual, exports2.createCustomEqual = createCustomEqual, exports2.deepEqual = deepEqual, exports2.sameValueZeroEqual = sameValueZeroEqual, exports2.shallowEqual = shallowEqual, Object.defineProperty(exports2, "__esModule", { value: !0 });
    });
  }(fastEquals$1, fastEquals$1.exports)), fastEquals$1.exports;
}
__name(requireFastEquals, "requireFastEquals");
var clsx$2 = { exports: {} }, hasRequiredClsx;
function requireClsx() {
  if (hasRequiredClsx) return clsx$2.exports;
  hasRequiredClsx = 1;
  function r2(e2) {
    var o, t, f = "";
    if (typeof e2 == "string" || typeof e2 == "number") f += e2;
    else if (typeof e2 == "object") if (Array.isArray(e2)) {
      var n = e2.length;
      for (o = 0; o < n; o++) e2[o] && (t = r2(e2[o])) && (f && (f += " "), f += t);
    } else for (t in e2) e2[t] && (f && (f += " "), f += t);
    return f;
  }
  __name(r2, "r");
  function e() {
    for (var e2, o, t = 0, f = "", n = arguments.length; t < n; t++) (e2 = arguments[t]) && (o = r2(e2)) && (f && (f += " "), f += o);
    return f;
  }
  return __name(e, "e"), clsx$2.exports = e, clsx$2.exports.clsx = e, clsx$2.exports;
}
__name(requireClsx, "requireClsx");
var utils$1 = {}, fastRGLPropsEqual, hasRequiredFastRGLPropsEqual;
function requireFastRGLPropsEqual() {
  return hasRequiredFastRGLPropsEqual || (hasRequiredFastRGLPropsEqual = 1, fastRGLPropsEqual = /* @__PURE__ */ __name(function(a, b, isEqualImpl) {
    return a === b ? !0 : a.className === b.className && isEqualImpl(a.style, b.style) && a.width === b.width && a.autoSize === b.autoSize && a.cols === b.cols && a.draggableCancel === b.draggableCancel && a.draggableHandle === b.draggableHandle && isEqualImpl(a.verticalCompact, b.verticalCompact) && isEqualImpl(a.compactType, b.compactType) && isEqualImpl(a.layout, b.layout) && isEqualImpl(a.margin, b.margin) && isEqualImpl(a.containerPadding, b.containerPadding) && a.rowHeight === b.rowHeight && a.maxRows === b.maxRows && a.isBounded === b.isBounded && a.isDraggable === b.isDraggable && a.isResizable === b.isResizable && a.allowOverlap === b.allowOverlap && a.preventCollision === b.preventCollision && a.useCSSTransforms === b.useCSSTransforms && a.transformScale === b.transformScale && a.isDroppable === b.isDroppable && isEqualImpl(a.resizeHandles, b.resizeHandles) && isEqualImpl(a.resizeHandle, b.resizeHandle) && a.onLayoutChange === b.onLayoutChange && a.onDragStart === b.onDragStart && a.onDrag === b.onDrag && a.onDragStop === b.onDragStop && a.onResizeStart === b.onResizeStart && a.onResize === b.onResize && a.onResizeStop === b.onResizeStop && a.onDrop === b.onDrop && isEqualImpl(a.droppingItem, b.droppingItem) && isEqualImpl(a.innerRef, b.innerRef);
  }, "fastRGLPropsEqual")), fastRGLPropsEqual;
}
__name(requireFastRGLPropsEqual, "requireFastRGLPropsEqual");
var hasRequiredUtils$1;
function requireUtils$1() {
  if (hasRequiredUtils$1) return utils$1;
  hasRequiredUtils$1 = 1, Object.defineProperty(utils$1, "__esModule", {
    value: !0
  }), utils$1.bottom = bottom, utils$1.childrenEqual = childrenEqual, utils$1.cloneLayout = cloneLayout, utils$1.cloneLayoutItem = cloneLayoutItem, utils$1.collides = collides, utils$1.compact = compact, utils$1.compactItem = compactItem, utils$1.compactType = compactType, utils$1.correctBounds = correctBounds, utils$1.fastPositionEqual = fastPositionEqual, utils$1.fastRGLPropsEqual = void 0, utils$1.getAllCollisions = getAllCollisions, utils$1.getFirstCollision = getFirstCollision, utils$1.getLayoutItem = getLayoutItem, utils$1.getStatics = getStatics, utils$1.modifyLayout = modifyLayout, utils$1.moveElement = moveElement, utils$1.moveElementAwayFromCollision = moveElementAwayFromCollision, utils$1.noop = void 0, utils$1.perc = perc, utils$1.resizeItemInDirection = resizeItemInDirection, utils$1.setTopLeft = setTopLeft, utils$1.setTransform = setTransform, utils$1.sortLayoutItems = sortLayoutItems, utils$1.sortLayoutItemsByColRow = sortLayoutItemsByColRow, utils$1.sortLayoutItemsByRowCol = sortLayoutItemsByRowCol, utils$1.synchronizeLayoutWithChildren = synchronizeLayoutWithChildren, utils$1.validateLayout = validateLayout, utils$1.withLayoutItem = withLayoutItem;
  var _fastEquals = /* @__PURE__ */ requireFastEquals(), _react = _interopRequireDefault(require$$0);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function bottom(layout) {
    let max = 0, bottomY;
    for (let i = 0, len = layout.length; i < len; i++)
      bottomY = layout[i].y + layout[i].h, bottomY > max && (max = bottomY);
    return max;
  }
  __name(bottom, "bottom");
  function cloneLayout(layout) {
    const newLayout = Array(layout.length);
    for (let i = 0, len = layout.length; i < len; i++)
      newLayout[i] = cloneLayoutItem(layout[i]);
    return newLayout;
  }
  __name(cloneLayout, "cloneLayout");
  function modifyLayout(layout, layoutItem) {
    const newLayout = Array(layout.length);
    for (let i = 0, len = layout.length; i < len; i++)
      layoutItem.i === layout[i].i ? newLayout[i] = layoutItem : newLayout[i] = layout[i];
    return newLayout;
  }
  __name(modifyLayout, "modifyLayout");
  function withLayoutItem(layout, itemKey, cb) {
    let item2 = getLayoutItem(layout, itemKey);
    return item2 ? (item2 = cb(cloneLayoutItem(item2)), layout = modifyLayout(layout, item2), [layout, item2]) : [layout, null];
  }
  __name(withLayoutItem, "withLayoutItem");
  function cloneLayoutItem(layoutItem) {
    return {
      w: layoutItem.w,
      h: layoutItem.h,
      x: layoutItem.x,
      y: layoutItem.y,
      i: layoutItem.i,
      minW: layoutItem.minW,
      maxW: layoutItem.maxW,
      minH: layoutItem.minH,
      maxH: layoutItem.maxH,
      moved: !!layoutItem.moved,
      static: !!layoutItem.static,
      // These can be null/undefined
      isDraggable: layoutItem.isDraggable,
      isResizable: layoutItem.isResizable,
      resizeHandles: layoutItem.resizeHandles,
      isBounded: layoutItem.isBounded
    };
  }
  __name(cloneLayoutItem, "cloneLayoutItem");
  function childrenEqual(a, b) {
    return (0, _fastEquals.deepEqual)(_react.default.Children.map(a, (c) => c == null ? void 0 : c.key), _react.default.Children.map(b, (c) => c == null ? void 0 : c.key)) && (0, _fastEquals.deepEqual)(_react.default.Children.map(a, (c) => c == null ? void 0 : c.props["data-grid"]), _react.default.Children.map(b, (c) => c == null ? void 0 : c.props["data-grid"]));
  }
  __name(childrenEqual, "childrenEqual"), utils$1.fastRGLPropsEqual = requireFastRGLPropsEqual();
  function fastPositionEqual(a, b) {
    return a.left === b.left && a.top === b.top && a.width === b.width && a.height === b.height;
  }
  __name(fastPositionEqual, "fastPositionEqual");
  function collides(l1, l2) {
    return !(l1.i === l2.i || l1.x + l1.w <= l2.x || l1.x >= l2.x + l2.w || l1.y + l1.h <= l2.y || l1.y >= l2.y + l2.h);
  }
  __name(collides, "collides");
  function compact(layout, compactType2, cols, allowOverlap) {
    const compareWith = getStatics(layout), sorted = sortLayoutItems(layout, compactType2), out = Array(layout.length);
    for (let i = 0, len = sorted.length; i < len; i++) {
      let l = cloneLayoutItem(sorted[i]);
      l.static || (l = compactItem(compareWith, l, compactType2, cols, sorted, allowOverlap), compareWith.push(l)), out[layout.indexOf(sorted[i])] = l, l.moved = !1;
    }
    return out;
  }
  __name(compact, "compact");
  const heightWidth = {
    x: "w",
    y: "h"
  };
  function resolveCompactionCollision(layout, item2, moveToCoord, axis) {
    const sizeProp = heightWidth[axis];
    item2[axis] += 1;
    const itemIndex = layout.map((layoutItem) => layoutItem.i).indexOf(item2.i);
    for (let i = itemIndex + 1; i < layout.length; i++) {
      const otherItem = layout[i];
      if (!otherItem.static) {
        if (otherItem.y > item2.y + item2.h) break;
        collides(item2, otherItem) && resolveCompactionCollision(layout, otherItem, moveToCoord + item2[sizeProp], axis);
      }
    }
    item2[axis] = moveToCoord;
  }
  __name(resolveCompactionCollision, "resolveCompactionCollision");
  function compactItem(compareWith, l, compactType2, cols, fullLayout, allowOverlap) {
    const compactV = compactType2 === "vertical", compactH = compactType2 === "horizontal";
    if (compactV)
      for (l.y = Math.min(bottom(compareWith), l.y); l.y > 0 && !getFirstCollision(compareWith, l); )
        l.y--;
    else if (compactH)
      for (; l.x > 0 && !getFirstCollision(compareWith, l); )
        l.x--;
    let collides2;
    for (; (collides2 = getFirstCollision(compareWith, l)) && !(compactType2 === null && allowOverlap); )
      if (compactH ? resolveCompactionCollision(fullLayout, l, collides2.x + collides2.w, "x") : resolveCompactionCollision(fullLayout, l, collides2.y + collides2.h, "y"), compactH && l.x + l.w > cols)
        for (l.x = cols - l.w, l.y++; l.x > 0 && !getFirstCollision(compareWith, l); )
          l.x--;
    return l.y = Math.max(l.y, 0), l.x = Math.max(l.x, 0), l;
  }
  __name(compactItem, "compactItem");
  function correctBounds(layout, bounds) {
    const collidesWith = getStatics(layout);
    for (let i = 0, len = layout.length; i < len; i++) {
      const l = layout[i];
      if (l.x + l.w > bounds.cols && (l.x = bounds.cols - l.w), l.x < 0 && (l.x = 0, l.w = bounds.cols), !l.static) collidesWith.push(l);
      else
        for (; getFirstCollision(collidesWith, l); )
          l.y++;
    }
    return layout;
  }
  __name(correctBounds, "correctBounds");
  function getLayoutItem(layout, id) {
    for (let i = 0, len = layout.length; i < len; i++)
      if (layout[i].i === id) return layout[i];
  }
  __name(getLayoutItem, "getLayoutItem");
  function getFirstCollision(layout, layoutItem) {
    for (let i = 0, len = layout.length; i < len; i++)
      if (collides(layout[i], layoutItem)) return layout[i];
  }
  __name(getFirstCollision, "getFirstCollision");
  function getAllCollisions(layout, layoutItem) {
    return layout.filter((l) => collides(l, layoutItem));
  }
  __name(getAllCollisions, "getAllCollisions");
  function getStatics(layout) {
    return layout.filter((l) => l.static);
  }
  __name(getStatics, "getStatics");
  function moveElement(layout, l, x, y, isUserAction, preventCollision, compactType2, cols, allowOverlap) {
    if (l.static && l.isDraggable !== !0 || l.y === y && l.x === x) return layout;
    `${l.i}${String(x)}${String(y)}${l.x}${l.y}`;
    const oldX = l.x, oldY = l.y;
    typeof x == "number" && (l.x = x), typeof y == "number" && (l.y = y), l.moved = !0;
    let sorted = sortLayoutItems(layout, compactType2);
    (compactType2 === "vertical" && typeof y == "number" ? oldY >= y : compactType2 === "horizontal" && typeof x == "number" ? oldX >= x : !1) && (sorted = sorted.reverse());
    const collisions = getAllCollisions(sorted, l), hasCollisions = collisions.length > 0;
    if (hasCollisions && allowOverlap)
      return cloneLayout(layout);
    if (hasCollisions && preventCollision)
      return `${l.i}`, l.x = oldX, l.y = oldY, l.moved = !1, layout;
    for (let i = 0, len = collisions.length; i < len; i++) {
      const collision = collisions[i];
      `${l.i}${l.x}${l.y}${collision.i}${collision.x}${collision.y}`, !collision.moved && (collision.static ? layout = moveElementAwayFromCollision(layout, collision, l, isUserAction, compactType2) : layout = moveElementAwayFromCollision(layout, l, collision, isUserAction, compactType2));
    }
    return layout;
  }
  __name(moveElement, "moveElement");
  function moveElementAwayFromCollision(layout, collidesWith, itemToMove, isUserAction, compactType2, cols) {
    const compactH = compactType2 === "horizontal", compactV = compactType2 === "vertical", preventCollision = collidesWith.static;
    if (isUserAction) {
      isUserAction = !1;
      const fakeItem = {
        x: compactH ? Math.max(collidesWith.x - itemToMove.w, 0) : itemToMove.x,
        y: compactV ? Math.max(collidesWith.y - itemToMove.h, 0) : itemToMove.y,
        w: itemToMove.w,
        h: itemToMove.h,
        i: "-1"
      }, firstCollision = getFirstCollision(layout, fakeItem), collisionNorth = firstCollision && firstCollision.y + firstCollision.h > collidesWith.y, collisionWest = firstCollision && collidesWith.x + collidesWith.w > firstCollision.x;
      if (firstCollision) {
        if (collisionNorth && compactV)
          return moveElement(layout, itemToMove, void 0, collidesWith.y + 1, isUserAction, preventCollision, compactType2);
        if (collisionNorth && compactType2 == null)
          return collidesWith.y = itemToMove.y, itemToMove.y = itemToMove.y + itemToMove.h, layout;
        if (collisionWest && compactH)
          return moveElement(layout, collidesWith, itemToMove.x, void 0, isUserAction, preventCollision, compactType2);
      } else return `${itemToMove.i}${fakeItem.x}${fakeItem.y}`, moveElement(layout, itemToMove, compactH ? fakeItem.x : void 0, compactV ? fakeItem.y : void 0, isUserAction, preventCollision, compactType2);
    }
    const newX = compactH ? itemToMove.x + 1 : void 0, newY = compactV ? itemToMove.y + 1 : void 0;
    return newX == null && newY == null ? layout : moveElement(layout, itemToMove, compactH ? itemToMove.x + 1 : void 0, compactV ? itemToMove.y + 1 : void 0, isUserAction, preventCollision, compactType2);
  }
  __name(moveElementAwayFromCollision, "moveElementAwayFromCollision");
  function perc(num) {
    return num * 100 + "%";
  }
  __name(perc, "perc");
  const constrainWidth = /* @__PURE__ */ __name((left, currentWidth, newWidth, containerWidth) => left + newWidth > containerWidth ? currentWidth : newWidth, "constrainWidth"), constrainHeight = /* @__PURE__ */ __name((top, currentHeight, newHeight) => top < 0 ? currentHeight : newHeight, "constrainHeight"), constrainLeft = /* @__PURE__ */ __name((left) => Math.max(0, left), "constrainLeft"), constrainTop = /* @__PURE__ */ __name((top) => Math.max(0, top), "constrainTop"), resizeNorth = /* @__PURE__ */ __name((currentSize, _ref, _containerWidth) => {
    let {
      left,
      height,
      width
    } = _ref;
    const top = currentSize.top - (height - currentSize.height);
    return {
      left,
      width,
      height: constrainHeight(top, currentSize.height, height),
      top: constrainTop(top)
    };
  }, "resizeNorth"), resizeEast = /* @__PURE__ */ __name((currentSize, _ref2, containerWidth) => {
    let {
      top,
      left,
      height,
      width
    } = _ref2;
    return {
      top,
      height,
      width: constrainWidth(currentSize.left, currentSize.width, width, containerWidth),
      left: constrainLeft(left)
    };
  }, "resizeEast"), resizeWest = /* @__PURE__ */ __name((currentSize, _ref3, containerWidth) => {
    let {
      top,
      height,
      width
    } = _ref3;
    const left = currentSize.left - (width - currentSize.width);
    return {
      height,
      width: left < 0 ? currentSize.width : constrainWidth(currentSize.left, currentSize.width, width, containerWidth),
      top: constrainTop(top),
      left: constrainLeft(left)
    };
  }, "resizeWest"), resizeSouth = /* @__PURE__ */ __name((currentSize, _ref4, containerWidth) => {
    let {
      top,
      left,
      height,
      width
    } = _ref4;
    return {
      width,
      left,
      height: constrainHeight(top, currentSize.height, height),
      top: constrainTop(top)
    };
  }, "resizeSouth"), ordinalResizeHandlerMap = {
    n: resizeNorth,
    ne: /* @__PURE__ */ __name(function() {
      return resizeNorth(arguments.length <= 0 ? void 0 : arguments[0], resizeEast(...arguments));
    }, "resizeNorthEast"),
    e: resizeEast,
    se: /* @__PURE__ */ __name(function() {
      return resizeSouth(arguments.length <= 0 ? void 0 : arguments[0], resizeEast(...arguments));
    }, "resizeSouthEast"),
    s: resizeSouth,
    sw: /* @__PURE__ */ __name(function() {
      return resizeSouth(arguments.length <= 0 ? void 0 : arguments[0], resizeWest(...arguments));
    }, "resizeSouthWest"),
    w: resizeWest,
    nw: /* @__PURE__ */ __name(function() {
      return resizeNorth(arguments.length <= 0 ? void 0 : arguments[0], resizeWest(...arguments));
    }, "resizeNorthWest")
  };
  function resizeItemInDirection(direction, currentSize, newSize, containerWidth) {
    const ordinalHandler = ordinalResizeHandlerMap[direction];
    return ordinalHandler ? ordinalHandler(currentSize, {
      ...currentSize,
      ...newSize
    }, containerWidth) : newSize;
  }
  __name(resizeItemInDirection, "resizeItemInDirection");
  function setTransform(_ref5) {
    let {
      top,
      left,
      width,
      height
    } = _ref5;
    const translate = `translate(${left}px,${top}px)`;
    return {
      transform: translate,
      WebkitTransform: translate,
      MozTransform: translate,
      msTransform: translate,
      OTransform: translate,
      width: `${width}px`,
      height: `${height}px`,
      position: "absolute"
    };
  }
  __name(setTransform, "setTransform");
  function setTopLeft(_ref6) {
    let {
      top,
      left,
      width,
      height
    } = _ref6;
    return {
      top: `${top}px`,
      left: `${left}px`,
      width: `${width}px`,
      height: `${height}px`,
      position: "absolute"
    };
  }
  __name(setTopLeft, "setTopLeft");
  function sortLayoutItems(layout, compactType2) {
    return compactType2 === "horizontal" ? sortLayoutItemsByColRow(layout) : compactType2 === "vertical" ? sortLayoutItemsByRowCol(layout) : layout;
  }
  __name(sortLayoutItems, "sortLayoutItems");
  function sortLayoutItemsByRowCol(layout) {
    return layout.slice(0).sort(function(a, b) {
      return a.y > b.y || a.y === b.y && a.x > b.x ? 1 : a.y === b.y && a.x === b.x ? 0 : -1;
    });
  }
  __name(sortLayoutItemsByRowCol, "sortLayoutItemsByRowCol");
  function sortLayoutItemsByColRow(layout) {
    return layout.slice(0).sort(function(a, b) {
      return a.x > b.x || a.x === b.x && a.y > b.y ? 1 : -1;
    });
  }
  __name(sortLayoutItemsByColRow, "sortLayoutItemsByColRow");
  function synchronizeLayoutWithChildren(initialLayout, children, cols, compactType2, allowOverlap) {
    initialLayout = initialLayout || [];
    const layout = [];
    _react.default.Children.forEach(children, (child) => {
      if ((child == null ? void 0 : child.key) == null) return;
      const exists = getLayoutItem(initialLayout, String(child.key)), g = child.props["data-grid"];
      exists && g == null ? layout.push(cloneLayoutItem(exists)) : g ? layout.push(cloneLayoutItem({
        ...g,
        i: child.key
      })) : layout.push(cloneLayoutItem({
        w: 1,
        h: 1,
        x: 0,
        y: bottom(layout),
        i: String(child.key)
      }));
    });
    const correctedLayout = correctBounds(layout, {
      cols
    });
    return allowOverlap ? correctedLayout : compact(correctedLayout, compactType2, cols);
  }
  __name(synchronizeLayoutWithChildren, "synchronizeLayoutWithChildren");
  function validateLayout(layout) {
    let contextName = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "Layout";
    const subProps = ["x", "y", "w", "h"];
    if (!Array.isArray(layout)) throw new Error(contextName + " must be an array!");
    for (let i = 0, len = layout.length; i < len; i++) {
      const item2 = layout[i];
      for (let j = 0; j < subProps.length; j++) {
        const key = subProps[j], value = item2[key];
        if (typeof value != "number" || Number.isNaN(value))
          throw new Error(`ReactGridLayout: ${contextName}[${i}].${key} must be a number! Received: ${value} (${typeof value})`);
      }
      if (typeof item2.i < "u" && typeof item2.i != "string")
        throw new Error(`ReactGridLayout: ${contextName}[${i}].i must be a string! Received: ${item2.i} (${typeof item2.i})`);
    }
  }
  __name(validateLayout, "validateLayout");
  function compactType(props) {
    const {
      verticalCompact,
      compactType: compactType2
    } = props || {};
    return verticalCompact === !1 ? null : compactType2;
  }
  __name(compactType, "compactType");
  function log2() {
  }
  __name(log2, "log");
  const noop = /* @__PURE__ */ __name(() => {
  }, "noop");
  return utils$1.noop = noop, utils$1;
}
__name(requireUtils$1, "requireUtils$1");
var calculateUtils = {}, hasRequiredCalculateUtils;
function requireCalculateUtils() {
  if (hasRequiredCalculateUtils) return calculateUtils;
  hasRequiredCalculateUtils = 1, Object.defineProperty(calculateUtils, "__esModule", {
    value: !0
  }), calculateUtils.calcGridColWidth = calcGridColWidth, calculateUtils.calcGridItemPosition = calcGridItemPosition, calculateUtils.calcGridItemWHPx = calcGridItemWHPx, calculateUtils.calcWH = calcWH, calculateUtils.calcXY = calcXY, calculateUtils.clamp = clamp;
  function calcGridColWidth(positionParams) {
    const {
      margin,
      containerPadding,
      containerWidth,
      cols
    } = positionParams;
    return (containerWidth - margin[0] * (cols - 1) - containerPadding[0] * 2) / cols;
  }
  __name(calcGridColWidth, "calcGridColWidth");
  function calcGridItemWHPx(gridUnits, colOrRowSize, marginPx) {
    return Number.isFinite(gridUnits) ? Math.round(colOrRowSize * gridUnits + Math.max(0, gridUnits - 1) * marginPx) : gridUnits;
  }
  __name(calcGridItemWHPx, "calcGridItemWHPx");
  function calcGridItemPosition(positionParams, x, y, w, h, state) {
    const {
      margin,
      containerPadding,
      rowHeight
    } = positionParams, colWidth = calcGridColWidth(positionParams), out = {};
    return state && state.resizing ? (out.width = Math.round(state.resizing.width), out.height = Math.round(state.resizing.height)) : (out.width = calcGridItemWHPx(w, colWidth, margin[0]), out.height = calcGridItemWHPx(h, rowHeight, margin[1])), state && state.dragging ? (out.top = Math.round(state.dragging.top), out.left = Math.round(state.dragging.left)) : state && state.resizing && typeof state.resizing.top == "number" && typeof state.resizing.left == "number" ? (out.top = Math.round(state.resizing.top), out.left = Math.round(state.resizing.left)) : (out.top = Math.round((rowHeight + margin[1]) * y + containerPadding[1]), out.left = Math.round((colWidth + margin[0]) * x + containerPadding[0])), out;
  }
  __name(calcGridItemPosition, "calcGridItemPosition");
  function calcXY(positionParams, top, left, w, h) {
    const {
      margin,
      containerPadding,
      cols,
      rowHeight,
      maxRows
    } = positionParams, colWidth = calcGridColWidth(positionParams);
    let x = Math.round((left - containerPadding[0]) / (colWidth + margin[0])), y = Math.round((top - containerPadding[1]) / (rowHeight + margin[1]));
    return x = clamp(x, 0, cols - w), y = clamp(y, 0, maxRows - h), {
      x,
      y
    };
  }
  __name(calcXY, "calcXY");
  function calcWH(positionParams, width, height, x, y, handle) {
    const {
      margin,
      maxRows,
      cols,
      rowHeight
    } = positionParams, colWidth = calcGridColWidth(positionParams);
    let w = Math.round((width + margin[0]) / (colWidth + margin[0])), h = Math.round((height + margin[1]) / (rowHeight + margin[1])), _w = clamp(w, 0, cols - x), _h = clamp(h, 0, maxRows - y);
    return ["sw", "w", "nw"].indexOf(handle) !== -1 && (_w = clamp(w, 0, cols)), ["nw", "n", "ne"].indexOf(handle) !== -1 && (_h = clamp(h, 0, maxRows)), {
      w: _w,
      h: _h
    };
  }
  __name(calcWH, "calcWH");
  function clamp(num, lowerBound, upperBound) {
    return Math.max(Math.min(num, upperBound), lowerBound);
  }
  return __name(clamp, "clamp"), calculateUtils;
}
__name(requireCalculateUtils, "requireCalculateUtils");
var GridItem = {}, propTypes$1 = { exports: {} }, ReactPropTypesSecret_1, hasRequiredReactPropTypesSecret;
function requireReactPropTypesSecret() {
  if (hasRequiredReactPropTypesSecret) return ReactPropTypesSecret_1;
  hasRequiredReactPropTypesSecret = 1;
  var ReactPropTypesSecret = "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED";
  return ReactPropTypesSecret_1 = ReactPropTypesSecret, ReactPropTypesSecret_1;
}
__name(requireReactPropTypesSecret, "requireReactPropTypesSecret");
var factoryWithThrowingShims, hasRequiredFactoryWithThrowingShims;
function requireFactoryWithThrowingShims() {
  if (hasRequiredFactoryWithThrowingShims) return factoryWithThrowingShims;
  hasRequiredFactoryWithThrowingShims = 1;
  var ReactPropTypesSecret = /* @__PURE__ */ requireReactPropTypesSecret();
  function emptyFunction() {
  }
  __name(emptyFunction, "emptyFunction");
  function emptyFunctionWithReset() {
  }
  return __name(emptyFunctionWithReset, "emptyFunctionWithReset"), emptyFunctionWithReset.resetWarningCache = emptyFunction, factoryWithThrowingShims = /* @__PURE__ */ __name(function() {
    function shim(props, propName, componentName, location, propFullName, secret) {
      if (secret !== ReactPropTypesSecret) {
        var err = new Error(
          "Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types"
        );
        throw err.name = "Invariant Violation", err;
      }
    }
    __name(shim, "shim"), shim.isRequired = shim;
    function getShim() {
      return shim;
    }
    __name(getShim, "getShim");
    var ReactPropTypes = {
      array: shim,
      bigint: shim,
      bool: shim,
      func: shim,
      number: shim,
      object: shim,
      string: shim,
      symbol: shim,
      any: shim,
      arrayOf: getShim,
      element: shim,
      elementType: shim,
      instanceOf: getShim,
      node: shim,
      objectOf: getShim,
      oneOf: getShim,
      oneOfType: getShim,
      shape: getShim,
      exact: getShim,
      checkPropTypes: emptyFunctionWithReset,
      resetWarningCache: emptyFunction
    };
    return ReactPropTypes.PropTypes = ReactPropTypes, ReactPropTypes;
  }, "factoryWithThrowingShims"), factoryWithThrowingShims;
}
__name(requireFactoryWithThrowingShims, "requireFactoryWithThrowingShims");
var hasRequiredPropTypes$1;
function requirePropTypes$1() {
  return hasRequiredPropTypes$1 || (hasRequiredPropTypes$1 = 1, propTypes$1.exports = /* @__PURE__ */ requireFactoryWithThrowingShims()()), propTypes$1.exports;
}
__name(requirePropTypes$1, "requirePropTypes$1");
var cjs = { exports: {} }, Draggable = {};
function r$1(e) {
  var t, f, n = "";
  if (typeof e == "string" || typeof e == "number") n += e;
  else if (typeof e == "object") if (Array.isArray(e)) for (t = 0; t < e.length; t++) e[t] && (f = r$1(e[t])) && (n && (n += " "), n += f);
  else for (t in e) e[t] && (n && (n += " "), n += t);
  return n;
}
__name(r$1, "r$1");
function clsx$1() {
  for (var e, t, f = 0, n = ""; f < arguments.length; ) (e = arguments[f++]) && (t = r$1(e)) && (n && (n += " "), n += t);
  return n;
}
__name(clsx$1, "clsx$1");
const clsx_m = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  clsx: clsx$1,
  default: clsx$1
}, Symbol.toStringTag, { value: "Module" })), require$$3 = /* @__PURE__ */ getAugmentedNamespace(clsx_m);
var domFns = {}, shims = {}, hasRequiredShims;
function requireShims() {
  if (hasRequiredShims) return shims;
  hasRequiredShims = 1, Object.defineProperty(shims, "__esModule", {
    value: !0
  }), shims.dontSetMe = dontSetMe, shims.findInArray = findInArray, shims.int = int, shims.isFunction = isFunction, shims.isNum = isNum;
  function findInArray(array, callback) {
    for (let i = 0, length = array.length; i < length; i++)
      if (callback.apply(callback, [array[i], i, array])) return array[i];
  }
  __name(findInArray, "findInArray");
  function isFunction(func) {
    return typeof func == "function" || Object.prototype.toString.call(func) === "[object Function]";
  }
  __name(isFunction, "isFunction");
  function isNum(num) {
    return typeof num == "number" && !isNaN(num);
  }
  __name(isNum, "isNum");
  function int(a) {
    return parseInt(a, 10);
  }
  __name(int, "int");
  function dontSetMe(props, propName, componentName) {
    if (props[propName])
      return new Error("Invalid prop ".concat(propName, " passed to ").concat(componentName, " - do not set this, set it on the child."));
  }
  return __name(dontSetMe, "dontSetMe"), shims;
}
__name(requireShims, "requireShims");
var getPrefix = {}, hasRequiredGetPrefix;
function requireGetPrefix() {
  if (hasRequiredGetPrefix) return getPrefix;
  hasRequiredGetPrefix = 1, Object.defineProperty(getPrefix, "__esModule", {
    value: !0
  }), getPrefix.browserPrefixToKey = browserPrefixToKey, getPrefix.browserPrefixToStyle = browserPrefixToStyle, getPrefix.default = void 0, getPrefix.getPrefix = getPrefix$1;
  const prefixes = ["Moz", "Webkit", "O", "ms"];
  function getPrefix$1() {
    var _window$document;
    let prop = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "transform";
    if (typeof window > "u") return "";
    const style = (_window$document = window.document) === null || _window$document === void 0 || (_window$document = _window$document.documentElement) === null || _window$document === void 0 ? void 0 : _window$document.style;
    if (!style || prop in style) return "";
    for (let i = 0; i < prefixes.length; i++)
      if (browserPrefixToKey(prop, prefixes[i]) in style) return prefixes[i];
    return "";
  }
  __name(getPrefix$1, "getPrefix$1");
  function browserPrefixToKey(prop, prefix) {
    return prefix ? "".concat(prefix).concat(kebabToTitleCase(prop)) : prop;
  }
  __name(browserPrefixToKey, "browserPrefixToKey");
  function browserPrefixToStyle(prop, prefix) {
    return prefix ? "-".concat(prefix.toLowerCase(), "-").concat(prop) : prop;
  }
  __name(browserPrefixToStyle, "browserPrefixToStyle");
  function kebabToTitleCase(str) {
    let out = "", shouldCapitalize = !0;
    for (let i = 0; i < str.length; i++)
      shouldCapitalize ? (out += str[i].toUpperCase(), shouldCapitalize = !1) : str[i] === "-" ? shouldCapitalize = !0 : out += str[i];
    return out;
  }
  return __name(kebabToTitleCase, "kebabToTitleCase"), getPrefix.default = getPrefix$1(), getPrefix;
}
__name(requireGetPrefix, "requireGetPrefix");
var hasRequiredDomFns;
function requireDomFns() {
  if (hasRequiredDomFns) return domFns;
  hasRequiredDomFns = 1, Object.defineProperty(domFns, "__esModule", {
    value: !0
  }), domFns.addClassName = addClassName, domFns.addEvent = addEvent, domFns.addUserSelectStyles = addUserSelectStyles, domFns.createCSSTransform = createCSSTransform, domFns.createSVGTransform = createSVGTransform, domFns.getTouch = getTouch, domFns.getTouchIdentifier = getTouchIdentifier, domFns.getTranslation = getTranslation, domFns.innerHeight = innerHeight, domFns.innerWidth = innerWidth, domFns.matchesSelector = matchesSelector, domFns.matchesSelectorAndParentsTo = matchesSelectorAndParentsTo, domFns.offsetXYFromParent = offsetXYFromParent, domFns.outerHeight = outerHeight, domFns.outerWidth = outerWidth, domFns.removeClassName = removeClassName, domFns.removeEvent = removeEvent, domFns.removeUserSelectStyles = removeUserSelectStyles;
  var _shims = requireShims(), _getPrefix = _interopRequireWildcard(requireGetPrefix());
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap != "function") return null;
    var cacheBabelInterop = /* @__PURE__ */ new WeakMap(), cacheNodeInterop = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(nodeInterop2) {
      return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
    }, "_getRequireWildcardCache"))(nodeInterop);
  }
  __name(_getRequireWildcardCache, "_getRequireWildcardCache");
  function _interopRequireWildcard(obj, nodeInterop) {
    if (obj && obj.__esModule)
      return obj;
    if (obj === null || typeof obj != "object" && typeof obj != "function")
      return { default: obj };
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj))
      return cache.get(obj);
    var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj)
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
      }
    return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
  }
  __name(_interopRequireWildcard, "_interopRequireWildcard");
  let matchesSelectorFunc = "";
  function matchesSelector(el, selector) {
    return matchesSelectorFunc || (matchesSelectorFunc = (0, _shims.findInArray)(["matches", "webkitMatchesSelector", "mozMatchesSelector", "msMatchesSelector", "oMatchesSelector"], function(method) {
      return (0, _shims.isFunction)(el[method]);
    })), (0, _shims.isFunction)(el[matchesSelectorFunc]) ? el[matchesSelectorFunc](selector) : !1;
  }
  __name(matchesSelector, "matchesSelector");
  function matchesSelectorAndParentsTo(el, selector, baseNode) {
    let node = el;
    do {
      if (matchesSelector(node, selector)) return !0;
      if (node === baseNode) return !1;
      node = node.parentNode;
    } while (node);
    return !1;
  }
  __name(matchesSelectorAndParentsTo, "matchesSelectorAndParentsTo");
  function addEvent(el, event, handler, inputOptions) {
    if (!el) return;
    const options = {
      capture: !0,
      ...inputOptions
    };
    el.addEventListener ? el.addEventListener(event, handler, options) : el.attachEvent ? el.attachEvent("on" + event, handler) : el["on" + event] = handler;
  }
  __name(addEvent, "addEvent");
  function removeEvent(el, event, handler, inputOptions) {
    if (!el) return;
    const options = {
      capture: !0,
      ...inputOptions
    };
    el.removeEventListener ? el.removeEventListener(event, handler, options) : el.detachEvent ? el.detachEvent("on" + event, handler) : el["on" + event] = null;
  }
  __name(removeEvent, "removeEvent");
  function outerHeight(node) {
    let height = node.clientHeight;
    const computedStyle = node.ownerDocument.defaultView.getComputedStyle(node);
    return height += (0, _shims.int)(computedStyle.borderTopWidth), height += (0, _shims.int)(computedStyle.borderBottomWidth), height;
  }
  __name(outerHeight, "outerHeight");
  function outerWidth(node) {
    let width = node.clientWidth;
    const computedStyle = node.ownerDocument.defaultView.getComputedStyle(node);
    return width += (0, _shims.int)(computedStyle.borderLeftWidth), width += (0, _shims.int)(computedStyle.borderRightWidth), width;
  }
  __name(outerWidth, "outerWidth");
  function innerHeight(node) {
    let height = node.clientHeight;
    const computedStyle = node.ownerDocument.defaultView.getComputedStyle(node);
    return height -= (0, _shims.int)(computedStyle.paddingTop), height -= (0, _shims.int)(computedStyle.paddingBottom), height;
  }
  __name(innerHeight, "innerHeight");
  function innerWidth(node) {
    let width = node.clientWidth;
    const computedStyle = node.ownerDocument.defaultView.getComputedStyle(node);
    return width -= (0, _shims.int)(computedStyle.paddingLeft), width -= (0, _shims.int)(computedStyle.paddingRight), width;
  }
  __name(innerWidth, "innerWidth");
  function offsetXYFromParent(evt, offsetParent, scale) {
    const offsetParentRect = offsetParent === offsetParent.ownerDocument.body ? {
      left: 0,
      top: 0
    } : offsetParent.getBoundingClientRect(), x = (evt.clientX + offsetParent.scrollLeft - offsetParentRect.left) / scale, y = (evt.clientY + offsetParent.scrollTop - offsetParentRect.top) / scale;
    return {
      x,
      y
    };
  }
  __name(offsetXYFromParent, "offsetXYFromParent");
  function createCSSTransform(controlPos, positionOffset) {
    const translation = getTranslation(controlPos, positionOffset, "px");
    return {
      [(0, _getPrefix.browserPrefixToKey)("transform", _getPrefix.default)]: translation
    };
  }
  __name(createCSSTransform, "createCSSTransform");
  function createSVGTransform(controlPos, positionOffset) {
    return getTranslation(controlPos, positionOffset, "");
  }
  __name(createSVGTransform, "createSVGTransform");
  function getTranslation(_ref, positionOffset, unitSuffix) {
    let {
      x,
      y
    } = _ref, translation = "translate(".concat(x).concat(unitSuffix, ",").concat(y).concat(unitSuffix, ")");
    if (positionOffset) {
      const defaultX = "".concat(typeof positionOffset.x == "string" ? positionOffset.x : positionOffset.x + unitSuffix), defaultY = "".concat(typeof positionOffset.y == "string" ? positionOffset.y : positionOffset.y + unitSuffix);
      translation = "translate(".concat(defaultX, ", ").concat(defaultY, ")") + translation;
    }
    return translation;
  }
  __name(getTranslation, "getTranslation");
  function getTouch(e, identifier) {
    return e.targetTouches && (0, _shims.findInArray)(e.targetTouches, (t) => identifier === t.identifier) || e.changedTouches && (0, _shims.findInArray)(e.changedTouches, (t) => identifier === t.identifier);
  }
  __name(getTouch, "getTouch");
  function getTouchIdentifier(e) {
    if (e.targetTouches && e.targetTouches[0]) return e.targetTouches[0].identifier;
    if (e.changedTouches && e.changedTouches[0]) return e.changedTouches[0].identifier;
  }
  __name(getTouchIdentifier, "getTouchIdentifier");
  function addUserSelectStyles(doc) {
    if (!doc) return;
    let styleEl = doc.getElementById("react-draggable-style-el");
    styleEl || (styleEl = doc.createElement("style"), styleEl.type = "text/css", styleEl.id = "react-draggable-style-el", styleEl.innerHTML = `.react-draggable-transparent-selection *::-moz-selection {all: inherit;}
`, styleEl.innerHTML += `.react-draggable-transparent-selection *::selection {all: inherit;}
`, doc.getElementsByTagName("head")[0].appendChild(styleEl)), doc.body && addClassName(doc.body, "react-draggable-transparent-selection");
  }
  __name(addUserSelectStyles, "addUserSelectStyles");
  function removeUserSelectStyles(doc) {
    if (doc)
      try {
        if (doc.body && removeClassName(doc.body, "react-draggable-transparent-selection"), doc.selection)
          doc.selection.empty();
        else {
          const selection = (doc.defaultView || window).getSelection();
          selection && selection.type !== "Caret" && selection.removeAllRanges();
        }
      } catch {
      }
  }
  __name(removeUserSelectStyles, "removeUserSelectStyles");
  function addClassName(el, className) {
    el.classList ? el.classList.add(className) : el.className.match(new RegExp("(?:^|\\s)".concat(className, "(?!\\S)"))) || (el.className += " ".concat(className));
  }
  __name(addClassName, "addClassName");
  function removeClassName(el, className) {
    el.classList ? el.classList.remove(className) : el.className = el.className.replace(new RegExp("(?:^|\\s)".concat(className, "(?!\\S)"), "g"), "");
  }
  return __name(removeClassName, "removeClassName"), domFns;
}
__name(requireDomFns, "requireDomFns");
var positionFns = {}, hasRequiredPositionFns;
function requirePositionFns() {
  if (hasRequiredPositionFns) return positionFns;
  hasRequiredPositionFns = 1, Object.defineProperty(positionFns, "__esModule", {
    value: !0
  }), positionFns.canDragX = canDragX, positionFns.canDragY = canDragY, positionFns.createCoreData = createCoreData, positionFns.createDraggableData = createDraggableData, positionFns.getBoundPosition = getBoundPosition, positionFns.getControlPosition = getControlPosition, positionFns.snapToGrid = snapToGrid;
  var _shims = requireShims(), _domFns = requireDomFns();
  function getBoundPosition(draggable, x, y) {
    if (!draggable.props.bounds) return [x, y];
    let {
      bounds
    } = draggable.props;
    bounds = typeof bounds == "string" ? bounds : cloneBounds(bounds);
    const node = findDOMNode(draggable);
    if (typeof bounds == "string") {
      const {
        ownerDocument
      } = node, ownerWindow = ownerDocument.defaultView;
      let boundNode;
      if (bounds === "parent" ? boundNode = node.parentNode : boundNode = ownerDocument.querySelector(bounds), !(boundNode instanceof ownerWindow.HTMLElement))
        throw new Error('Bounds selector "' + bounds + '" could not find an element.');
      const boundNodeEl = boundNode, nodeStyle = ownerWindow.getComputedStyle(node), boundNodeStyle = ownerWindow.getComputedStyle(boundNodeEl);
      bounds = {
        left: -node.offsetLeft + (0, _shims.int)(boundNodeStyle.paddingLeft) + (0, _shims.int)(nodeStyle.marginLeft),
        top: -node.offsetTop + (0, _shims.int)(boundNodeStyle.paddingTop) + (0, _shims.int)(nodeStyle.marginTop),
        right: (0, _domFns.innerWidth)(boundNodeEl) - (0, _domFns.outerWidth)(node) - node.offsetLeft + (0, _shims.int)(boundNodeStyle.paddingRight) - (0, _shims.int)(nodeStyle.marginRight),
        bottom: (0, _domFns.innerHeight)(boundNodeEl) - (0, _domFns.outerHeight)(node) - node.offsetTop + (0, _shims.int)(boundNodeStyle.paddingBottom) - (0, _shims.int)(nodeStyle.marginBottom)
      };
    }
    return (0, _shims.isNum)(bounds.right) && (x = Math.min(x, bounds.right)), (0, _shims.isNum)(bounds.bottom) && (y = Math.min(y, bounds.bottom)), (0, _shims.isNum)(bounds.left) && (x = Math.max(x, bounds.left)), (0, _shims.isNum)(bounds.top) && (y = Math.max(y, bounds.top)), [x, y];
  }
  __name(getBoundPosition, "getBoundPosition");
  function snapToGrid(grid, pendingX, pendingY) {
    const x = Math.round(pendingX / grid[0]) * grid[0], y = Math.round(pendingY / grid[1]) * grid[1];
    return [x, y];
  }
  __name(snapToGrid, "snapToGrid");
  function canDragX(draggable) {
    return draggable.props.axis === "both" || draggable.props.axis === "x";
  }
  __name(canDragX, "canDragX");
  function canDragY(draggable) {
    return draggable.props.axis === "both" || draggable.props.axis === "y";
  }
  __name(canDragY, "canDragY");
  function getControlPosition(e, touchIdentifier, draggableCore) {
    const touchObj = typeof touchIdentifier == "number" ? (0, _domFns.getTouch)(e, touchIdentifier) : null;
    if (typeof touchIdentifier == "number" && !touchObj) return null;
    const node = findDOMNode(draggableCore), offsetParent = draggableCore.props.offsetParent || node.offsetParent || node.ownerDocument.body;
    return (0, _domFns.offsetXYFromParent)(touchObj || e, offsetParent, draggableCore.props.scale);
  }
  __name(getControlPosition, "getControlPosition");
  function createCoreData(draggable, x, y) {
    const isStart = !(0, _shims.isNum)(draggable.lastX), node = findDOMNode(draggable);
    return isStart ? {
      node,
      deltaX: 0,
      deltaY: 0,
      lastX: x,
      lastY: y,
      x,
      y
    } : {
      node,
      deltaX: x - draggable.lastX,
      deltaY: y - draggable.lastY,
      lastX: draggable.lastX,
      lastY: draggable.lastY,
      x,
      y
    };
  }
  __name(createCoreData, "createCoreData");
  function createDraggableData(draggable, coreData) {
    const scale = draggable.props.scale;
    return {
      node: coreData.node,
      x: draggable.state.x + coreData.deltaX / scale,
      y: draggable.state.y + coreData.deltaY / scale,
      deltaX: coreData.deltaX / scale,
      deltaY: coreData.deltaY / scale,
      lastX: draggable.state.x,
      lastY: draggable.state.y
    };
  }
  __name(createDraggableData, "createDraggableData");
  function cloneBounds(bounds) {
    return {
      left: bounds.left,
      top: bounds.top,
      right: bounds.right,
      bottom: bounds.bottom
    };
  }
  __name(cloneBounds, "cloneBounds");
  function findDOMNode(draggable) {
    const node = draggable.findDOMNode();
    if (!node)
      throw new Error("<DraggableCore>: Unmounted during event!");
    return node;
  }
  return __name(findDOMNode, "findDOMNode"), positionFns;
}
__name(requirePositionFns, "requirePositionFns");
var DraggableCore = {}, log = {}, hasRequiredLog;
function requireLog() {
  if (hasRequiredLog) return log;
  hasRequiredLog = 1, Object.defineProperty(log, "__esModule", {
    value: !0
  }), log.default = log$1;
  function log$1() {
  }
  return __name(log$1, "log$1"), log;
}
__name(requireLog, "requireLog");
var hasRequiredDraggableCore;
function requireDraggableCore() {
  var _a15;
  if (hasRequiredDraggableCore) return DraggableCore;
  hasRequiredDraggableCore = 1, Object.defineProperty(DraggableCore, "__esModule", {
    value: !0
  }), DraggableCore.default = void 0;
  var React = _interopRequireWildcard(require$$0), _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1()), _reactDom = _interopRequireDefault(require$$2$1), _domFns = requireDomFns(), _positionFns = requirePositionFns(), _shims = requireShims(), _log = _interopRequireDefault(requireLog());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap != "function") return null;
    var cacheBabelInterop = /* @__PURE__ */ new WeakMap(), cacheNodeInterop = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(nodeInterop2) {
      return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
    }, "_getRequireWildcardCache"))(nodeInterop);
  }
  __name(_getRequireWildcardCache, "_getRequireWildcardCache");
  function _interopRequireWildcard(obj, nodeInterop) {
    if (obj && obj.__esModule)
      return obj;
    if (obj === null || typeof obj != "object" && typeof obj != "function")
      return { default: obj };
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj))
      return cache.get(obj);
    var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj)
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
      }
    return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
  }
  __name(_interopRequireWildcard, "_interopRequireWildcard");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  const eventsFor = {
    touch: {
      start: "touchstart",
      move: "touchmove",
      stop: "touchend"
    },
    mouse: {
      start: "mousedown",
      move: "mousemove",
      stop: "mouseup"
    }
  };
  let dragEventFor = eventsFor.mouse, DraggableCore$1 = (_a15 = class extends React.Component {
    constructor() {
      super(...arguments), _defineProperty(this, "dragging", !1), _defineProperty(this, "lastX", NaN), _defineProperty(this, "lastY", NaN), _defineProperty(this, "touchIdentifier", null), _defineProperty(this, "mounted", !1), _defineProperty(this, "handleDragStart", (e) => {
        if (this.props.onMouseDown(e), !this.props.allowAnyClick && typeof e.button == "number" && e.button !== 0) return !1;
        const thisNode = this.findDOMNode();
        if (!thisNode || !thisNode.ownerDocument || !thisNode.ownerDocument.body)
          throw new Error("<DraggableCore> not mounted on DragStart!");
        const {
          ownerDocument
        } = thisNode;
        if (this.props.disabled || !(e.target instanceof ownerDocument.defaultView.Node) || this.props.handle && !(0, _domFns.matchesSelectorAndParentsTo)(e.target, this.props.handle, thisNode) || this.props.cancel && (0, _domFns.matchesSelectorAndParentsTo)(e.target, this.props.cancel, thisNode))
          return;
        e.type === "touchstart" && e.preventDefault();
        const touchIdentifier = (0, _domFns.getTouchIdentifier)(e);
        this.touchIdentifier = touchIdentifier;
        const position = (0, _positionFns.getControlPosition)(e, touchIdentifier, this);
        if (position == null) return;
        const {
          x,
          y
        } = position, coreEvent = (0, _positionFns.createCoreData)(this, x, y);
        (0, _log.default)("DraggableCore: handleDragStart: %j", coreEvent), (0, _log.default)("calling", this.props.onStart), !(this.props.onStart(e, coreEvent) === !1 || this.mounted === !1) && (this.props.enableUserSelectHack && (0, _domFns.addUserSelectStyles)(ownerDocument), this.dragging = !0, this.lastX = x, this.lastY = y, (0, _domFns.addEvent)(ownerDocument, dragEventFor.move, this.handleDrag), (0, _domFns.addEvent)(ownerDocument, dragEventFor.stop, this.handleDragStop));
      }), _defineProperty(this, "handleDrag", (e) => {
        const position = (0, _positionFns.getControlPosition)(e, this.touchIdentifier, this);
        if (position == null) return;
        let {
          x,
          y
        } = position;
        if (Array.isArray(this.props.grid)) {
          let deltaX = x - this.lastX, deltaY = y - this.lastY;
          if ([deltaX, deltaY] = (0, _positionFns.snapToGrid)(this.props.grid, deltaX, deltaY), !deltaX && !deltaY) return;
          x = this.lastX + deltaX, y = this.lastY + deltaY;
        }
        const coreEvent = (0, _positionFns.createCoreData)(this, x, y);
        if ((0, _log.default)("DraggableCore: handleDrag: %j", coreEvent), this.props.onDrag(e, coreEvent) === !1 || this.mounted === !1) {
          try {
            this.handleDragStop(new MouseEvent("mouseup"));
          } catch {
            const event = document.createEvent("MouseEvents");
            event.initMouseEvent("mouseup", !0, !0, window, 0, 0, 0, 0, 0, !1, !1, !1, !1, 0, null), this.handleDragStop(event);
          }
          return;
        }
        this.lastX = x, this.lastY = y;
      }), _defineProperty(this, "handleDragStop", (e) => {
        if (!this.dragging) return;
        const position = (0, _positionFns.getControlPosition)(e, this.touchIdentifier, this);
        if (position == null) return;
        let {
          x,
          y
        } = position;
        if (Array.isArray(this.props.grid)) {
          let deltaX = x - this.lastX || 0, deltaY = y - this.lastY || 0;
          [deltaX, deltaY] = (0, _positionFns.snapToGrid)(this.props.grid, deltaX, deltaY), x = this.lastX + deltaX, y = this.lastY + deltaY;
        }
        const coreEvent = (0, _positionFns.createCoreData)(this, x, y);
        if (this.props.onStop(e, coreEvent) === !1 || this.mounted === !1) return !1;
        const thisNode = this.findDOMNode();
        thisNode && this.props.enableUserSelectHack && (0, _domFns.removeUserSelectStyles)(thisNode.ownerDocument), (0, _log.default)("DraggableCore: handleDragStop: %j", coreEvent), this.dragging = !1, this.lastX = NaN, this.lastY = NaN, thisNode && ((0, _log.default)("DraggableCore: Removing handlers"), (0, _domFns.removeEvent)(thisNode.ownerDocument, dragEventFor.move, this.handleDrag), (0, _domFns.removeEvent)(thisNode.ownerDocument, dragEventFor.stop, this.handleDragStop));
      }), _defineProperty(this, "onMouseDown", (e) => (dragEventFor = eventsFor.mouse, this.handleDragStart(e))), _defineProperty(this, "onMouseUp", (e) => (dragEventFor = eventsFor.mouse, this.handleDragStop(e))), _defineProperty(this, "onTouchStart", (e) => (dragEventFor = eventsFor.touch, this.handleDragStart(e))), _defineProperty(this, "onTouchEnd", (e) => (dragEventFor = eventsFor.touch, this.handleDragStop(e)));
    }
    componentDidMount() {
      this.mounted = !0;
      const thisNode = this.findDOMNode();
      thisNode && (0, _domFns.addEvent)(thisNode, eventsFor.touch.start, this.onTouchStart, {
        passive: !1
      });
    }
    componentWillUnmount() {
      this.mounted = !1;
      const thisNode = this.findDOMNode();
      if (thisNode) {
        const {
          ownerDocument
        } = thisNode;
        (0, _domFns.removeEvent)(ownerDocument, eventsFor.mouse.move, this.handleDrag), (0, _domFns.removeEvent)(ownerDocument, eventsFor.touch.move, this.handleDrag), (0, _domFns.removeEvent)(ownerDocument, eventsFor.mouse.stop, this.handleDragStop), (0, _domFns.removeEvent)(ownerDocument, eventsFor.touch.stop, this.handleDragStop), (0, _domFns.removeEvent)(thisNode, eventsFor.touch.start, this.onTouchStart, {
          passive: !1
        }), this.props.enableUserSelectHack && (0, _domFns.removeUserSelectStyles)(ownerDocument);
      }
    }
    // React Strict Mode compatibility: if `nodeRef` is passed, we will use it instead of trying to find
    // the underlying DOM node ourselves. See the README for more information.
    findDOMNode() {
      var _this$props, _this$props2;
      return (_this$props = this.props) !== null && _this$props !== void 0 && _this$props.nodeRef ? (_this$props2 = this.props) === null || _this$props2 === void 0 || (_this$props2 = _this$props2.nodeRef) === null || _this$props2 === void 0 ? void 0 : _this$props2.current : _reactDom.default.findDOMNode(this);
    }
    render() {
      return /* @__PURE__ */ React.cloneElement(React.Children.only(this.props.children), {
        // Note: mouseMove handler is attached to document so it will still function
        // when the user drags quickly and leaves the bounds of the element.
        onMouseDown: this.onMouseDown,
        onMouseUp: this.onMouseUp,
        // onTouchStart is added on `componentDidMount` so they can be added with
        // {passive: false}, which allows it to cancel. See
        // https://developers.google.com/web/updates/2017/01/scrolling-intervention
        onTouchEnd: this.onTouchEnd
      });
    }
  }, __name(_a15, "DraggableCore"), _a15);
  return DraggableCore.default = DraggableCore$1, _defineProperty(DraggableCore$1, "displayName", "DraggableCore"), _defineProperty(DraggableCore$1, "propTypes", {
    /**
     * `allowAnyClick` allows dragging using any mouse button.
     * By default, we only accept the left button.
     *
     * Defaults to `false`.
     */
    allowAnyClick: _propTypes.default.bool,
    children: _propTypes.default.node.isRequired,
    /**
     * `disabled`, if true, stops the <Draggable> from dragging. All handlers,
     * with the exception of `onMouseDown`, will not fire.
     */
    disabled: _propTypes.default.bool,
    /**
     * By default, we add 'user-select:none' attributes to the document body
     * to prevent ugly text selection during drag. If this is causing problems
     * for your app, set this to `false`.
     */
    enableUserSelectHack: _propTypes.default.bool,
    /**
     * `offsetParent`, if set, uses the passed DOM node to compute drag offsets
     * instead of using the parent node.
     */
    offsetParent: /* @__PURE__ */ __name(function(props, propName) {
      if (props[propName] && props[propName].nodeType !== 1)
        throw new Error("Draggable's offsetParent must be a DOM Node.");
    }, "offsetParent"),
    /**
     * `grid` specifies the x and y that dragging should snap to.
     */
    grid: _propTypes.default.arrayOf(_propTypes.default.number),
    /**
     * `handle` specifies a selector to be used as the handle that initiates drag.
     *
     * Example:
     *
     * ```jsx
     *   let App = React.createClass({
     *       render: function () {
     *         return (
     *            <Draggable handle=".handle">
     *              <div>
     *                  <div className="handle">Click me to drag</div>
     *                  <div>This is some other content</div>
     *              </div>
     *           </Draggable>
     *         );
     *       }
     *   });
     * ```
     */
    handle: _propTypes.default.string,
    /**
     * `cancel` specifies a selector to be used to prevent drag initialization.
     *
     * Example:
     *
     * ```jsx
     *   let App = React.createClass({
     *       render: function () {
     *           return(
     *               <Draggable cancel=".cancel">
     *                   <div>
     *                     <div className="cancel">You can't drag from here</div>
     *                     <div>Dragging here works fine</div>
     *                   </div>
     *               </Draggable>
     *           );
     *       }
     *   });
     * ```
     */
    cancel: _propTypes.default.string,
    /* If running in React Strict mode, ReactDOM.findDOMNode() is deprecated.
     * Unfortunately, in order for <Draggable> to work properly, we need raw access
     * to the underlying DOM node. If you want to avoid the warning, pass a `nodeRef`
     * as in this example:
     *
     * function MyComponent() {
     *   const nodeRef = React.useRef(null);
     *   return (
     *     <Draggable nodeRef={nodeRef}>
     *       <div ref={nodeRef}>Example Target</div>
     *     </Draggable>
     *   );
     * }
     *
     * This can be used for arbitrarily nested components, so long as the ref ends up
     * pointing to the actual child DOM node and not a custom component.
     */
    nodeRef: _propTypes.default.object,
    /**
     * Called when dragging starts.
     * If this function returns the boolean false, dragging will be canceled.
     */
    onStart: _propTypes.default.func,
    /**
     * Called while dragging.
     * If this function returns the boolean false, dragging will be canceled.
     */
    onDrag: _propTypes.default.func,
    /**
     * Called when dragging stops.
     * If this function returns the boolean false, the drag will remain active.
     */
    onStop: _propTypes.default.func,
    /**
     * A workaround option which can be passed if onMouseDown needs to be accessed,
     * since it'll always be blocked (as there is internal use of onMouseDown)
     */
    onMouseDown: _propTypes.default.func,
    /**
     * `scale`, if set, applies scaling while dragging an element
     */
    scale: _propTypes.default.number,
    /**
     * These properties should be defined on the child, not here.
     */
    className: _shims.dontSetMe,
    style: _shims.dontSetMe,
    transform: _shims.dontSetMe
  }), _defineProperty(DraggableCore$1, "defaultProps", {
    allowAnyClick: !1,
    // by default only accept left click
    disabled: !1,
    enableUserSelectHack: !0,
    onStart: /* @__PURE__ */ __name(function() {
    }, "onStart"),
    onDrag: /* @__PURE__ */ __name(function() {
    }, "onDrag"),
    onStop: /* @__PURE__ */ __name(function() {
    }, "onStop"),
    onMouseDown: /* @__PURE__ */ __name(function() {
    }, "onMouseDown"),
    scale: 1
  }), DraggableCore;
}
__name(requireDraggableCore, "requireDraggableCore");
var hasRequiredDraggable;
function requireDraggable() {
  return hasRequiredDraggable || (hasRequiredDraggable = 1, function(exports) {
    Object.defineProperty(exports, "__esModule", {
      value: !0
    }), Object.defineProperty(exports, "DraggableCore", {
      enumerable: !0,
      get: /* @__PURE__ */ __name(function() {
        return _DraggableCore.default;
      }, "get")
    }), exports.default = void 0;
    var React = _interopRequireWildcard(require$$0), _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1()), _reactDom = _interopRequireDefault(require$$2$1), _clsx = _interopRequireDefault(require$$3), _domFns = requireDomFns(), _positionFns = requirePositionFns(), _shims = requireShims(), _DraggableCore = _interopRequireDefault(requireDraggableCore()), _log = _interopRequireDefault(requireLog());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    __name(_interopRequireDefault, "_interopRequireDefault");
    function _getRequireWildcardCache(nodeInterop) {
      if (typeof WeakMap != "function") return null;
      var cacheBabelInterop = /* @__PURE__ */ new WeakMap(), cacheNodeInterop = /* @__PURE__ */ new WeakMap();
      return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(nodeInterop2) {
        return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
      }, "_getRequireWildcardCache"))(nodeInterop);
    }
    __name(_getRequireWildcardCache, "_getRequireWildcardCache");
    function _interopRequireWildcard(obj, nodeInterop) {
      if (obj && obj.__esModule)
        return obj;
      if (obj === null || typeof obj != "object" && typeof obj != "function")
        return { default: obj };
      var cache = _getRequireWildcardCache(nodeInterop);
      if (cache && cache.has(obj))
        return cache.get(obj);
      var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
      for (var key in obj)
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
          desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
        }
      return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
    }
    __name(_interopRequireWildcard, "_interopRequireWildcard");
    function _extends() {
      return _extends = Object.assign ? Object.assign.bind() : function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source)
            Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
        }
        return target;
      }, _extends.apply(this, arguments);
    }
    __name(_extends, "_extends");
    function _defineProperty(obj, key, value) {
      return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
    }
    __name(_defineProperty, "_defineProperty");
    function _toPropertyKey(arg) {
      var key = _toPrimitive(arg, "string");
      return typeof key == "symbol" ? key : String(key);
    }
    __name(_toPropertyKey, "_toPropertyKey");
    function _toPrimitive(input, hint) {
      if (typeof input != "object" || input === null) return input;
      var prim = input[Symbol.toPrimitive];
      if (prim !== void 0) {
        var res = prim.call(input, hint || "default");
        if (typeof res != "object") return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
      }
      return (hint === "string" ? String : Number)(input);
    }
    __name(_toPrimitive, "_toPrimitive");
    const _Draggable = class _Draggable extends React.Component {
      // React 16.3+
      // Arity (props, state)
      static getDerivedStateFromProps(_ref, _ref2) {
        let {
          position
        } = _ref, {
          prevPropsPosition
        } = _ref2;
        return position && (!prevPropsPosition || position.x !== prevPropsPosition.x || position.y !== prevPropsPosition.y) ? ((0, _log.default)("Draggable: getDerivedStateFromProps %j", {
          position,
          prevPropsPosition
        }), {
          x: position.x,
          y: position.y,
          prevPropsPosition: {
            ...position
          }
        }) : null;
      }
      constructor(props) {
        super(props), _defineProperty(this, "onDragStart", (e, coreData) => {
          if ((0, _log.default)("Draggable: onDragStart: %j", coreData), this.props.onStart(e, (0, _positionFns.createDraggableData)(this, coreData)) === !1) return !1;
          this.setState({
            dragging: !0,
            dragged: !0
          });
        }), _defineProperty(this, "onDrag", (e, coreData) => {
          if (!this.state.dragging) return !1;
          (0, _log.default)("Draggable: onDrag: %j", coreData);
          const uiData = (0, _positionFns.createDraggableData)(this, coreData), newState = {
            x: uiData.x,
            y: uiData.y,
            slackX: 0,
            slackY: 0
          };
          if (this.props.bounds) {
            const {
              x,
              y
            } = newState;
            newState.x += this.state.slackX, newState.y += this.state.slackY;
            const [newStateX, newStateY] = (0, _positionFns.getBoundPosition)(this, newState.x, newState.y);
            newState.x = newStateX, newState.y = newStateY, newState.slackX = this.state.slackX + (x - newState.x), newState.slackY = this.state.slackY + (y - newState.y), uiData.x = newState.x, uiData.y = newState.y, uiData.deltaX = newState.x - this.state.x, uiData.deltaY = newState.y - this.state.y;
          }
          if (this.props.onDrag(e, uiData) === !1) return !1;
          this.setState(newState);
        }), _defineProperty(this, "onDragStop", (e, coreData) => {
          if (!this.state.dragging || this.props.onStop(e, (0, _positionFns.createDraggableData)(this, coreData)) === !1) return !1;
          (0, _log.default)("Draggable: onDragStop: %j", coreData);
          const newState = {
            dragging: !1,
            slackX: 0,
            slackY: 0
          };
          if (!!this.props.position) {
            const {
              x,
              y
            } = this.props.position;
            newState.x = x, newState.y = y;
          }
          this.setState(newState);
        }), this.state = {
          // Whether or not we are currently dragging.
          dragging: !1,
          // Whether or not we have been dragged before.
          dragged: !1,
          // Current transform x and y.
          x: props.position ? props.position.x : props.defaultPosition.x,
          y: props.position ? props.position.y : props.defaultPosition.y,
          prevPropsPosition: {
            ...props.position
          },
          // Used for compensating for out-of-bounds drags
          slackX: 0,
          slackY: 0,
          // Can only determine if SVG after mounting
          isElementSVG: !1
        }, props.position && !(props.onDrag || props.onStop) && console.warn("A `position` was applied to this <Draggable>, without drag handlers. This will make this component effectively undraggable. Please attach `onDrag` or `onStop` handlers so you can adjust the `position` of this element.");
      }
      componentDidMount() {
        typeof window.SVGElement < "u" && this.findDOMNode() instanceof window.SVGElement && this.setState({
          isElementSVG: !0
        });
      }
      componentWillUnmount() {
        this.setState({
          dragging: !1
        });
      }
      // React Strict Mode compatibility: if `nodeRef` is passed, we will use it instead of trying to find
      // the underlying DOM node ourselves. See the README for more information.
      findDOMNode() {
        var _this$props$nodeRef$c, _this$props;
        return (_this$props$nodeRef$c = (_this$props = this.props) === null || _this$props === void 0 || (_this$props = _this$props.nodeRef) === null || _this$props === void 0 ? void 0 : _this$props.current) !== null && _this$props$nodeRef$c !== void 0 ? _this$props$nodeRef$c : _reactDom.default.findDOMNode(this);
      }
      render() {
        const {
          axis,
          bounds,
          children,
          defaultPosition,
          defaultClassName,
          defaultClassNameDragging,
          defaultClassNameDragged,
          position,
          positionOffset,
          scale,
          ...draggableCoreProps
        } = this.props;
        let style = {}, svgTransform = null;
        const draggable = !!!position || this.state.dragging, validPosition = position || defaultPosition, transformOpts = {
          // Set left if horizontal drag is enabled
          x: (0, _positionFns.canDragX)(this) && draggable ? this.state.x : validPosition.x,
          // Set top if vertical drag is enabled
          y: (0, _positionFns.canDragY)(this) && draggable ? this.state.y : validPosition.y
        };
        this.state.isElementSVG ? svgTransform = (0, _domFns.createSVGTransform)(transformOpts, positionOffset) : style = (0, _domFns.createCSSTransform)(transformOpts, positionOffset);
        const className = (0, _clsx.default)(children.props.className || "", defaultClassName, {
          [defaultClassNameDragging]: this.state.dragging,
          [defaultClassNameDragged]: this.state.dragged
        });
        return /* @__PURE__ */ React.createElement(_DraggableCore.default, _extends({}, draggableCoreProps, {
          onStart: this.onDragStart,
          onDrag: this.onDrag,
          onStop: this.onDragStop
        }), /* @__PURE__ */ React.cloneElement(React.Children.only(children), {
          className,
          style: {
            ...children.props.style,
            ...style
          },
          transform: svgTransform
        }));
      }
    };
    __name(_Draggable, "Draggable");
    let Draggable2 = _Draggable;
    exports.default = Draggable2, _defineProperty(Draggable2, "displayName", "Draggable"), _defineProperty(Draggable2, "propTypes", {
      // Accepts all props <DraggableCore> accepts.
      ..._DraggableCore.default.propTypes,
      /**
       * `axis` determines which axis the draggable can move.
       *
       *  Note that all callbacks will still return data as normal. This only
       *  controls flushing to the DOM.
       *
       * 'both' allows movement horizontally and vertically.
       * 'x' limits movement to horizontal axis.
       * 'y' limits movement to vertical axis.
       * 'none' limits all movement.
       *
       * Defaults to 'both'.
       */
      axis: _propTypes.default.oneOf(["both", "x", "y", "none"]),
      /**
       * `bounds` determines the range of movement available to the element.
       * Available values are:
       *
       * 'parent' restricts movement within the Draggable's parent node.
       *
       * Alternatively, pass an object with the following properties, all of which are optional:
       *
       * {left: LEFT_BOUND, right: RIGHT_BOUND, bottom: BOTTOM_BOUND, top: TOP_BOUND}
       *
       * All values are in px.
       *
       * Example:
       *
       * ```jsx
       *   let App = React.createClass({
       *       render: function () {
       *         return (
       *            <Draggable bounds={{right: 300, bottom: 300}}>
       *              <div>Content</div>
       *           </Draggable>
       *         );
       *       }
       *   });
       * ```
       */
      bounds: _propTypes.default.oneOfType([_propTypes.default.shape({
        left: _propTypes.default.number,
        right: _propTypes.default.number,
        top: _propTypes.default.number,
        bottom: _propTypes.default.number
      }), _propTypes.default.string, _propTypes.default.oneOf([!1])]),
      defaultClassName: _propTypes.default.string,
      defaultClassNameDragging: _propTypes.default.string,
      defaultClassNameDragged: _propTypes.default.string,
      /**
       * `defaultPosition` specifies the x and y that the dragged item should start at
       *
       * Example:
       *
       * ```jsx
       *      let App = React.createClass({
       *          render: function () {
       *              return (
       *                  <Draggable defaultPosition={{x: 25, y: 25}}>
       *                      <div>I start with transformX: 25px and transformY: 25px;</div>
       *                  </Draggable>
       *              );
       *          }
       *      });
       * ```
       */
      defaultPosition: _propTypes.default.shape({
        x: _propTypes.default.number,
        y: _propTypes.default.number
      }),
      positionOffset: _propTypes.default.shape({
        x: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
        y: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string])
      }),
      /**
       * `position`, if present, defines the current position of the element.
       *
       *  This is similar to how form elements in React work - if no `position` is supplied, the component
       *  is uncontrolled.
       *
       * Example:
       *
       * ```jsx
       *      let App = React.createClass({
       *          render: function () {
       *              return (
       *                  <Draggable position={{x: 25, y: 25}}>
       *                      <div>I start with transformX: 25px and transformY: 25px;</div>
       *                  </Draggable>
       *              );
       *          }
       *      });
       * ```
       */
      position: _propTypes.default.shape({
        x: _propTypes.default.number,
        y: _propTypes.default.number
      }),
      /**
       * These properties should be defined on the child, not here.
       */
      className: _shims.dontSetMe,
      style: _shims.dontSetMe,
      transform: _shims.dontSetMe
    }), _defineProperty(Draggable2, "defaultProps", {
      ..._DraggableCore.default.defaultProps,
      axis: "both",
      bounds: !1,
      defaultClassName: "react-draggable",
      defaultClassNameDragging: "react-draggable-dragging",
      defaultClassNameDragged: "react-draggable-dragged",
      defaultPosition: {
        x: 0,
        y: 0
      },
      scale: 1
    });
  }(Draggable)), Draggable;
}
__name(requireDraggable, "requireDraggable");
var hasRequiredCjs;
function requireCjs() {
  if (hasRequiredCjs) return cjs.exports;
  hasRequiredCjs = 1;
  const {
    default: Draggable2,
    DraggableCore: DraggableCore2
  } = requireDraggable();
  return cjs.exports = Draggable2, cjs.exports.default = Draggable2, cjs.exports.DraggableCore = DraggableCore2, cjs.exports;
}
__name(requireCjs, "requireCjs");
var reactResizable = { exports: {} }, Resizable = {}, utils = {}, hasRequiredUtils;
function requireUtils() {
  if (hasRequiredUtils) return utils;
  hasRequiredUtils = 1, utils.__esModule = !0, utils.cloneElement = cloneElement;
  var _react = _interopRequireDefault(require$$0);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }
    return keys;
  }
  __name(ownKeys, "ownKeys");
  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
    return target;
  }
  __name(_objectSpread, "_objectSpread");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  function cloneElement(element2, props) {
    return props.style && element2.props.style && (props.style = _objectSpread(_objectSpread({}, element2.props.style), props.style)), props.className && element2.props.className && (props.className = element2.props.className + " " + props.className), /* @__PURE__ */ _react.default.cloneElement(element2, props);
  }
  return __name(cloneElement, "cloneElement"), utils;
}
__name(requireUtils, "requireUtils");
var propTypes = {}, hasRequiredPropTypes;
function requirePropTypes() {
  if (hasRequiredPropTypes) return propTypes;
  hasRequiredPropTypes = 1, propTypes.__esModule = !0, propTypes.resizableProps = void 0;
  var _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1());
  requireCjs();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  var resizableProps = {
    /*
    * Restricts resizing to a particular axis (default: 'both')
    * 'both' - allows resizing by width or height
    * 'x' - only allows the width to be changed
    * 'y' - only allows the height to be changed
    * 'none' - disables resizing altogether
    * */
    axis: _propTypes.default.oneOf(["both", "x", "y", "none"]),
    className: _propTypes.default.string,
    /*
    * Require that one and only one child be present.
    * */
    children: _propTypes.default.element.isRequired,
    /*
    * These will be passed wholesale to react-draggable's DraggableCore
    * */
    draggableOpts: _propTypes.default.shape({
      allowAnyClick: _propTypes.default.bool,
      cancel: _propTypes.default.string,
      children: _propTypes.default.node,
      disabled: _propTypes.default.bool,
      enableUserSelectHack: _propTypes.default.bool,
      offsetParent: _propTypes.default.node,
      grid: _propTypes.default.arrayOf(_propTypes.default.number),
      handle: _propTypes.default.string,
      nodeRef: _propTypes.default.object,
      onStart: _propTypes.default.func,
      onDrag: _propTypes.default.func,
      onStop: _propTypes.default.func,
      onMouseDown: _propTypes.default.func,
      scale: _propTypes.default.number
    }),
    /*
    * Initial height
    * */
    height: /* @__PURE__ */ __name(function() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)
        args[_key] = arguments[_key];
      var props = args[0];
      if (props.axis === "both" || props.axis === "y") {
        var _PropTypes$number;
        return (_PropTypes$number = _propTypes.default.number).isRequired.apply(_PropTypes$number, args);
      }
      return _propTypes.default.number.apply(_propTypes.default, args);
    }, "height"),
    /*
    * Customize cursor resize handle
    * */
    handle: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
    /*
    * If you change this, be sure to update your css
    * */
    handleSize: _propTypes.default.arrayOf(_propTypes.default.number),
    lockAspectRatio: _propTypes.default.bool,
    /*
    * Max X & Y measure
    * */
    maxConstraints: _propTypes.default.arrayOf(_propTypes.default.number),
    /*
    * Min X & Y measure
    * */
    minConstraints: _propTypes.default.arrayOf(_propTypes.default.number),
    /*
    * Called on stop resize event
    * */
    onResizeStop: _propTypes.default.func,
    /*
    * Called on start resize event
    * */
    onResizeStart: _propTypes.default.func,
    /*
    * Called on resize event
    * */
    onResize: _propTypes.default.func,
    /*
    * Defines which resize handles should be rendered (default: 'se')
    * 's' - South handle (bottom-center)
    * 'w' - West handle (left-center)
    * 'e' - East handle (right-center)
    * 'n' - North handle (top-center)
    * 'sw' - Southwest handle (bottom-left)
    * 'nw' - Northwest handle (top-left)
    * 'se' - Southeast handle (bottom-right)
    * 'ne' - Northeast handle (top-center)
    * */
    resizeHandles: _propTypes.default.arrayOf(_propTypes.default.oneOf(["s", "w", "e", "n", "sw", "nw", "se", "ne"])),
    /*
    * If `transform: scale(n)` is set on the parent, this should be set to `n`.
    * */
    transformScale: _propTypes.default.number,
    /*
     * Initial width
     */
    width: /* @__PURE__ */ __name(function() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++)
        args[_key2] = arguments[_key2];
      var props = args[0];
      if (props.axis === "both" || props.axis === "x") {
        var _PropTypes$number2;
        return (_PropTypes$number2 = _propTypes.default.number).isRequired.apply(_PropTypes$number2, args);
      }
      return _propTypes.default.number.apply(_propTypes.default, args);
    }, "width")
  };
  return propTypes.resizableProps = resizableProps, propTypes;
}
__name(requirePropTypes, "requirePropTypes");
var hasRequiredResizable;
function requireResizable() {
  if (hasRequiredResizable) return Resizable;
  hasRequiredResizable = 1, Resizable.__esModule = !0, Resizable.default = void 0;
  var React = _interopRequireWildcard(require$$0), _reactDraggable = requireCjs(), _utils = requireUtils(), _propTypes = requirePropTypes(), _excluded = ["children", "className", "draggableOpts", "width", "height", "handle", "handleSize", "lockAspectRatio", "axis", "minConstraints", "maxConstraints", "onResize", "onResizeStop", "onResizeStart", "resizeHandles", "transformScale"];
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap != "function") return null;
    var cacheBabelInterop = /* @__PURE__ */ new WeakMap(), cacheNodeInterop = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(nodeInterop2) {
      return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
    }, "_getRequireWildcardCache"))(nodeInterop);
  }
  __name(_getRequireWildcardCache, "_getRequireWildcardCache");
  function _interopRequireWildcard(obj, nodeInterop) {
    if (obj && obj.__esModule)
      return obj;
    if (obj === null || typeof obj != "object" && typeof obj != "function")
      return { default: obj };
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj))
      return cache.get(obj);
    var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj)
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
      }
    return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
  }
  __name(_interopRequireWildcard, "_interopRequireWildcard");
  function _extends() {
    return _extends = Object.assign ? Object.assign.bind() : function(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source)
          Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
      }
      return target;
    }, _extends.apply(this, arguments);
  }
  __name(_extends, "_extends");
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys = Object.keys(source), key, i;
    for (i = 0; i < sourceKeys.length; i++)
      key = sourceKeys[i], !(excluded.indexOf(key) >= 0) && (target[key] = source[key]);
    return target;
  }
  __name(_objectWithoutPropertiesLoose, "_objectWithoutPropertiesLoose");
  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }
    return keys;
  }
  __name(ownKeys, "ownKeys");
  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
    return target;
  }
  __name(_objectSpread, "_objectSpread");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, _setPrototypeOf(subClass, superClass);
  }
  __name(_inheritsLoose, "_inheritsLoose");
  function _setPrototypeOf(o, p) {
    return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : /* @__PURE__ */ __name(function(o2, p2) {
      return o2.__proto__ = p2, o2;
    }, "_setPrototypeOf"), _setPrototypeOf(o, p);
  }
  __name(_setPrototypeOf, "_setPrototypeOf");
  var Resizable$1 = /* @__PURE__ */ function(_React$Component) {
    _inheritsLoose(Resizable2, _React$Component);
    function Resizable2() {
      for (var _this, _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)
        args[_key] = arguments[_key];
      return _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.handleRefs = {}, _this.lastHandleRect = null, _this.slack = null, _this;
    }
    __name(Resizable2, "Resizable");
    var _proto = Resizable2.prototype;
    return _proto.componentWillUnmount = /* @__PURE__ */ __name(function() {
      this.resetData();
    }, "componentWillUnmount"), _proto.resetData = /* @__PURE__ */ __name(function() {
      this.lastHandleRect = this.slack = null;
    }, "resetData"), _proto.runConstraints = /* @__PURE__ */ __name(function(width, height) {
      var _this$props = this.props, minConstraints = _this$props.minConstraints, maxConstraints = _this$props.maxConstraints, lockAspectRatio = _this$props.lockAspectRatio;
      if (!minConstraints && !maxConstraints && !lockAspectRatio) return [width, height];
      if (lockAspectRatio) {
        var ratio = this.props.width / this.props.height, deltaW = width - this.props.width, deltaH = height - this.props.height;
        Math.abs(deltaW) > Math.abs(deltaH * ratio) ? height = width / ratio : width = height * ratio;
      }
      var oldW = width, oldH = height, _ref = this.slack || [0, 0], slackW = _ref[0], slackH = _ref[1];
      return width += slackW, height += slackH, minConstraints && (width = Math.max(minConstraints[0], width), height = Math.max(minConstraints[1], height)), maxConstraints && (width = Math.min(maxConstraints[0], width), height = Math.min(maxConstraints[1], height)), this.slack = [slackW + (oldW - width), slackH + (oldH - height)], [width, height];
    }, "runConstraints"), _proto.resizeHandler = /* @__PURE__ */ __name(function(handlerName, axis) {
      var _this2 = this;
      return function(e, _ref2) {
        var node = _ref2.node, deltaX = _ref2.deltaX, deltaY = _ref2.deltaY;
        handlerName === "onResizeStart" && _this2.resetData();
        var canDragX = (_this2.props.axis === "both" || _this2.props.axis === "x") && axis !== "n" && axis !== "s", canDragY = (_this2.props.axis === "both" || _this2.props.axis === "y") && axis !== "e" && axis !== "w";
        if (!(!canDragX && !canDragY)) {
          var axisV = axis[0], axisH = axis[axis.length - 1], handleRect = node.getBoundingClientRect();
          if (_this2.lastHandleRect != null) {
            if (axisH === "w") {
              var deltaLeftSinceLast = handleRect.left - _this2.lastHandleRect.left;
              deltaX += deltaLeftSinceLast;
            }
            if (axisV === "n") {
              var deltaTopSinceLast = handleRect.top - _this2.lastHandleRect.top;
              deltaY += deltaTopSinceLast;
            }
          }
          _this2.lastHandleRect = handleRect, axisH === "w" && (deltaX = -deltaX), axisV === "n" && (deltaY = -deltaY);
          var width = _this2.props.width + (canDragX ? deltaX / _this2.props.transformScale : 0), height = _this2.props.height + (canDragY ? deltaY / _this2.props.transformScale : 0), _this2$runConstraints = _this2.runConstraints(width, height);
          width = _this2$runConstraints[0], height = _this2$runConstraints[1];
          var dimensionsChanged = width !== _this2.props.width || height !== _this2.props.height, cb = typeof _this2.props[handlerName] == "function" ? _this2.props[handlerName] : null, shouldSkipCb = handlerName === "onResize" && !dimensionsChanged;
          cb && !shouldSkipCb && (e.persist == null || e.persist(), cb(e, {
            node,
            size: {
              width,
              height
            },
            handle: axis
          })), handlerName === "onResizeStop" && _this2.resetData();
        }
      };
    }, "resizeHandler"), _proto.renderResizeHandle = /* @__PURE__ */ __name(function(handleAxis, ref) {
      var handle = this.props.handle;
      if (!handle)
        return /* @__PURE__ */ React.createElement("span", {
          className: "react-resizable-handle react-resizable-handle-" + handleAxis,
          ref
        });
      if (typeof handle == "function")
        return handle(handleAxis, ref);
      var isDOMElement = typeof handle.type == "string", props = _objectSpread({
        ref
      }, isDOMElement ? {} : {
        handleAxis
      });
      return /* @__PURE__ */ React.cloneElement(handle, props);
    }, "renderResizeHandle"), _proto.render = /* @__PURE__ */ __name(function() {
      var _this3 = this, _this$props2 = this.props, children = _this$props2.children, className = _this$props2.className, draggableOpts = _this$props2.draggableOpts;
      _this$props2.width, _this$props2.height, _this$props2.handle, _this$props2.handleSize, _this$props2.lockAspectRatio, _this$props2.axis, _this$props2.minConstraints, _this$props2.maxConstraints, _this$props2.onResize, _this$props2.onResizeStop, _this$props2.onResizeStart;
      var resizeHandles = _this$props2.resizeHandles;
      _this$props2.transformScale;
      var p = _objectWithoutPropertiesLoose(_this$props2, _excluded);
      return (0, _utils.cloneElement)(children, _objectSpread(_objectSpread({}, p), {}, {
        className: (className ? className + " " : "") + "react-resizable",
        children: [].concat(children.props.children, resizeHandles.map(function(handleAxis) {
          var _this3$handleRefs$han, ref = (_this3$handleRefs$han = _this3.handleRefs[handleAxis]) != null ? _this3$handleRefs$han : _this3.handleRefs[handleAxis] = /* @__PURE__ */ React.createRef();
          return /* @__PURE__ */ React.createElement(_reactDraggable.DraggableCore, _extends({}, draggableOpts, {
            nodeRef: ref,
            key: "resizableHandle-" + handleAxis,
            onStop: _this3.resizeHandler("onResizeStop", handleAxis),
            onStart: _this3.resizeHandler("onResizeStart", handleAxis),
            onDrag: _this3.resizeHandler("onResize", handleAxis)
          }), _this3.renderResizeHandle(handleAxis, ref));
        }))
      }));
    }, "render"), Resizable2;
  }(React.Component);
  return Resizable.default = Resizable$1, Resizable$1.propTypes = _propTypes.resizableProps, Resizable$1.defaultProps = {
    axis: "both",
    handleSize: [20, 20],
    lockAspectRatio: !1,
    minConstraints: [20, 20],
    maxConstraints: [1 / 0, 1 / 0],
    resizeHandles: ["se"],
    transformScale: 1
  }, Resizable;
}
__name(requireResizable, "requireResizable");
var ResizableBox = {}, hasRequiredResizableBox;
function requireResizableBox() {
  if (hasRequiredResizableBox) return ResizableBox;
  hasRequiredResizableBox = 1, ResizableBox.__esModule = !0, ResizableBox.default = void 0;
  var React = _interopRequireWildcard(require$$0), _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1()), _Resizable = _interopRequireDefault(requireResizable()), _propTypes2 = requirePropTypes(), _excluded = ["handle", "handleSize", "onResize", "onResizeStart", "onResizeStop", "draggableOpts", "minConstraints", "maxConstraints", "lockAspectRatio", "axis", "width", "height", "resizeHandles", "style", "transformScale"];
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap != "function") return null;
    var cacheBabelInterop = /* @__PURE__ */ new WeakMap(), cacheNodeInterop = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(nodeInterop2) {
      return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
    }, "_getRequireWildcardCache"))(nodeInterop);
  }
  __name(_getRequireWildcardCache, "_getRequireWildcardCache");
  function _interopRequireWildcard(obj, nodeInterop) {
    if (obj && obj.__esModule)
      return obj;
    if (obj === null || typeof obj != "object" && typeof obj != "function")
      return { default: obj };
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj))
      return cache.get(obj);
    var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj)
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
      }
    return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
  }
  __name(_interopRequireWildcard, "_interopRequireWildcard");
  function _extends() {
    return _extends = Object.assign ? Object.assign.bind() : function(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source)
          Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
      }
      return target;
    }, _extends.apply(this, arguments);
  }
  __name(_extends, "_extends");
  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }
    return keys;
  }
  __name(ownKeys, "ownKeys");
  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
    return target;
  }
  __name(_objectSpread, "_objectSpread");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys = Object.keys(source), key, i;
    for (i = 0; i < sourceKeys.length; i++)
      key = sourceKeys[i], !(excluded.indexOf(key) >= 0) && (target[key] = source[key]);
    return target;
  }
  __name(_objectWithoutPropertiesLoose, "_objectWithoutPropertiesLoose");
  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, _setPrototypeOf(subClass, superClass);
  }
  __name(_inheritsLoose, "_inheritsLoose");
  function _setPrototypeOf(o, p) {
    return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : /* @__PURE__ */ __name(function(o2, p2) {
      return o2.__proto__ = p2, o2;
    }, "_setPrototypeOf"), _setPrototypeOf(o, p);
  }
  __name(_setPrototypeOf, "_setPrototypeOf");
  var ResizableBox$1 = /* @__PURE__ */ function(_React$Component) {
    _inheritsLoose(ResizableBox2, _React$Component);
    function ResizableBox2() {
      for (var _this, _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)
        args[_key] = arguments[_key];
      return _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
        width: _this.props.width,
        height: _this.props.height,
        propsWidth: _this.props.width,
        propsHeight: _this.props.height
      }, _this.onResize = function(e, data) {
        var size = data.size;
        _this.props.onResize ? (e.persist == null || e.persist(), _this.setState(size, function() {
          return _this.props.onResize && _this.props.onResize(e, data);
        })) : _this.setState(size);
      }, _this;
    }
    __name(ResizableBox2, "ResizableBox"), ResizableBox2.getDerivedStateFromProps = /* @__PURE__ */ __name(function(props, state) {
      return state.propsWidth !== props.width || state.propsHeight !== props.height ? {
        width: props.width,
        height: props.height,
        propsWidth: props.width,
        propsHeight: props.height
      } : null;
    }, "getDerivedStateFromProps");
    var _proto = ResizableBox2.prototype;
    return _proto.render = /* @__PURE__ */ __name(function() {
      var _this$props = this.props, handle = _this$props.handle, handleSize = _this$props.handleSize;
      _this$props.onResize;
      var onResizeStart = _this$props.onResizeStart, onResizeStop = _this$props.onResizeStop, draggableOpts = _this$props.draggableOpts, minConstraints = _this$props.minConstraints, maxConstraints = _this$props.maxConstraints, lockAspectRatio = _this$props.lockAspectRatio, axis = _this$props.axis;
      _this$props.width, _this$props.height;
      var resizeHandles = _this$props.resizeHandles, style = _this$props.style, transformScale = _this$props.transformScale, props = _objectWithoutPropertiesLoose(_this$props, _excluded);
      return /* @__PURE__ */ React.createElement(_Resizable.default, {
        axis,
        draggableOpts,
        handle,
        handleSize,
        height: this.state.height,
        lockAspectRatio,
        maxConstraints,
        minConstraints,
        onResizeStart,
        onResize: this.onResize,
        onResizeStop,
        resizeHandles,
        transformScale,
        width: this.state.width
      }, /* @__PURE__ */ React.createElement("div", _extends({}, props, {
        style: _objectSpread(_objectSpread({}, style), {}, {
          width: this.state.width + "px",
          height: this.state.height + "px"
        })
      })));
    }, "render"), ResizableBox2;
  }(React.Component);
  return ResizableBox.default = ResizableBox$1, ResizableBox$1.propTypes = _objectSpread(_objectSpread({}, _propTypes2.resizableProps), {}, {
    children: _propTypes.default.element
  }), ResizableBox;
}
__name(requireResizableBox, "requireResizableBox");
var hasRequiredReactResizable;
function requireReactResizable() {
  return hasRequiredReactResizable || (hasRequiredReactResizable = 1, reactResizable.exports = function() {
    throw new Error("Don't instantiate Resizable directly! Use require('react-resizable').Resizable");
  }, reactResizable.exports.Resizable = requireResizable().default, reactResizable.exports.ResizableBox = requireResizableBox().default), reactResizable.exports;
}
__name(requireReactResizable, "requireReactResizable");
var ReactGridLayoutPropTypes = {}, hasRequiredReactGridLayoutPropTypes;
function requireReactGridLayoutPropTypes() {
  if (hasRequiredReactGridLayoutPropTypes) return ReactGridLayoutPropTypes;
  hasRequiredReactGridLayoutPropTypes = 1, Object.defineProperty(ReactGridLayoutPropTypes, "__esModule", {
    value: !0
  }), ReactGridLayoutPropTypes.resizeHandleType = ReactGridLayoutPropTypes.resizeHandleAxesType = ReactGridLayoutPropTypes.default = void 0;
  var _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1()), _react = _interopRequireDefault(require$$0);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  const resizeHandleAxesType = ReactGridLayoutPropTypes.resizeHandleAxesType = _propTypes.default.arrayOf(_propTypes.default.oneOf(["s", "w", "e", "n", "sw", "nw", "se", "ne"])), resizeHandleType = ReactGridLayoutPropTypes.resizeHandleType = _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]);
  return ReactGridLayoutPropTypes.default = {
    //
    // Basic props
    //
    className: _propTypes.default.string,
    style: _propTypes.default.object,
    // This can be set explicitly. If it is not set, it will automatically
    // be set to the container width. Note that resizes will *not* cause this to adjust.
    // If you need that behavior, use WidthProvider.
    width: _propTypes.default.number,
    // If true, the container height swells and contracts to fit contents
    autoSize: _propTypes.default.bool,
    // # of cols.
    cols: _propTypes.default.number,
    // A selector that will not be draggable.
    draggableCancel: _propTypes.default.string,
    // A selector for the draggable handler
    draggableHandle: _propTypes.default.string,
    // Deprecated
    verticalCompact: /* @__PURE__ */ __name(function(props) {
      props.verticalCompact;
    }, "verticalCompact"),
    // Choose vertical or hotizontal compaction
    compactType: _propTypes.default.oneOf(["vertical", "horizontal"]),
    // layout is an array of object with the format:
    // {x: Number, y: Number, w: Number, h: Number, i: String}
    layout: /* @__PURE__ */ __name(function(props) {
      var layout = props.layout;
      layout !== void 0 && requireUtils$1().validateLayout(layout, "layout");
    }, "layout"),
    //
    // Grid Dimensions
    //
    // Margin between items [x, y] in px
    margin: _propTypes.default.arrayOf(_propTypes.default.number),
    // Padding inside the container [x, y] in px
    containerPadding: _propTypes.default.arrayOf(_propTypes.default.number),
    // Rows have a static height, but you can change this based on breakpoints if you like
    rowHeight: _propTypes.default.number,
    // Default Infinity, but you can specify a max here if you like.
    // Note that this isn't fully fleshed out and won't error if you specify a layout that
    // extends beyond the row capacity. It will, however, not allow users to drag/resize
    // an item past the barrier. They can push items beyond the barrier, though.
    // Intentionally not documented for this reason.
    maxRows: _propTypes.default.number,
    //
    // Flags
    //
    isBounded: _propTypes.default.bool,
    isDraggable: _propTypes.default.bool,
    isResizable: _propTypes.default.bool,
    // If true, grid can be placed one over the other.
    allowOverlap: _propTypes.default.bool,
    // If true, grid items won't change position when being dragged over.
    preventCollision: _propTypes.default.bool,
    // Use CSS transforms instead of top/left
    useCSSTransforms: _propTypes.default.bool,
    // parent layout transform scale
    transformScale: _propTypes.default.number,
    // If true, an external element can trigger onDrop callback with a specific grid position as a parameter
    isDroppable: _propTypes.default.bool,
    // Resize handle options
    resizeHandles: resizeHandleAxesType,
    resizeHandle: resizeHandleType,
    //
    // Callbacks
    //
    // Callback so you can save the layout. Calls after each drag & resize stops.
    onLayoutChange: _propTypes.default.func,
    // Calls when drag starts. Callback is of the signature (layout, oldItem, newItem, placeholder, e, ?node).
    // All callbacks below have the same signature. 'start' and 'stop' callbacks omit the 'placeholder'.
    onDragStart: _propTypes.default.func,
    // Calls on each drag movement.
    onDrag: _propTypes.default.func,
    // Calls when drag is complete.
    onDragStop: _propTypes.default.func,
    //Calls when resize starts.
    onResizeStart: _propTypes.default.func,
    // Calls when resize movement happens.
    onResize: _propTypes.default.func,
    // Calls when resize is complete.
    onResizeStop: _propTypes.default.func,
    // Calls when some element is dropped.
    onDrop: _propTypes.default.func,
    //
    // Other validations
    //
    droppingItem: _propTypes.default.shape({
      i: _propTypes.default.string.isRequired,
      w: _propTypes.default.number.isRequired,
      h: _propTypes.default.number.isRequired
    }),
    // Children must not have duplicate keys.
    children: /* @__PURE__ */ __name(function(props, propName) {
      const children = props[propName], keys = {};
      _react.default.Children.forEach(children, function(child) {
        if ((child == null ? void 0 : child.key) != null) {
          if (keys[child.key])
            throw new Error('Duplicate child key "' + child.key + '" found! This will cause problems in ReactGridLayout.');
          keys[child.key] = !0;
        }
      });
    }, "children"),
    // Optional ref for getting a reference for the wrapping div.
    innerRef: _propTypes.default.any
  }, ReactGridLayoutPropTypes;
}
__name(requireReactGridLayoutPropTypes, "requireReactGridLayoutPropTypes");
var hasRequiredGridItem;
function requireGridItem() {
  var _a15;
  if (hasRequiredGridItem) return GridItem;
  hasRequiredGridItem = 1, Object.defineProperty(GridItem, "__esModule", {
    value: !0
  }), GridItem.default = void 0;
  var _react = _interopRequireDefault(require$$0), _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1()), _reactDraggable = requireCjs(), _reactResizable = requireReactResizable(), _utils = requireUtils$1(), _calculateUtils = requireCalculateUtils(), _ReactGridLayoutPropTypes = requireReactGridLayoutPropTypes(), _clsx = _interopRequireDefault(requireClsx());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  let GridItem$1 = (_a15 = class extends _react.default.Component {
    constructor() {
      super(...arguments), _defineProperty(this, "state", {
        resizing: null,
        dragging: null,
        className: ""
      }), _defineProperty(this, "elementRef", /* @__PURE__ */ _react.default.createRef()), _defineProperty(this, "onDragStart", (e, _ref) => {
        let {
          node
        } = _ref;
        const {
          onDragStart,
          transformScale
        } = this.props;
        if (!onDragStart) return;
        const newPosition = {
          top: 0,
          left: 0
        }, {
          offsetParent
        } = node;
        if (!offsetParent) return;
        const parentRect = offsetParent.getBoundingClientRect(), clientRect = node.getBoundingClientRect(), cLeft = clientRect.left / transformScale, pLeft = parentRect.left / transformScale, cTop = clientRect.top / transformScale, pTop = parentRect.top / transformScale;
        newPosition.left = cLeft - pLeft + offsetParent.scrollLeft, newPosition.top = cTop - pTop + offsetParent.scrollTop, this.setState({
          dragging: newPosition
        });
        const {
          x,
          y
        } = (0, _calculateUtils.calcXY)(this.getPositionParams(), newPosition.top, newPosition.left, this.props.w, this.props.h);
        return onDragStart.call(this, this.props.i, x, y, {
          e,
          node,
          newPosition
        });
      }), _defineProperty(this, "onDrag", (e, _ref2) => {
        let {
          node,
          deltaX,
          deltaY
        } = _ref2;
        const {
          onDrag
        } = this.props;
        if (!onDrag) return;
        if (!this.state.dragging)
          throw new Error("onDrag called before onDragStart.");
        let top = this.state.dragging.top + deltaY, left = this.state.dragging.left + deltaX;
        const {
          isBounded,
          i,
          w,
          h,
          containerWidth
        } = this.props, positionParams = this.getPositionParams();
        if (isBounded) {
          const {
            offsetParent
          } = node;
          if (offsetParent) {
            const {
              margin,
              rowHeight,
              containerPadding
            } = this.props, bottomBoundary = offsetParent.clientHeight - (0, _calculateUtils.calcGridItemWHPx)(h, rowHeight, margin[1]);
            top = (0, _calculateUtils.clamp)(top - containerPadding[1], 0, bottomBoundary);
            const colWidth = (0, _calculateUtils.calcGridColWidth)(positionParams), rightBoundary = containerWidth - (0, _calculateUtils.calcGridItemWHPx)(w, colWidth, margin[0]);
            left = (0, _calculateUtils.clamp)(left - containerPadding[0], 0, rightBoundary);
          }
        }
        const newPosition = {
          top,
          left
        };
        this.setState({
          dragging: newPosition
        });
        const {
          x,
          y
        } = (0, _calculateUtils.calcXY)(positionParams, top, left, w, h);
        return onDrag.call(this, i, x, y, {
          e,
          node,
          newPosition
        });
      }), _defineProperty(this, "onDragStop", (e, _ref3) => {
        let {
          node
        } = _ref3;
        const {
          onDragStop
        } = this.props;
        if (!onDragStop) return;
        if (!this.state.dragging)
          throw new Error("onDragEnd called before onDragStart.");
        const {
          w,
          h,
          i
        } = this.props, {
          left,
          top
        } = this.state.dragging, newPosition = {
          top,
          left
        };
        this.setState({
          dragging: null
        });
        const {
          x,
          y
        } = (0, _calculateUtils.calcXY)(this.getPositionParams(), top, left, w, h);
        return onDragStop.call(this, i, x, y, {
          e,
          node,
          newPosition
        });
      }), _defineProperty(this, "onResizeStop", (e, callbackData, position) => this.onResizeHandler(e, callbackData, position, "onResizeStop")), _defineProperty(this, "onResizeStart", (e, callbackData, position) => this.onResizeHandler(e, callbackData, position, "onResizeStart")), _defineProperty(this, "onResize", (e, callbackData, position) => this.onResizeHandler(e, callbackData, position, "onResize"));
    }
    shouldComponentUpdate(nextProps, nextState) {
      if (this.props.children !== nextProps.children || this.props.droppingPosition !== nextProps.droppingPosition) return !0;
      const oldPosition = (0, _calculateUtils.calcGridItemPosition)(this.getPositionParams(this.props), this.props.x, this.props.y, this.props.w, this.props.h, this.state), newPosition = (0, _calculateUtils.calcGridItemPosition)(this.getPositionParams(nextProps), nextProps.x, nextProps.y, nextProps.w, nextProps.h, nextState);
      return !(0, _utils.fastPositionEqual)(oldPosition, newPosition) || this.props.useCSSTransforms !== nextProps.useCSSTransforms;
    }
    componentDidMount() {
      this.moveDroppingItem({});
    }
    componentDidUpdate(prevProps) {
      this.moveDroppingItem(prevProps);
    }
    // When a droppingPosition is present, this means we should fire a move event, as if we had moved
    // this element by `x, y` pixels.
    moveDroppingItem(prevProps) {
      const {
        droppingPosition
      } = this.props;
      if (!droppingPosition) return;
      const node = this.elementRef.current;
      if (!node) return;
      const prevDroppingPosition = prevProps.droppingPosition || {
        left: 0,
        top: 0
      }, {
        dragging
      } = this.state, shouldDrag = dragging && droppingPosition.left !== prevDroppingPosition.left || droppingPosition.top !== prevDroppingPosition.top;
      if (!dragging)
        this.onDragStart(droppingPosition.e, {
          node,
          deltaX: droppingPosition.left,
          deltaY: droppingPosition.top
        });
      else if (shouldDrag) {
        const deltaX = droppingPosition.left - dragging.left, deltaY = droppingPosition.top - dragging.top;
        this.onDrag(droppingPosition.e, {
          node,
          deltaX,
          deltaY
        });
      }
    }
    getPositionParams() {
      let props = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.props;
      return {
        cols: props.cols,
        containerPadding: props.containerPadding,
        containerWidth: props.containerWidth,
        margin: props.margin,
        maxRows: props.maxRows,
        rowHeight: props.rowHeight
      };
    }
    /**
     * This is where we set the grid item's absolute placement. It gets a little tricky because we want to do it
     * well when server rendering, and the only way to do that properly is to use percentage width/left because
     * we don't know exactly what the browser viewport is.
     * Unfortunately, CSS Transforms, which are great for performance, break in this instance because a percentage
     * left is relative to the item itself, not its container! So we cannot use them on the server rendering pass.
     *
     * @param  {Object} pos Position object with width, height, left, top.
     * @return {Object}     Style object.
     */
    createStyle(pos) {
      const {
        usePercentages,
        containerWidth,
        useCSSTransforms
      } = this.props;
      let style;
      return useCSSTransforms ? style = (0, _utils.setTransform)(pos) : (style = (0, _utils.setTopLeft)(pos), usePercentages && (style.left = (0, _utils.perc)(pos.left / containerWidth), style.width = (0, _utils.perc)(pos.width / containerWidth))), style;
    }
    /**
     * Mix a Draggable instance into a child.
     * @param  {Element} child    Child element.
     * @return {Element}          Child wrapped in Draggable.
     */
    mixinDraggable(child, isDraggable) {
      return /* @__PURE__ */ _react.default.createElement(_reactDraggable.DraggableCore, {
        disabled: !isDraggable,
        onStart: this.onDragStart,
        onDrag: this.onDrag,
        onStop: this.onDragStop,
        handle: this.props.handle,
        cancel: ".react-resizable-handle" + (this.props.cancel ? "," + this.props.cancel : ""),
        scale: this.props.transformScale,
        nodeRef: this.elementRef
      }, child);
    }
    /**
     * Utility function to setup callback handler definitions for
     * similarily structured resize events.
     */
    curryResizeHandler(position, handler) {
      return (e, data) => (
        /*: Function*/
        handler(e, data, position)
      );
    }
    /**
     * Mix a Resizable instance into a child.
     * @param  {Element} child    Child element.
     * @param  {Object} position  Position object (pixel values)
     * @return {Element}          Child wrapped in Resizable.
     */
    mixinResizable(child, position, isResizable) {
      const {
        cols,
        minW,
        minH,
        maxW,
        maxH,
        transformScale,
        resizeHandles,
        resizeHandle
      } = this.props, positionParams = this.getPositionParams(), maxWidth = (0, _calculateUtils.calcGridItemPosition)(positionParams, 0, 0, cols, 0).width, mins = (0, _calculateUtils.calcGridItemPosition)(positionParams, 0, 0, minW, minH), maxes = (0, _calculateUtils.calcGridItemPosition)(positionParams, 0, 0, maxW, maxH), minConstraints = [mins.width, mins.height], maxConstraints = [Math.min(maxes.width, maxWidth), Math.min(maxes.height, 1 / 0)];
      return /* @__PURE__ */ _react.default.createElement(
        _reactResizable.Resizable,
        {
          draggableOpts: {
            disabled: !isResizable
          },
          className: isResizable ? void 0 : "react-resizable-hide",
          width: position.width,
          height: position.height,
          minConstraints,
          maxConstraints,
          onResizeStop: this.curryResizeHandler(position, this.onResizeStop),
          onResizeStart: this.curryResizeHandler(position, this.onResizeStart),
          onResize: this.curryResizeHandler(position, this.onResize),
          transformScale,
          resizeHandles,
          handle: resizeHandle
        },
        child
      );
    }
    /**
     * Wrapper around resize events to provide more useful data.
     */
    onResizeHandler(e, _ref4, position, handlerName) {
      let {
        node,
        size,
        handle
      } = _ref4;
      const handler = this.props[handlerName];
      if (!handler) return;
      const {
        x,
        y,
        i,
        maxH,
        minH,
        containerWidth
      } = this.props, {
        minW,
        maxW
      } = this.props;
      let updatedSize = size;
      node && (updatedSize = (0, _utils.resizeItemInDirection)(handle, position, size, containerWidth), this.setState({
        resizing: handlerName === "onResizeStop" ? null : updatedSize
      }));
      let {
        w,
        h
      } = (0, _calculateUtils.calcWH)(this.getPositionParams(), updatedSize.width, updatedSize.height, x, y, handle);
      w = (0, _calculateUtils.clamp)(w, Math.max(minW, 1), maxW), h = (0, _calculateUtils.clamp)(h, minH, maxH), handler.call(this, i, w, h, {
        e,
        node,
        size: updatedSize,
        handle
      });
    }
    render() {
      const {
        x,
        y,
        w,
        h,
        isDraggable,
        isResizable,
        droppingPosition,
        useCSSTransforms
      } = this.props, pos = (0, _calculateUtils.calcGridItemPosition)(this.getPositionParams(), x, y, w, h, this.state), child = _react.default.Children.only(this.props.children);
      let newChild = /* @__PURE__ */ _react.default.cloneElement(child, {
        ref: this.elementRef,
        className: (0, _clsx.default)("react-grid-item", child.props.className, this.props.className, {
          static: this.props.static,
          resizing: !!this.state.resizing,
          "react-draggable": isDraggable,
          "react-draggable-dragging": !!this.state.dragging,
          dropping: !!droppingPosition,
          cssTransforms: useCSSTransforms
        }),
        // We can set the width and height on the child, but unfortunately we can't set the position.
        style: {
          ...this.props.style,
          ...child.props.style,
          ...this.createStyle(pos)
        }
      });
      return newChild = this.mixinResizable(newChild, pos, isResizable), newChild = this.mixinDraggable(newChild, isDraggable), newChild;
    }
  }, __name(_a15, "GridItem"), _a15);
  return GridItem.default = GridItem$1, _defineProperty(GridItem$1, "propTypes", {
    // Children must be only a single element
    children: _propTypes.default.element,
    // General grid attributes
    cols: _propTypes.default.number.isRequired,
    containerWidth: _propTypes.default.number.isRequired,
    rowHeight: _propTypes.default.number.isRequired,
    margin: _propTypes.default.array.isRequired,
    maxRows: _propTypes.default.number.isRequired,
    containerPadding: _propTypes.default.array.isRequired,
    // These are all in grid units
    x: _propTypes.default.number.isRequired,
    y: _propTypes.default.number.isRequired,
    w: _propTypes.default.number.isRequired,
    h: _propTypes.default.number.isRequired,
    // All optional
    minW: /* @__PURE__ */ __name(function(props, propName) {
      const value = props[propName];
      if (typeof value != "number") return new Error("minWidth not Number");
      if (value > props.w || value > props.maxW) return new Error("minWidth larger than item width/maxWidth");
    }, "minW"),
    maxW: /* @__PURE__ */ __name(function(props, propName) {
      const value = props[propName];
      if (typeof value != "number") return new Error("maxWidth not Number");
      if (value < props.w || value < props.minW) return new Error("maxWidth smaller than item width/minWidth");
    }, "maxW"),
    minH: /* @__PURE__ */ __name(function(props, propName) {
      const value = props[propName];
      if (typeof value != "number") return new Error("minHeight not Number");
      if (value > props.h || value > props.maxH) return new Error("minHeight larger than item height/maxHeight");
    }, "minH"),
    maxH: /* @__PURE__ */ __name(function(props, propName) {
      const value = props[propName];
      if (typeof value != "number") return new Error("maxHeight not Number");
      if (value < props.h || value < props.minH) return new Error("maxHeight smaller than item height/minHeight");
    }, "maxH"),
    // ID is nice to have for callbacks
    i: _propTypes.default.string.isRequired,
    // Resize handle options
    resizeHandles: _ReactGridLayoutPropTypes.resizeHandleAxesType,
    resizeHandle: _ReactGridLayoutPropTypes.resizeHandleType,
    // Functions
    onDragStop: _propTypes.default.func,
    onDragStart: _propTypes.default.func,
    onDrag: _propTypes.default.func,
    onResizeStop: _propTypes.default.func,
    onResizeStart: _propTypes.default.func,
    onResize: _propTypes.default.func,
    // Flags
    isDraggable: _propTypes.default.bool.isRequired,
    isResizable: _propTypes.default.bool.isRequired,
    isBounded: _propTypes.default.bool.isRequired,
    static: _propTypes.default.bool,
    // Use CSS transforms instead of top/left
    useCSSTransforms: _propTypes.default.bool.isRequired,
    transformScale: _propTypes.default.number,
    // Others
    className: _propTypes.default.string,
    // Selector for draggable handle
    handle: _propTypes.default.string,
    // Selector for draggable cancel (see react-draggable)
    cancel: _propTypes.default.string,
    // Current position of a dropping element
    droppingPosition: _propTypes.default.shape({
      e: _propTypes.default.object.isRequired,
      left: _propTypes.default.number.isRequired,
      top: _propTypes.default.number.isRequired
    })
  }), _defineProperty(GridItem$1, "defaultProps", {
    className: "",
    cancel: "",
    handle: "",
    minH: 1,
    minW: 1,
    maxH: 1 / 0,
    maxW: 1 / 0,
    transformScale: 1
  }), GridItem;
}
__name(requireGridItem, "requireGridItem");
var hasRequiredReactGridLayout$1;
function requireReactGridLayout$1() {
  var _a15;
  if (hasRequiredReactGridLayout$1) return ReactGridLayout;
  hasRequiredReactGridLayout$1 = 1, Object.defineProperty(ReactGridLayout, "__esModule", {
    value: !0
  }), ReactGridLayout.default = void 0;
  var React = _interopRequireWildcard(require$$0), _fastEquals = /* @__PURE__ */ requireFastEquals(), _clsx = _interopRequireDefault(requireClsx()), _utils = requireUtils$1(), _calculateUtils = requireCalculateUtils(), _GridItem = _interopRequireDefault(requireGridItem()), _ReactGridLayoutPropTypes = _interopRequireDefault(requireReactGridLayoutPropTypes());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function _getRequireWildcardCache(e) {
    if (typeof WeakMap != "function") return null;
    var r2 = /* @__PURE__ */ new WeakMap(), t = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(e2) {
      return e2 ? t : r2;
    }, "_getRequireWildcardCache"))(e);
  }
  __name(_getRequireWildcardCache, "_getRequireWildcardCache");
  function _interopRequireWildcard(e, r2) {
    if (e && e.__esModule) return e;
    if (e === null || typeof e != "object" && typeof e != "function") return { default: e };
    var t = _getRequireWildcardCache(r2);
    if (t && t.has(e)) return t.get(e);
    var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e) if (u !== "default" && Object.prototype.hasOwnProperty.call(e, u)) {
      var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
      i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
    }
    return n.default = e, t && t.set(e, n), n;
  }
  __name(_interopRequireWildcard, "_interopRequireWildcard");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  const layoutClassName = "react-grid-layout";
  let isFirefox = !1;
  try {
    isFirefox = /firefox/i.test(navigator.userAgent);
  } catch {
  }
  let ReactGridLayout$1 = (_a15 = class extends React.Component {
    constructor() {
      super(...arguments), _defineProperty(this, "state", {
        activeDrag: null,
        layout: (0, _utils.synchronizeLayoutWithChildren)(
          this.props.layout,
          this.props.children,
          this.props.cols,
          // Legacy support for verticalCompact: false
          (0, _utils.compactType)(this.props),
          this.props.allowOverlap
        ),
        mounted: !1,
        oldDragItem: null,
        oldLayout: null,
        oldResizeItem: null,
        resizing: !1,
        droppingDOMNode: null,
        children: []
      }), _defineProperty(this, "dragEnterCounter", 0), _defineProperty(this, "onDragStart", (i, x, y, _ref) => {
        let {
          e,
          node
        } = _ref;
        const {
          layout
        } = this.state, l = (0, _utils.getLayoutItem)(layout, i);
        if (!l) return;
        const placeholder = {
          w: l.w,
          h: l.h,
          x: l.x,
          y: l.y,
          placeholder: !0,
          i
        };
        return this.setState({
          oldDragItem: (0, _utils.cloneLayoutItem)(l),
          oldLayout: layout,
          activeDrag: placeholder
        }), this.props.onDragStart(layout, l, l, null, e, node);
      }), _defineProperty(this, "onDrag", (i, x, y, _ref2) => {
        let {
          e,
          node
        } = _ref2;
        const {
          oldDragItem
        } = this.state;
        let {
          layout
        } = this.state;
        const {
          cols,
          allowOverlap,
          preventCollision
        } = this.props, l = (0, _utils.getLayoutItem)(layout, i);
        if (!l) return;
        const placeholder = {
          w: l.w,
          h: l.h,
          x: l.x,
          y: l.y,
          placeholder: !0,
          i
        };
        layout = (0, _utils.moveElement)(layout, l, x, y, !0, preventCollision, (0, _utils.compactType)(this.props), cols, allowOverlap), this.props.onDrag(layout, oldDragItem, l, placeholder, e, node), this.setState({
          layout: allowOverlap ? layout : (0, _utils.compact)(layout, (0, _utils.compactType)(this.props), cols),
          activeDrag: placeholder
        });
      }), _defineProperty(this, "onDragStop", (i, x, y, _ref3) => {
        let {
          e,
          node
        } = _ref3;
        if (!this.state.activeDrag) return;
        const {
          oldDragItem
        } = this.state;
        let {
          layout
        } = this.state;
        const {
          cols,
          preventCollision,
          allowOverlap
        } = this.props, l = (0, _utils.getLayoutItem)(layout, i);
        if (!l) return;
        layout = (0, _utils.moveElement)(layout, l, x, y, !0, preventCollision, (0, _utils.compactType)(this.props), cols, allowOverlap);
        const newLayout = allowOverlap ? layout : (0, _utils.compact)(layout, (0, _utils.compactType)(this.props), cols);
        this.props.onDragStop(newLayout, oldDragItem, l, null, e, node);
        const {
          oldLayout
        } = this.state;
        this.setState({
          activeDrag: null,
          layout: newLayout,
          oldDragItem: null,
          oldLayout: null
        }), this.onLayoutMaybeChanged(newLayout, oldLayout);
      }), _defineProperty(this, "onResizeStart", (i, w, h, _ref4) => {
        let {
          e,
          node
        } = _ref4;
        const {
          layout
        } = this.state, l = (0, _utils.getLayoutItem)(layout, i);
        l && (this.setState({
          oldResizeItem: (0, _utils.cloneLayoutItem)(l),
          oldLayout: this.state.layout,
          resizing: !0
        }), this.props.onResizeStart(layout, l, l, null, e, node));
      }), _defineProperty(this, "onResize", (i, w, h, _ref5) => {
        let {
          e,
          node,
          size,
          handle
        } = _ref5;
        const {
          oldResizeItem
        } = this.state, {
          layout
        } = this.state, {
          cols,
          preventCollision,
          allowOverlap
        } = this.props;
        let shouldMoveItem = !1, finalLayout, x, y;
        const [newLayout, l] = (0, _utils.withLayoutItem)(layout, i, (l2) => {
          let hasCollisions;
          return x = l2.x, y = l2.y, ["sw", "w", "nw", "n", "ne"].indexOf(handle) !== -1 && (["sw", "nw", "w"].indexOf(handle) !== -1 && (x = l2.x + (l2.w - w), w = l2.x !== x && x < 0 ? l2.w : w, x = x < 0 ? 0 : x), ["ne", "n", "nw"].indexOf(handle) !== -1 && (y = l2.y + (l2.h - h), h = l2.y !== y && y < 0 ? l2.h : h, y = y < 0 ? 0 : y), shouldMoveItem = !0), preventCollision && !allowOverlap && (hasCollisions = (0, _utils.getAllCollisions)(layout, {
            ...l2,
            w,
            h,
            x,
            y
          }).filter((layoutItem) => layoutItem.i !== l2.i).length > 0, hasCollisions && (y = l2.y, h = l2.h, x = l2.x, w = l2.w, shouldMoveItem = !1)), l2.w = w, l2.h = h, l2;
        });
        if (!l) return;
        finalLayout = newLayout, shouldMoveItem && (finalLayout = (0, _utils.moveElement)(newLayout, l, x, y, !0, this.props.preventCollision, (0, _utils.compactType)(this.props), cols, allowOverlap));
        const placeholder = {
          w: l.w,
          h: l.h,
          x: l.x,
          y: l.y,
          static: !0,
          i
        };
        this.props.onResize(finalLayout, oldResizeItem, l, placeholder, e, node), this.setState({
          layout: allowOverlap ? finalLayout : (0, _utils.compact)(finalLayout, (0, _utils.compactType)(this.props), cols),
          activeDrag: placeholder
        });
      }), _defineProperty(this, "onResizeStop", (i, w, h, _ref6) => {
        let {
          e,
          node
        } = _ref6;
        const {
          layout,
          oldResizeItem
        } = this.state, {
          cols,
          allowOverlap
        } = this.props, l = (0, _utils.getLayoutItem)(layout, i), newLayout = allowOverlap ? layout : (0, _utils.compact)(layout, (0, _utils.compactType)(this.props), cols);
        this.props.onResizeStop(newLayout, oldResizeItem, l, null, e, node);
        const {
          oldLayout
        } = this.state;
        this.setState({
          activeDrag: null,
          layout: newLayout,
          oldResizeItem: null,
          oldLayout: null,
          resizing: !1
        }), this.onLayoutMaybeChanged(newLayout, oldLayout);
      }), _defineProperty(this, "onDragOver", (e) => {
        var _a16;
        if (e.preventDefault(), e.stopPropagation(), isFirefox && // $FlowIgnore can't figure this out
        !((_a16 = e.nativeEvent.target) != null && _a16.classList.contains(layoutClassName)))
          return !1;
        const {
          droppingItem,
          onDropDragOver,
          margin,
          cols,
          rowHeight,
          maxRows,
          width,
          containerPadding,
          transformScale
        } = this.props, onDragOverResult = onDropDragOver == null ? void 0 : onDropDragOver(e);
        if (onDragOverResult === !1)
          return this.state.droppingDOMNode && this.removeDroppingPlaceholder(), !1;
        const finalDroppingItem = {
          ...droppingItem,
          ...onDragOverResult
        }, {
          layout
        } = this.state, gridRect = e.currentTarget.getBoundingClientRect(), layerX = e.clientX - gridRect.left, layerY = e.clientY - gridRect.top, droppingPosition = {
          left: layerX / transformScale,
          top: layerY / transformScale,
          e
        };
        if (this.state.droppingDOMNode) {
          if (this.state.droppingPosition) {
            const {
              left,
              top
            } = this.state.droppingPosition;
            (left != layerX || top != layerY) && this.setState({
              droppingPosition
            });
          }
        } else {
          const positionParams = {
            cols,
            margin,
            maxRows,
            rowHeight,
            containerWidth: width,
            containerPadding: containerPadding || margin
          }, calculatedPosition = (0, _calculateUtils.calcXY)(positionParams, layerY, layerX, finalDroppingItem.w, finalDroppingItem.h);
          this.setState({
            droppingDOMNode: /* @__PURE__ */ React.createElement("div", {
              key: finalDroppingItem.i
            }),
            droppingPosition,
            layout: [...layout, {
              ...finalDroppingItem,
              x: calculatedPosition.x,
              y: calculatedPosition.y,
              static: !1,
              isDraggable: !0
            }]
          });
        }
      }), _defineProperty(this, "removeDroppingPlaceholder", () => {
        const {
          droppingItem,
          cols
        } = this.props, {
          layout
        } = this.state, newLayout = (0, _utils.compact)(layout.filter((l) => l.i !== droppingItem.i), (0, _utils.compactType)(this.props), cols, this.props.allowOverlap);
        this.setState({
          layout: newLayout,
          droppingDOMNode: null,
          activeDrag: null,
          droppingPosition: void 0
        });
      }), _defineProperty(this, "onDragLeave", (e) => {
        e.preventDefault(), e.stopPropagation(), this.dragEnterCounter--, this.dragEnterCounter === 0 && this.removeDroppingPlaceholder();
      }), _defineProperty(this, "onDragEnter", (e) => {
        e.preventDefault(), e.stopPropagation(), this.dragEnterCounter++;
      }), _defineProperty(this, "onDrop", (e) => {
        e.preventDefault(), e.stopPropagation();
        const {
          droppingItem
        } = this.props, {
          layout
        } = this.state, item2 = layout.find((l) => l.i === droppingItem.i);
        this.dragEnterCounter = 0, this.removeDroppingPlaceholder(), this.props.onDrop(layout, item2, e);
      });
    }
    componentDidMount() {
      this.setState({
        mounted: !0
      }), this.onLayoutMaybeChanged(this.state.layout, this.props.layout);
    }
    static getDerivedStateFromProps(nextProps, prevState) {
      let newLayoutBase;
      return prevState.activeDrag ? null : (!(0, _fastEquals.deepEqual)(nextProps.layout, prevState.propsLayout) || nextProps.compactType !== prevState.compactType ? newLayoutBase = nextProps.layout : (0, _utils.childrenEqual)(nextProps.children, prevState.children) || (newLayoutBase = prevState.layout), newLayoutBase ? {
        layout: (0, _utils.synchronizeLayoutWithChildren)(newLayoutBase, nextProps.children, nextProps.cols, (0, _utils.compactType)(nextProps), nextProps.allowOverlap),
        // We need to save these props to state for using
        // getDerivedStateFromProps instead of componentDidMount (in which we would get extra rerender)
        compactType: nextProps.compactType,
        children: nextProps.children,
        propsLayout: nextProps.layout
      } : null);
    }
    shouldComponentUpdate(nextProps, nextState) {
      return (
        // NOTE: this is almost always unequal. Therefore the only way to get better performance
        // from SCU is if the user intentionally memoizes children. If they do, and they can
        // handle changes properly, performance will increase.
        this.props.children !== nextProps.children || !(0, _utils.fastRGLPropsEqual)(this.props, nextProps, _fastEquals.deepEqual) || this.state.activeDrag !== nextState.activeDrag || this.state.mounted !== nextState.mounted || this.state.droppingPosition !== nextState.droppingPosition
      );
    }
    componentDidUpdate(prevProps, prevState) {
      if (!this.state.activeDrag) {
        const newLayout = this.state.layout, oldLayout = prevState.layout;
        this.onLayoutMaybeChanged(newLayout, oldLayout);
      }
    }
    /**
     * Calculates a pixel value for the container.
     * @return {String} Container height in pixels.
     */
    containerHeight() {
      if (!this.props.autoSize) return;
      const nbRow = (0, _utils.bottom)(this.state.layout), containerPaddingY = this.props.containerPadding ? this.props.containerPadding[1] : this.props.margin[1];
      return nbRow * this.props.rowHeight + (nbRow - 1) * this.props.margin[1] + containerPaddingY * 2 + "px";
    }
    onLayoutMaybeChanged(newLayout, oldLayout) {
      oldLayout || (oldLayout = this.state.layout), (0, _fastEquals.deepEqual)(oldLayout, newLayout) || this.props.onLayoutChange(newLayout);
    }
    /**
     * Create a placeholder object.
     * @return {Element} Placeholder div.
     */
    placeholder() {
      const {
        activeDrag
      } = this.state;
      if (!activeDrag) return null;
      const {
        width,
        cols,
        margin,
        containerPadding,
        rowHeight,
        maxRows,
        useCSSTransforms,
        transformScale
      } = this.props;
      return /* @__PURE__ */ React.createElement(_GridItem.default, {
        w: activeDrag.w,
        h: activeDrag.h,
        x: activeDrag.x,
        y: activeDrag.y,
        i: activeDrag.i,
        className: `react-grid-placeholder ${this.state.resizing ? "placeholder-resizing" : ""}`,
        containerWidth: width,
        cols,
        margin,
        containerPadding: containerPadding || margin,
        maxRows,
        rowHeight,
        isDraggable: !1,
        isResizable: !1,
        isBounded: !1,
        useCSSTransforms,
        transformScale
      }, /* @__PURE__ */ React.createElement("div", null));
    }
    /**
     * Given a grid item, set its style attributes & surround in a <Draggable>.
     * @param  {Element} child React element.
     * @return {Element}       Element wrapped in draggable and properly placed.
     */
    processGridItem(child, isDroppingItem) {
      if (!child || !child.key) return;
      const l = (0, _utils.getLayoutItem)(this.state.layout, String(child.key));
      if (!l) return null;
      const {
        width,
        cols,
        margin,
        containerPadding,
        rowHeight,
        maxRows,
        isDraggable,
        isResizable,
        isBounded,
        useCSSTransforms,
        transformScale,
        draggableCancel,
        draggableHandle: draggableHandle2,
        resizeHandles,
        resizeHandle
      } = this.props, {
        mounted,
        droppingPosition
      } = this.state, draggable = typeof l.isDraggable == "boolean" ? l.isDraggable : !l.static && isDraggable, resizable = typeof l.isResizable == "boolean" ? l.isResizable : !l.static && isResizable, resizeHandlesOptions = l.resizeHandles || resizeHandles, bounded = draggable && isBounded && l.isBounded !== !1;
      return /* @__PURE__ */ React.createElement(_GridItem.default, {
        containerWidth: width,
        cols,
        margin,
        containerPadding: containerPadding || margin,
        maxRows,
        rowHeight,
        cancel: draggableCancel,
        handle: draggableHandle2,
        onDragStop: this.onDragStop,
        onDragStart: this.onDragStart,
        onDrag: this.onDrag,
        onResizeStart: this.onResizeStart,
        onResize: this.onResize,
        onResizeStop: this.onResizeStop,
        isDraggable: draggable,
        isResizable: resizable,
        isBounded: bounded,
        useCSSTransforms: useCSSTransforms && mounted,
        usePercentages: !mounted,
        transformScale,
        w: l.w,
        h: l.h,
        x: l.x,
        y: l.y,
        i: l.i,
        minH: l.minH,
        minW: l.minW,
        maxH: l.maxH,
        maxW: l.maxW,
        static: l.static,
        droppingPosition: isDroppingItem ? droppingPosition : void 0,
        resizeHandles: resizeHandlesOptions,
        resizeHandle
      }, child);
    }
    render() {
      const {
        className,
        style,
        isDroppable,
        innerRef
      } = this.props, mergedClassName = (0, _clsx.default)(layoutClassName, className), mergedStyle = {
        height: this.containerHeight(),
        ...style
      };
      return /* @__PURE__ */ React.createElement("div", {
        ref: innerRef,
        className: mergedClassName,
        style: mergedStyle,
        onDrop: isDroppable ? this.onDrop : _utils.noop,
        onDragLeave: isDroppable ? this.onDragLeave : _utils.noop,
        onDragEnter: isDroppable ? this.onDragEnter : _utils.noop,
        onDragOver: isDroppable ? this.onDragOver : _utils.noop
      }, React.Children.map(this.props.children, (child) => this.processGridItem(child)), isDroppable && this.state.droppingDOMNode && this.processGridItem(this.state.droppingDOMNode, !0), this.placeholder());
    }
  }, __name(_a15, "ReactGridLayout"), _a15);
  return ReactGridLayout.default = ReactGridLayout$1, _defineProperty(ReactGridLayout$1, "displayName", "ReactGridLayout"), _defineProperty(ReactGridLayout$1, "propTypes", _ReactGridLayoutPropTypes.default), _defineProperty(ReactGridLayout$1, "defaultProps", {
    autoSize: !0,
    cols: 12,
    className: "",
    style: {},
    draggableHandle: "",
    draggableCancel: "",
    containerPadding: null,
    rowHeight: 150,
    maxRows: 1 / 0,
    // infinite vertical growth
    layout: [],
    margin: [10, 10],
    isBounded: !1,
    isDraggable: !0,
    isResizable: !0,
    allowOverlap: !1,
    isDroppable: !1,
    useCSSTransforms: !0,
    transformScale: 1,
    verticalCompact: !0,
    compactType: "vertical",
    preventCollision: !1,
    droppingItem: {
      i: "__dropping-elem__",
      h: 1,
      w: 1
    },
    resizeHandles: ["se"],
    onLayoutChange: _utils.noop,
    onDragStart: _utils.noop,
    onDrag: _utils.noop,
    onDragStop: _utils.noop,
    onResizeStart: _utils.noop,
    onResize: _utils.noop,
    onResizeStop: _utils.noop,
    onDrop: _utils.noop,
    onDropDragOver: _utils.noop
  }), ReactGridLayout;
}
__name(requireReactGridLayout$1, "requireReactGridLayout$1");
var ResponsiveReactGridLayout = {}, responsiveUtils = {}, hasRequiredResponsiveUtils;
function requireResponsiveUtils() {
  if (hasRequiredResponsiveUtils) return responsiveUtils;
  hasRequiredResponsiveUtils = 1, Object.defineProperty(responsiveUtils, "__esModule", {
    value: !0
  }), responsiveUtils.findOrGenerateResponsiveLayout = findOrGenerateResponsiveLayout, responsiveUtils.getBreakpointFromWidth = getBreakpointFromWidth, responsiveUtils.getColsFromBreakpoint = getColsFromBreakpoint, responsiveUtils.sortBreakpoints = sortBreakpoints;
  var _utils = requireUtils$1();
  function getBreakpointFromWidth(breakpoints, width) {
    const sorted = sortBreakpoints(breakpoints);
    let matching = sorted[0];
    for (let i = 1, len = sorted.length; i < len; i++) {
      const breakpointName = sorted[i];
      width > breakpoints[breakpointName] && (matching = breakpointName);
    }
    return matching;
  }
  __name(getBreakpointFromWidth, "getBreakpointFromWidth");
  function getColsFromBreakpoint(breakpoint, cols) {
    if (!cols[breakpoint])
      throw new Error("ResponsiveReactGridLayout: `cols` entry for breakpoint " + breakpoint + " is missing!");
    return cols[breakpoint];
  }
  __name(getColsFromBreakpoint, "getColsFromBreakpoint");
  function findOrGenerateResponsiveLayout(layouts, breakpoints, breakpoint, lastBreakpoint, cols, compactType) {
    if (layouts[breakpoint]) return (0, _utils.cloneLayout)(layouts[breakpoint]);
    let layout = layouts[lastBreakpoint];
    const breakpointsSorted = sortBreakpoints(breakpoints), breakpointsAbove = breakpointsSorted.slice(breakpointsSorted.indexOf(breakpoint));
    for (let i = 0, len = breakpointsAbove.length; i < len; i++) {
      const b = breakpointsAbove[i];
      if (layouts[b]) {
        layout = layouts[b];
        break;
      }
    }
    return layout = (0, _utils.cloneLayout)(layout || []), (0, _utils.compact)((0, _utils.correctBounds)(layout, {
      cols
    }), compactType, cols);
  }
  __name(findOrGenerateResponsiveLayout, "findOrGenerateResponsiveLayout");
  function sortBreakpoints(breakpoints) {
    return Object.keys(breakpoints).sort(function(a, b) {
      return breakpoints[a] - breakpoints[b];
    });
  }
  return __name(sortBreakpoints, "sortBreakpoints"), responsiveUtils;
}
__name(requireResponsiveUtils, "requireResponsiveUtils");
var hasRequiredResponsiveReactGridLayout;
function requireResponsiveReactGridLayout() {
  var _a15;
  if (hasRequiredResponsiveReactGridLayout) return ResponsiveReactGridLayout;
  hasRequiredResponsiveReactGridLayout = 1, Object.defineProperty(ResponsiveReactGridLayout, "__esModule", {
    value: !0
  }), ResponsiveReactGridLayout.default = void 0;
  var React = _interopRequireWildcard(require$$0), _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1()), _fastEquals = /* @__PURE__ */ requireFastEquals(), _utils = requireUtils$1(), _responsiveUtils = requireResponsiveUtils(), _ReactGridLayout = _interopRequireDefault(requireReactGridLayout$1());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function _getRequireWildcardCache(e) {
    if (typeof WeakMap != "function") return null;
    var r2 = /* @__PURE__ */ new WeakMap(), t = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(e2) {
      return e2 ? t : r2;
    }, "_getRequireWildcardCache"))(e);
  }
  __name(_getRequireWildcardCache, "_getRequireWildcardCache");
  function _interopRequireWildcard(e, r2) {
    if (e && e.__esModule) return e;
    if (e === null || typeof e != "object" && typeof e != "function") return { default: e };
    var t = _getRequireWildcardCache(r2);
    if (t && t.has(e)) return t.get(e);
    var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e) if (u !== "default" && Object.prototype.hasOwnProperty.call(e, u)) {
      var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
      i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
    }
    return n.default = e, t && t.set(e, n), n;
  }
  __name(_interopRequireWildcard, "_interopRequireWildcard");
  function _extends() {
    return _extends = Object.assign ? Object.assign.bind() : function(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source)
          Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
      }
      return target;
    }, _extends.apply(this, arguments);
  }
  __name(_extends, "_extends");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  const type = /* @__PURE__ */ __name((obj) => Object.prototype.toString.call(obj), "type");
  function getIndentationValue(param, breakpoint) {
    return param == null ? null : Array.isArray(param) ? param : param[breakpoint];
  }
  __name(getIndentationValue, "getIndentationValue");
  let ResponsiveReactGridLayout$1 = (_a15 = class extends React.Component {
    constructor() {
      super(...arguments), _defineProperty(this, "state", this.generateInitialState()), _defineProperty(this, "onLayoutChange", (layout) => {
        this.props.onLayoutChange(layout, {
          ...this.props.layouts,
          [this.state.breakpoint]: layout
        });
      });
    }
    generateInitialState() {
      const {
        width,
        breakpoints,
        layouts,
        cols
      } = this.props, breakpoint = (0, _responsiveUtils.getBreakpointFromWidth)(breakpoints, width), colNo = (0, _responsiveUtils.getColsFromBreakpoint)(breakpoint, cols), compactType = this.props.verticalCompact === !1 ? null : this.props.compactType;
      return {
        layout: (0, _responsiveUtils.findOrGenerateResponsiveLayout)(layouts, breakpoints, breakpoint, breakpoint, colNo, compactType),
        breakpoint,
        cols: colNo
      };
    }
    static getDerivedStateFromProps(nextProps, prevState) {
      if (!(0, _fastEquals.deepEqual)(nextProps.layouts, prevState.layouts)) {
        const {
          breakpoint,
          cols
        } = prevState;
        return {
          layout: (0, _responsiveUtils.findOrGenerateResponsiveLayout)(nextProps.layouts, nextProps.breakpoints, breakpoint, breakpoint, cols, nextProps.compactType),
          layouts: nextProps.layouts
        };
      }
      return null;
    }
    componentDidUpdate(prevProps) {
      (this.props.width != prevProps.width || this.props.breakpoint !== prevProps.breakpoint || !(0, _fastEquals.deepEqual)(this.props.breakpoints, prevProps.breakpoints) || !(0, _fastEquals.deepEqual)(this.props.cols, prevProps.cols)) && this.onWidthChange(prevProps);
    }
    /**
     * When the width changes work through breakpoints and reset state with the new width & breakpoint.
     * Width changes are necessary to figure out the widget widths.
     */
    onWidthChange(prevProps) {
      const {
        breakpoints,
        cols,
        layouts,
        compactType
      } = this.props, newBreakpoint = this.props.breakpoint || (0, _responsiveUtils.getBreakpointFromWidth)(this.props.breakpoints, this.props.width), lastBreakpoint = this.state.breakpoint, newCols = (0, _responsiveUtils.getColsFromBreakpoint)(newBreakpoint, cols), newLayouts = {
        ...layouts
      };
      if (lastBreakpoint !== newBreakpoint || prevProps.breakpoints !== breakpoints || prevProps.cols !== cols) {
        lastBreakpoint in newLayouts || (newLayouts[lastBreakpoint] = (0, _utils.cloneLayout)(this.state.layout));
        let layout = (0, _responsiveUtils.findOrGenerateResponsiveLayout)(newLayouts, breakpoints, newBreakpoint, lastBreakpoint, newCols, compactType);
        layout = (0, _utils.synchronizeLayoutWithChildren)(layout, this.props.children, newCols, compactType, this.props.allowOverlap), newLayouts[newBreakpoint] = layout, this.props.onBreakpointChange(newBreakpoint, newCols), this.props.onLayoutChange(layout, newLayouts), this.setState({
          breakpoint: newBreakpoint,
          layout,
          cols: newCols
        });
      }
      const margin = getIndentationValue(this.props.margin, newBreakpoint), containerPadding = getIndentationValue(this.props.containerPadding, newBreakpoint);
      this.props.onWidthChange(this.props.width, margin, newCols, containerPadding);
    }
    render() {
      const {
        breakpoint,
        breakpoints,
        cols,
        layouts,
        margin,
        containerPadding,
        onBreakpointChange,
        onLayoutChange,
        onWidthChange,
        ...other
      } = this.props;
      return /* @__PURE__ */ React.createElement(_ReactGridLayout.default, _extends({}, other, {
        // $FlowIgnore should allow nullable here due to DefaultProps
        margin: getIndentationValue(margin, this.state.breakpoint),
        containerPadding: getIndentationValue(containerPadding, this.state.breakpoint),
        onLayoutChange: this.onLayoutChange,
        layout: this.state.layout,
        cols: this.state.cols
      }));
    }
  }, __name(_a15, "ResponsiveReactGridLayout"), _a15);
  return ResponsiveReactGridLayout.default = ResponsiveReactGridLayout$1, _defineProperty(ResponsiveReactGridLayout$1, "propTypes", {
    //
    // Basic props
    //
    // Optional, but if you are managing width yourself you may want to set the breakpoint
    // yourself as well.
    breakpoint: _propTypes.default.string,
    // {name: pxVal}, e.g. {lg: 1200, md: 996, sm: 768, xs: 480}
    breakpoints: _propTypes.default.object,
    allowOverlap: _propTypes.default.bool,
    // # of cols. This is a breakpoint -> cols map
    cols: _propTypes.default.object,
    // # of margin. This is a breakpoint -> margin map
    // e.g. { lg: [5, 5], md: [10, 10], sm: [15, 15] }
    // Margin between items [x, y] in px
    // e.g. [10, 10]
    margin: _propTypes.default.oneOfType([_propTypes.default.array, _propTypes.default.object]),
    // # of containerPadding. This is a breakpoint -> containerPadding map
    // e.g. { lg: [5, 5], md: [10, 10], sm: [15, 15] }
    // Padding inside the container [x, y] in px
    // e.g. [10, 10]
    containerPadding: _propTypes.default.oneOfType([_propTypes.default.array, _propTypes.default.object]),
    // layouts is an object mapping breakpoints to layouts.
    // e.g. {lg: Layout, md: Layout, ...}
    layouts(props, propName) {
      if (type(props[propName]) !== "[object Object]")
        throw new Error("Layout property must be an object. Received: " + type(props[propName]));
      Object.keys(props[propName]).forEach((key) => {
        if (!(key in props.breakpoints))
          throw new Error("Each key in layouts must align with a key in breakpoints.");
        (0, _utils.validateLayout)(props.layouts[key], "layouts." + key);
      });
    },
    // The width of this component.
    // Required in this propTypes stanza because generateInitialState() will fail without it.
    width: _propTypes.default.number.isRequired,
    //
    // Callbacks
    //
    // Calls back with breakpoint and new # cols
    onBreakpointChange: _propTypes.default.func,
    // Callback so you can save the layout.
    // Calls back with (currentLayout, allLayouts). allLayouts are keyed by breakpoint.
    onLayoutChange: _propTypes.default.func,
    // Calls back with (containerWidth, margin, cols, containerPadding)
    onWidthChange: _propTypes.default.func
  }), _defineProperty(ResponsiveReactGridLayout$1, "defaultProps", {
    breakpoints: {
      lg: 1200,
      md: 996,
      sm: 768,
      xs: 480,
      xxs: 0
    },
    cols: {
      lg: 12,
      md: 10,
      sm: 6,
      xs: 4,
      xxs: 2
    },
    containerPadding: {
      lg: null,
      md: null,
      sm: null,
      xs: null,
      xxs: null
    },
    layouts: {},
    margin: [10, 10],
    allowOverlap: !1,
    onBreakpointChange: _utils.noop,
    onLayoutChange: _utils.noop,
    onWidthChange: _utils.noop
  }), ResponsiveReactGridLayout;
}
__name(requireResponsiveReactGridLayout, "requireResponsiveReactGridLayout");
var WidthProvider = {}, MapShim = function() {
  if (typeof Map < "u")
    return Map;
  function getIndex(arr, key) {
    var result = -1;
    return arr.some(function(entry, index2) {
      return entry[0] === key ? (result = index2, !0) : !1;
    }), result;
  }
  return __name(getIndex, "getIndex"), /** @class */
  function() {
    function class_1() {
      this.__entries__ = [];
    }
    return __name(class_1, "class_1"), Object.defineProperty(class_1.prototype, "size", {
      /**
       * @returns {boolean}
       */
      get: /* @__PURE__ */ __name(function() {
        return this.__entries__.length;
      }, "get"),
      enumerable: !0,
      configurable: !0
    }), class_1.prototype.get = function(key) {
      var index2 = getIndex(this.__entries__, key), entry = this.__entries__[index2];
      return entry && entry[1];
    }, class_1.prototype.set = function(key, value) {
      var index2 = getIndex(this.__entries__, key);
      ~index2 ? this.__entries__[index2][1] = value : this.__entries__.push([key, value]);
    }, class_1.prototype.delete = function(key) {
      var entries = this.__entries__, index2 = getIndex(entries, key);
      ~index2 && entries.splice(index2, 1);
    }, class_1.prototype.has = function(key) {
      return !!~getIndex(this.__entries__, key);
    }, class_1.prototype.clear = function() {
      this.__entries__.splice(0);
    }, class_1.prototype.forEach = function(callback, ctx) {
      ctx === void 0 && (ctx = null);
      for (var _i = 0, _a15 = this.__entries__; _i < _a15.length; _i++) {
        var entry = _a15[_i];
        callback.call(ctx, entry[1], entry[0]);
      }
    }, class_1;
  }();
}(), isBrowser = typeof window < "u" && typeof document < "u" && window.document === document, global$1 = function() {
  return typeof global < "u" && global.Math === Math ? global : typeof self < "u" && self.Math === Math ? self : typeof window < "u" && window.Math === Math ? window : Function("return this")();
}(), requestAnimationFrame$1 = function() {
  return typeof requestAnimationFrame == "function" ? requestAnimationFrame.bind(global$1) : function(callback) {
    return setTimeout(function() {
      return callback(Date.now());
    }, 1e3 / 60);
  };
}(), trailingTimeout = 2;
function throttle(callback, delay) {
  var leadingCall = !1, trailingCall = !1, lastCallTime = 0;
  function resolvePending() {
    leadingCall && (leadingCall = !1, callback()), trailingCall && proxy();
  }
  __name(resolvePending, "resolvePending");
  function timeoutCallback() {
    requestAnimationFrame$1(resolvePending);
  }
  __name(timeoutCallback, "timeoutCallback");
  function proxy() {
    var timeStamp = Date.now();
    if (leadingCall) {
      if (timeStamp - lastCallTime < trailingTimeout)
        return;
      trailingCall = !0;
    } else
      leadingCall = !0, trailingCall = !1, setTimeout(timeoutCallback, delay);
    lastCallTime = timeStamp;
  }
  return __name(proxy, "proxy"), proxy;
}
__name(throttle, "throttle");
var REFRESH_DELAY = 20, transitionKeys = ["top", "right", "bottom", "left", "width", "height", "size", "weight"], mutationObserverSupported = typeof MutationObserver < "u", ResizeObserverController = (
  /** @class */
  function() {
    function ResizeObserverController2() {
      this.connected_ = !1, this.mutationEventsAdded_ = !1, this.mutationsObserver_ = null, this.observers_ = [], this.onTransitionEnd_ = this.onTransitionEnd_.bind(this), this.refresh = throttle(this.refresh.bind(this), REFRESH_DELAY);
    }
    return __name(ResizeObserverController2, "ResizeObserverController"), ResizeObserverController2.prototype.addObserver = function(observer) {
      ~this.observers_.indexOf(observer) || this.observers_.push(observer), this.connected_ || this.connect_();
    }, ResizeObserverController2.prototype.removeObserver = function(observer) {
      var observers2 = this.observers_, index2 = observers2.indexOf(observer);
      ~index2 && observers2.splice(index2, 1), !observers2.length && this.connected_ && this.disconnect_();
    }, ResizeObserverController2.prototype.refresh = function() {
      var changesDetected = this.updateObservers_();
      changesDetected && this.refresh();
    }, ResizeObserverController2.prototype.updateObservers_ = function() {
      var activeObservers = this.observers_.filter(function(observer) {
        return observer.gatherActive(), observer.hasActive();
      });
      return activeObservers.forEach(function(observer) {
        return observer.broadcastActive();
      }), activeObservers.length > 0;
    }, ResizeObserverController2.prototype.connect_ = function() {
      !isBrowser || this.connected_ || (document.addEventListener("transitionend", this.onTransitionEnd_), window.addEventListener("resize", this.refresh), mutationObserverSupported ? (this.mutationsObserver_ = new MutationObserver(this.refresh), this.mutationsObserver_.observe(document, {
        attributes: !0,
        childList: !0,
        characterData: !0,
        subtree: !0
      })) : (document.addEventListener("DOMSubtreeModified", this.refresh), this.mutationEventsAdded_ = !0), this.connected_ = !0);
    }, ResizeObserverController2.prototype.disconnect_ = function() {
      !isBrowser || !this.connected_ || (document.removeEventListener("transitionend", this.onTransitionEnd_), window.removeEventListener("resize", this.refresh), this.mutationsObserver_ && this.mutationsObserver_.disconnect(), this.mutationEventsAdded_ && document.removeEventListener("DOMSubtreeModified", this.refresh), this.mutationsObserver_ = null, this.mutationEventsAdded_ = !1, this.connected_ = !1);
    }, ResizeObserverController2.prototype.onTransitionEnd_ = function(_a15) {
      var _b = _a15.propertyName, propertyName = _b === void 0 ? "" : _b, isReflowProperty = transitionKeys.some(function(key) {
        return !!~propertyName.indexOf(key);
      });
      isReflowProperty && this.refresh();
    }, ResizeObserverController2.getInstance = function() {
      return this.instance_ || (this.instance_ = new ResizeObserverController2()), this.instance_;
    }, ResizeObserverController2.instance_ = null, ResizeObserverController2;
  }()
), defineConfigurable = /* @__PURE__ */ __name(function(target, props) {
  for (var _i = 0, _a15 = Object.keys(props); _i < _a15.length; _i++) {
    var key = _a15[_i];
    Object.defineProperty(target, key, {
      value: props[key],
      enumerable: !1,
      writable: !1,
      configurable: !0
    });
  }
  return target;
}, "defineConfigurable"), getWindowOf = /* @__PURE__ */ __name(function(target) {
  var ownerGlobal = target && target.ownerDocument && target.ownerDocument.defaultView;
  return ownerGlobal || global$1;
}, "getWindowOf"), emptyRect = createRectInit(0, 0, 0, 0);
function toFloat(value) {
  return parseFloat(value) || 0;
}
__name(toFloat, "toFloat");
function getBordersSize(styles2) {
  for (var positions = [], _i = 1; _i < arguments.length; _i++)
    positions[_i - 1] = arguments[_i];
  return positions.reduce(function(size, position) {
    var value = styles2["border-" + position + "-width"];
    return size + toFloat(value);
  }, 0);
}
__name(getBordersSize, "getBordersSize");
function getPaddings(styles2) {
  for (var positions = ["top", "right", "bottom", "left"], paddings = {}, _i = 0, positions_1 = positions; _i < positions_1.length; _i++) {
    var position = positions_1[_i], value = styles2["padding-" + position];
    paddings[position] = toFloat(value);
  }
  return paddings;
}
__name(getPaddings, "getPaddings");
function getSVGContentRect(target) {
  var bbox = target.getBBox();
  return createRectInit(0, 0, bbox.width, bbox.height);
}
__name(getSVGContentRect, "getSVGContentRect");
function getHTMLElementContentRect(target) {
  var clientWidth = target.clientWidth, clientHeight = target.clientHeight;
  if (!clientWidth && !clientHeight)
    return emptyRect;
  var styles2 = getWindowOf(target).getComputedStyle(target), paddings = getPaddings(styles2), horizPad = paddings.left + paddings.right, vertPad = paddings.top + paddings.bottom, width = toFloat(styles2.width), height = toFloat(styles2.height);
  if (styles2.boxSizing === "border-box" && (Math.round(width + horizPad) !== clientWidth && (width -= getBordersSize(styles2, "left", "right") + horizPad), Math.round(height + vertPad) !== clientHeight && (height -= getBordersSize(styles2, "top", "bottom") + vertPad)), !isDocumentElement(target)) {
    var vertScrollbar = Math.round(width + horizPad) - clientWidth, horizScrollbar = Math.round(height + vertPad) - clientHeight;
    Math.abs(vertScrollbar) !== 1 && (width -= vertScrollbar), Math.abs(horizScrollbar) !== 1 && (height -= horizScrollbar);
  }
  return createRectInit(paddings.left, paddings.top, width, height);
}
__name(getHTMLElementContentRect, "getHTMLElementContentRect");
var isSVGGraphicsElement = /* @__PURE__ */ function() {
  return typeof SVGGraphicsElement < "u" ? function(target) {
    return target instanceof getWindowOf(target).SVGGraphicsElement;
  } : function(target) {
    return target instanceof getWindowOf(target).SVGElement && typeof target.getBBox == "function";
  };
}();
function isDocumentElement(target) {
  return target === getWindowOf(target).document.documentElement;
}
__name(isDocumentElement, "isDocumentElement");
function getContentRect(target) {
  return isBrowser ? isSVGGraphicsElement(target) ? getSVGContentRect(target) : getHTMLElementContentRect(target) : emptyRect;
}
__name(getContentRect, "getContentRect");
function createReadOnlyRect(_a15) {
  var x = _a15.x, y = _a15.y, width = _a15.width, height = _a15.height, Constr = typeof DOMRectReadOnly < "u" ? DOMRectReadOnly : Object, rect = Object.create(Constr.prototype);
  return defineConfigurable(rect, {
    x,
    y,
    width,
    height,
    top: y,
    right: x + width,
    bottom: height + y,
    left: x
  }), rect;
}
__name(createReadOnlyRect, "createReadOnlyRect");
function createRectInit(x, y, width, height) {
  return { x, y, width, height };
}
__name(createRectInit, "createRectInit");
var ResizeObservation = (
  /** @class */
  function() {
    function ResizeObservation2(target) {
      this.broadcastWidth = 0, this.broadcastHeight = 0, this.contentRect_ = createRectInit(0, 0, 0, 0), this.target = target;
    }
    return __name(ResizeObservation2, "ResizeObservation"), ResizeObservation2.prototype.isActive = function() {
      var rect = getContentRect(this.target);
      return this.contentRect_ = rect, rect.width !== this.broadcastWidth || rect.height !== this.broadcastHeight;
    }, ResizeObservation2.prototype.broadcastRect = function() {
      var rect = this.contentRect_;
      return this.broadcastWidth = rect.width, this.broadcastHeight = rect.height, rect;
    }, ResizeObservation2;
  }()
), ResizeObserverEntry = (
  /** @class */
  function() {
    function ResizeObserverEntry2(target, rectInit) {
      var contentRect = createReadOnlyRect(rectInit);
      defineConfigurable(this, { target, contentRect });
    }
    return __name(ResizeObserverEntry2, "ResizeObserverEntry"), ResizeObserverEntry2;
  }()
), ResizeObserverSPI = (
  /** @class */
  function() {
    function ResizeObserverSPI2(callback, controller, callbackCtx) {
      if (this.activeObservations_ = [], this.observations_ = new MapShim(), typeof callback != "function")
        throw new TypeError("The callback provided as parameter 1 is not a function.");
      this.callback_ = callback, this.controller_ = controller, this.callbackCtx_ = callbackCtx;
    }
    return __name(ResizeObserverSPI2, "ResizeObserverSPI"), ResizeObserverSPI2.prototype.observe = function(target) {
      if (!arguments.length)
        throw new TypeError("1 argument required, but only 0 present.");
      if (!(typeof Element > "u" || !(Element instanceof Object))) {
        if (!(target instanceof getWindowOf(target).Element))
          throw new TypeError('parameter 1 is not of type "Element".');
        var observations = this.observations_;
        observations.has(target) || (observations.set(target, new ResizeObservation(target)), this.controller_.addObserver(this), this.controller_.refresh());
      }
    }, ResizeObserverSPI2.prototype.unobserve = function(target) {
      if (!arguments.length)
        throw new TypeError("1 argument required, but only 0 present.");
      if (!(typeof Element > "u" || !(Element instanceof Object))) {
        if (!(target instanceof getWindowOf(target).Element))
          throw new TypeError('parameter 1 is not of type "Element".');
        var observations = this.observations_;
        observations.has(target) && (observations.delete(target), observations.size || this.controller_.removeObserver(this));
      }
    }, ResizeObserverSPI2.prototype.disconnect = function() {
      this.clearActive(), this.observations_.clear(), this.controller_.removeObserver(this);
    }, ResizeObserverSPI2.prototype.gatherActive = function() {
      var _this = this;
      this.clearActive(), this.observations_.forEach(function(observation) {
        observation.isActive() && _this.activeObservations_.push(observation);
      });
    }, ResizeObserverSPI2.prototype.broadcastActive = function() {
      if (this.hasActive()) {
        var ctx = this.callbackCtx_, entries = this.activeObservations_.map(function(observation) {
          return new ResizeObserverEntry(observation.target, observation.broadcastRect());
        });
        this.callback_.call(ctx, entries, ctx), this.clearActive();
      }
    }, ResizeObserverSPI2.prototype.clearActive = function() {
      this.activeObservations_.splice(0);
    }, ResizeObserverSPI2.prototype.hasActive = function() {
      return this.activeObservations_.length > 0;
    }, ResizeObserverSPI2;
  }()
), observers = typeof WeakMap < "u" ? /* @__PURE__ */ new WeakMap() : new MapShim(), ResizeObserver = (
  /** @class */
  function() {
    function ResizeObserver2(callback) {
      if (!(this instanceof ResizeObserver2))
        throw new TypeError("Cannot call a class as a function.");
      if (!arguments.length)
        throw new TypeError("1 argument required, but only 0 present.");
      var controller = ResizeObserverController.getInstance(), observer = new ResizeObserverSPI(callback, controller, this);
      observers.set(this, observer);
    }
    return __name(ResizeObserver2, "ResizeObserver"), ResizeObserver2;
  }()
);
[
  "observe",
  "unobserve",
  "disconnect"
].forEach(function(method) {
  ResizeObserver.prototype[method] = function() {
    var _a15;
    return (_a15 = observers.get(this))[method].apply(_a15, arguments);
  };
});
var index = function() {
  return typeof global$1.ResizeObserver < "u" ? global$1.ResizeObserver : ResizeObserver;
}();
const ResizeObserver_es = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: index
}, Symbol.toStringTag, { value: "Module" })), require$$2 = /* @__PURE__ */ getAugmentedNamespace(ResizeObserver_es);
var hasRequiredWidthProvider;
function requireWidthProvider() {
  if (hasRequiredWidthProvider) return WidthProvider;
  hasRequiredWidthProvider = 1, Object.defineProperty(WidthProvider, "__esModule", {
    value: !0
  }), WidthProvider.default = WidthProvideRGL;
  var React = _interopRequireWildcard(require$$0), _propTypes = _interopRequireDefault(/* @__PURE__ */ requirePropTypes$1()), _resizeObserverPolyfill = _interopRequireDefault(require$$2), _clsx = _interopRequireDefault(requireClsx());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  __name(_interopRequireDefault, "_interopRequireDefault");
  function _getRequireWildcardCache(e) {
    if (typeof WeakMap != "function") return null;
    var r2 = /* @__PURE__ */ new WeakMap(), t = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = /* @__PURE__ */ __name(function(e2) {
      return e2 ? t : r2;
    }, "_getRequireWildcardCache"))(e);
  }
  __name(_getRequireWildcardCache, "_getRequireWildcardCache");
  function _interopRequireWildcard(e, r2) {
    if (e && e.__esModule) return e;
    if (e === null || typeof e != "object" && typeof e != "function") return { default: e };
    var t = _getRequireWildcardCache(r2);
    if (t && t.has(e)) return t.get(e);
    var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e) if (u !== "default" && Object.prototype.hasOwnProperty.call(e, u)) {
      var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
      i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
    }
    return n.default = e, t && t.set(e, n), n;
  }
  __name(_interopRequireWildcard, "_interopRequireWildcard");
  function _extends() {
    return _extends = Object.assign ? Object.assign.bind() : function(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source)
          Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
      }
      return target;
    }, _extends.apply(this, arguments);
  }
  __name(_extends, "_extends");
  function _defineProperty(obj, key, value) {
    return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
  }
  __name(_defineProperty, "_defineProperty");
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key == "symbol" ? key : String(key);
  }
  __name(_toPropertyKey, "_toPropertyKey");
  function _toPrimitive(input, hint) {
    if (typeof input != "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== void 0) {
      var res = prim.call(input, hint || "default");
      if (typeof res != "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  __name(_toPrimitive, "_toPrimitive");
  const layoutClassName = "react-grid-layout";
  function WidthProvideRGL(ComposedComponent) {
    var _a15;
    var _class;
    return _class = (_a15 = class extends React.Component {
      constructor() {
        super(...arguments), _defineProperty(this, "state", {
          width: 1280
        }), _defineProperty(this, "elementRef", /* @__PURE__ */ React.createRef()), _defineProperty(this, "mounted", !1), _defineProperty(this, "resizeObserver", void 0);
      }
      componentDidMount() {
        this.mounted = !0, this.resizeObserver = new _resizeObserverPolyfill.default((entries) => {
          if (this.elementRef.current instanceof HTMLElement) {
            const width = entries[0].contentRect.width;
            this.setState({
              width
            });
          }
        });
        const node = this.elementRef.current;
        node instanceof HTMLElement && this.resizeObserver.observe(node);
      }
      componentWillUnmount() {
        this.mounted = !1;
        const node = this.elementRef.current;
        node instanceof HTMLElement && this.resizeObserver.unobserve(node), this.resizeObserver.disconnect();
      }
      render() {
        const {
          measureBeforeMount,
          ...rest
        } = this.props;
        return measureBeforeMount && !this.mounted ? /* @__PURE__ */ React.createElement("div", {
          className: (0, _clsx.default)(this.props.className, layoutClassName),
          style: this.props.style,
          ref: this.elementRef
        }) : /* @__PURE__ */ React.createElement(ComposedComponent, _extends({
          innerRef: this.elementRef
        }, rest, this.state));
      }
    }, __name(_a15, "WidthProvider"), _a15), _defineProperty(_class, "defaultProps", {
      measureBeforeMount: !1
    }), _defineProperty(_class, "propTypes", {
      // If true, will not render children until mounted. Useful for getting the exact width before
      // rendering, to prevent any unsightly resizing.
      measureBeforeMount: _propTypes.default.bool
    }), _class;
  }
  return __name(WidthProvideRGL, "WidthProvideRGL"), WidthProvider;
}
__name(requireWidthProvider, "requireWidthProvider");
var hasRequiredReactGridLayout;
function requireReactGridLayout() {
  return hasRequiredReactGridLayout || (hasRequiredReactGridLayout = 1, function(module) {
    module.exports = requireReactGridLayout$1().default, module.exports.utils = requireUtils$1(), module.exports.calculateUtils = requireCalculateUtils(), module.exports.Responsive = requireResponsiveReactGridLayout().default, module.exports.Responsive.utils = requireResponsiveUtils(), module.exports.WidthProvider = requireWidthProvider().default;
  }(reactGridLayout)), reactGridLayout.exports;
}
__name(requireReactGridLayout, "requireReactGridLayout");
var reactGridLayoutExports = requireReactGridLayout();
const GridLayout = /* @__PURE__ */ getDefaultExportFromCjs(reactGridLayoutExports);
var __defProp$d = Object.defineProperty, __getOwnPropDesc$d = Object.getOwnPropertyDescriptor, __decorateClass$d = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$d(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$d(target, key, result), result;
}, "__decorateClass$d"), __decorateParam$d = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$d"), _a;
let ConditionalFormattingI18nController = (_a = class extends Disposable {
  constructor(_localeService) {
    super();
    __publicField(this, "_initLocal", /* @__PURE__ */ __name(() => {
    }, "_initLocal"));
    __publicField(this, "_findReplaceIndex", /* @__PURE__ */ __name((text2) => {
      const reg = /\{([^}]+)?\}/g, result = [];
      let currentValue = reg.exec(text2);
      for (; currentValue; )
        result.push({
          startIndex: currentValue.index,
          key: Number(currentValue[1]),
          endIndex: currentValue.index + currentValue[0].length - 1
        }), currentValue = reg.exec(text2);
      return result;
    }, "_findReplaceIndex"));
    this._localeService = _localeService, this._initLocal();
  }
  tWithReactNode(key, ...args) {
    const locale = this._localeService.getLocales(), keys = key.split("."), resolvedValue = locale && this._localeService.resolveKeyPath(locale, keys);
    if (typeof resolvedValue == "string") {
      const result = [];
      return this._findReplaceIndex(resolvedValue).forEach((item2, index2, list) => {
        const preItem = list[index2 - 1] || { startIndex: 0, endIndex: -1 };
        if (preItem.endIndex + 1 < item2.startIndex) {
          const text2 = resolvedValue.slice(preItem.endIndex + 1, item2.startIndex);
          text2 && result.push(text2);
        }
        if (args[item2.key] && result.push(args[item2.key]), index2 === list.length - 1) {
          const text2 = resolvedValue.slice(item2.endIndex + 1);
          text2 && result.push(text2);
        }
      }), result;
    }
    return [];
  }
}, __name(_a, "ConditionalFormattingI18nController"), _a);
ConditionalFormattingI18nController = __decorateClass$d([
  __decorateParam$d(0, Inject(LocaleService))
], ConditionalFormattingI18nController);
const cfPreview = "univer-cf-preview", styles$4 = {
  cfPreview
}, Preview = /* @__PURE__ */ __name((props) => {
  var _a15, _b;
  const rule = props.rule;
  if (!rule)
    return null;
  const colorList = useMemo(() => {
    if (rule.type === CFRuleType.colorScale) {
      const config = rule.config.map((c, index2) => ({ color: new ColorKit(c.color), value: index2 })), maxValue = config.length - 1;
      return new Array(5).fill("").map((_v, index2, arr) => index2 * maxValue / (arr.length - 1)).map((value) => getColorScaleFromValue(config, value));
    }
    return null;
  }, [rule]), iconSet2 = useMemo(() => {
    if (rule.type === CFRuleType.iconSet)
      return rule.config.map((item2) => {
        const iconList = iconMap[item2.iconType];
        return iconList && iconList[Number(item2.iconId)];
      });
  }, [rule]);
  switch (rule.type) {
    case CFRuleType.dataBar: {
      const { isGradient } = rule.config, commonStyle = { width: "50%", height: "100%" }, positiveColor = isGradient ? `linear-gradient(to right, ${rule.config.positiveColor || defaultDataBarPositiveColor}, rgb(255 255 255))` : rule.config.positiveColor, nativeColor = isGradient ? `linear-gradient(to right,  rgb(255 255 255),${rule.config.nativeColor || defaultDataBarNativeColor})` : rule.config.nativeColor;
      return /* @__PURE__ */ jsxs("div", { className: styles$4.cfPreview, children: [
        /* @__PURE__ */ jsx("div", { style: { ...commonStyle, background: nativeColor, border: `1px solid ${rule.config.nativeColor || defaultDataBarNativeColor}` } }),
        /* @__PURE__ */ jsx("div", { style: { ...commonStyle, background: positiveColor, border: `1px solid ${rule.config.positiveColor || defaultDataBarPositiveColor}` } })
      ] });
    }
    case CFRuleType.colorScale:
      return colorList && /* @__PURE__ */ jsx("div", { className: styles$4.cfPreview, children: colorList.map((item2, index2) => /* @__PURE__ */ jsx("div", { style: { width: `${100 / colorList.length}%`, height: "100%", background: item2 } }, index2)) });
    case CFRuleType.iconSet:
      return iconSet2 && /* @__PURE__ */ jsx("div", { className: styles$4.cfPreview, children: iconSet2.map((base64, index2) => base64 ? /* @__PURE__ */ jsx("img", { style: { height: "100%" }, src: base64 }, index2) : /* @__PURE__ */ jsx(SlashSingle, {}, index2)) });
    case CFRuleType.highlightCell: {
      const { ul, st, it, bl, bg, cl } = rule.style, isUnderline = (ul == null ? void 0 : ul.s) === BooleanNumber.TRUE, isStrikethrough = (st == null ? void 0 : st.s) === BooleanNumber.TRUE, isItalic = it === BooleanNumber.TRUE, isBold = bl === BooleanNumber.TRUE, bgColor = (_a15 = bg == null ? void 0 : bg.rgb) != null ? _a15 : DEFAULT_BG_COLOR, fontColor = (_b = cl == null ? void 0 : cl.rgb) != null ? _b : DEFAULT_FONT_COLOR, style = {
        fontWeight: isBold ? "bold" : void 0,
        fontStyle: isItalic ? "italic" : void 0,
        textDecoration: `${isUnderline ? "underline" : ""} ${isStrikethrough ? "line-through" : ""}`.replace(/^ /, "") || void 0,
        backgroundColor: bgColor,
        color: fontColor
      };
      return /* @__PURE__ */ jsx("div", { style, className: styles$4.cfPreview, children: "123" });
    }
  }
  return null;
}, "Preview"), cfRuleList = "univer-cf-rule-list", ruleSelector = "univer-rule-selector", select = "univer-select", selectSelector = "univer-select-selector", selectSelectionItem = "univer-select-selection-item", selectSelectionSearchInput = "univer-select-selection-search-input", btnList$1 = "univer-btn-list", gap = "univer-gap", icon$1 = "univer-icon", disabled = "univer-disabled", ruleItem = "univer-rule-item", ruleDescribe = "univer-rule-describe", ruleType = "univer-rule-type", ruleRange = "univer-rule-range", active = "univer-active", draggableHandle = "univer-draggableHandle", deleteItem = "univer-delete-item", gridLayoutWrap = "univer-grid-layout-wrap", reactGridItem = "univer-react-grid-item", styles$3 = {
  cfRuleList,
  ruleSelector,
  select,
  selectSelector,
  selectSelectionItem,
  selectSelectionSearchInput,
  btnList: btnList$1,
  gap,
  icon: icon$1,
  disabled,
  ruleItem,
  ruleDescribe,
  ruleType,
  ruleRange,
  active,
  draggableHandle,
  deleteItem,
  gridLayoutWrap,
  reactGridItem
}, getRuleDescribe = /* @__PURE__ */ __name((rule, localeService) => {
  const ruleConfig = rule.rule;
  switch (ruleConfig.type) {
    case CFRuleType.colorScale:
      return localeService.t("sheet.cf.ruleType.colorScale");
    case CFRuleType.dataBar:
      return localeService.t("sheet.cf.ruleType.dataBar");
    case CFRuleType.iconSet:
      return localeService.t("sheet.cf.ruleType.iconSet");
    case CFRuleType.highlightCell:
      switch (ruleConfig.subType) {
        case CFSubRuleType.average: {
          const operator = ruleConfig.operator;
          return localeService.t(`sheet.cf.preview.describe.${operator}`, localeService.t("sheet.cf.subRuleType.average"));
        }
        case CFSubRuleType.duplicateValues:
          return localeService.t("sheet.cf.subRuleType.duplicateValues");
        case CFSubRuleType.uniqueValues:
          return localeService.t("sheet.cf.subRuleType.uniqueValues");
        case CFSubRuleType.number: {
          const operator = ruleConfig.operator;
          return localeService.t(`sheet.cf.preview.describe.${operator}`, ...Array.isArray(ruleConfig.value) ? ruleConfig.value.map((e) => String(e)) : [String(ruleConfig.value || "")]);
        }
        case CFSubRuleType.text: {
          const operator = ruleConfig.operator;
          return localeService.t(`sheet.cf.preview.describe.${operator}`, ruleConfig.value || "");
        }
        case CFSubRuleType.timePeriod: {
          const operator = ruleConfig.operator;
          return localeService.t(`sheet.cf.preview.describe.${operator}`);
        }
        case CFSubRuleType.rank:
          return ruleConfig.isPercent ? ruleConfig.isBottom ? localeService.t("sheet.cf.preview.describe.bottomNPercent", String(ruleConfig.value)) : localeService.t("sheet.cf.preview.describe.topNPercent", String(ruleConfig.value)) : ruleConfig.isBottom ? localeService.t("sheet.cf.preview.describe.bottomN", String(ruleConfig.value)) : localeService.t("sheet.cf.preview.describe.topN", String(ruleConfig.value));
        case CFSubRuleType.formula:
          return localeService.t("sheet.cf.ruleType.formula");
      }
  }
}, "getRuleDescribe");
let defaultWidth = 0;
const RuleList = /* @__PURE__ */ __name((props) => {
  const { onClick } = props, conditionalFormattingRuleModel = useDependency(ConditionalFormattingRuleModel), univerInstanceService = useDependency(IUniverInstanceService), selectionManagerService = useDependency(SheetsSelectionsService), commandService = useDependency(ICommandService), localeService = useDependency(LocaleService), injector = useDependency(Injector), conditionalFormattingI18nController = useDependency(ConditionalFormattingI18nController), workbook = useObservable(() => univerInstanceService.getCurrentTypeOfUnit$(UniverInstanceType.UNIVER_SHEET), void 0, void 0, []), unitId = workbook.getUnitId(), worksheet = workbook.getActiveSheet();
  if (!worksheet)
    throw new Error("No active sheet found");
  const subUnitId = worksheet.getSheetId(), [currentRuleRanges, currentRuleRangesSet] = useState([]), [selectValue, selectValueSet] = useState("2"), [fetchRuleListId, fetchRuleListIdSet] = useState(0), [draggingId, draggingIdSet] = useState(-1), [layoutWidth, layoutWidthSet] = useState(defaultWidth), layoutContainerRef = useRef(null), selectOption = [
    { label: localeService.t("sheet.cf.panel.workSheet"), value: "2" },
    { label: localeService.t("sheet.cf.panel.selectedRange"), value: "1" }
  ], getRuleList = /* @__PURE__ */ __name(() => {
    const ruleList2 = conditionalFormattingRuleModel.getSubunitRules(unitId, subUnitId);
    if (!ruleList2 || !ruleList2.length)
      return [];
    if (selectValue === "1") {
      const selection = selectionManagerService.getCurrentLastSelection();
      if (!selection)
        return [];
      const range = selection.range;
      return ruleList2.filter((rule) => rule.ranges.some((ruleRange2) => Rectangle.intersects(ruleRange2, range)));
    } else if (selectValue === "2")
      return [...ruleList2];
    return [];
  }, "getRuleList"), [ruleList, ruleListSet] = useState(getRuleList);
  useHighlightRange(currentRuleRanges), useEffect(() => {
    const disposable = commandService.onCommandExecuted((commandInfo) => {
      commandInfo.id === SetWorksheetActiveOperation.id && fetchRuleListIdSet(Math.random());
    });
    return () => disposable.dispose();
  }), useEffect(() => {
    ruleListSet(getRuleList);
  }, [selectValue, fetchRuleListId, unitId, subUnitId]), useEffect(() => {
    if (selectValue === "2")
      return;
    const subscription = new Observable((commandSubscribe) => {
      const commandList2 = [SetSelectionsOperation.id, AddConditionalRuleMutation.id, SetConditionalRuleMutation.id, DeleteConditionalRuleMutation.id, MoveConditionalRuleMutation.id], disposable = commandService.onCommandExecuted((commandInfo) => {
        const { id, params } = commandInfo, unitId2 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId();
        commandList2.includes(id) && params.unitId === unitId2 && commandSubscribe.next(null);
      });
      return () => disposable.dispose();
    }).pipe(debounceTime(16)).subscribe(() => {
      ruleListSet(getRuleList);
    });
    return () => {
      subscription.unsubscribe();
    };
  }, [univerInstanceService, selectValue, unitId, subUnitId]), useEffect(() => {
    const dispose = conditionalFormattingRuleModel.$ruleChange.subscribe(() => {
      fetchRuleListIdSet(Math.random());
    });
    return () => dispose.unsubscribe();
  }, [conditionalFormattingRuleModel]), useEffect(() => {
    const getWidth = /* @__PURE__ */ __name(() => {
      var _a15;
      const width = Math.max(0, (((_a15 = layoutContainerRef.current) == null ? void 0 : _a15.getBoundingClientRect().width) || 0) - 8);
      return defaultWidth = width, width;
    }, "getWidth"), subscription = new Observable((subscribe) => {
      const targetElement = document.querySelector(".univer-sidebar");
      if (targetElement) {
        let time = setTimeout(() => {
          subscribe.next();
        }, 150);
        const clearTime = /* @__PURE__ */ __name(() => {
          time && clearTimeout(time), time = null;
        }, "clearTime"), handle = /* @__PURE__ */ __name((e) => {
          e.propertyName === "width" && (clearTime(), subscribe.next());
        }, "handle");
        return targetElement.addEventListener("transitionend", handle), () => {
          clearTime(), targetElement.removeEventListener("transitionend", handle);
        };
      }
    }).pipe(debounceTime(16)).subscribe(() => {
      layoutWidthSet(getWidth());
    });
    return () => {
      subscription.unsubscribe();
    };
  }, []);
  const handleDelete = /* @__PURE__ */ __name((rule) => {
    var _a15;
    const unitId2 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId(), subUnitId2 = (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet()) == null ? void 0 : _a15.getSheetId();
    if (!unitId2 || !subUnitId2)
      throw new Error("No active sheet found");
    commandService.executeCommand(DeleteCfCommand.id, { unitId: unitId2, subUnitId: subUnitId2, cfId: rule.cfId });
  }, "handleDelete"), handleDragStart = /* @__PURE__ */ __name((_layout, from) => {
    draggingIdSet(from.y);
  }, "handleDragStart"), handleDragStop = /* @__PURE__ */ __name((_layout, from, to) => {
    var _a15;
    draggingIdSet(-1);
    const unitId2 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId(), subUnitId2 = (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet()) == null ? void 0 : _a15.getSheetId();
    if (!unitId2 || !subUnitId2)
      throw new Error("No active sheet found");
    const getSaveIndex = /* @__PURE__ */ __name((index2) => {
      const length = ruleList.length;
      return Math.min(length - 1, Math.max(0, index2));
    }, "getSaveIndex"), cfId = ruleList[getSaveIndex(from.y)].cfId, targetCfId = ruleList[getSaveIndex(to.y)].cfId;
    cfId !== targetCfId && commandService.executeCommand(MoveCfCommand.id, { unitId: unitId2, subUnitId: subUnitId2, start: { id: cfId, type: "self" }, end: { id: targetCfId, type: to.y > from.y ? "after" : "before" } });
  }, "handleDragStop"), handleCreate = /* @__PURE__ */ __name(() => {
    props.onCreate();
  }, "handleCreate"), handleClear = /* @__PURE__ */ __name(() => {
    selectValue === "2" ? commandService.executeCommand(ClearWorksheetCfCommand.id) : selectValue === "1" && ruleList.map((rule) => ({ unitId, subUnitId, cfId: rule.cfId })).forEach((config) => {
      commandService.executeCommand(DeleteCfCommand.id, config);
    });
  }, "handleClear"), ruleListByPermissionCheck = useMemo(() => {
    const workbook2 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), worksheet2 = workbook2.getActiveSheet();
    return ruleList.filter((rule) => {
      const ranges = rule.ranges;
      return checkRangesEditablePermission(injector, workbook2.getUnitId(), worksheet2.getSheetId(), ranges);
    });
  }, [ruleList]), layout = ruleListByPermissionCheck.map((rule, index2) => ({ i: rule.cfId, x: 0, w: 12, y: index2, h: 1, isResizable: !1 })), isHasAllRuleEditPermission = useMemo(() => {
    const workbook2 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), worksheet2 = workbook2.getActiveSheet();
    return ruleList.every((rule) => {
      const ranges = rule.ranges;
      return checkRangesEditablePermission(injector, workbook2.getUnitId(), worksheet2.getSheetId(), ranges);
    });
  }, [ruleList]);
  return /* @__PURE__ */ jsxs("div", { className: styles$3.cfRuleList, children: [
    /* @__PURE__ */ jsxs("div", { className: styles$3.ruleSelector, children: [
      /* @__PURE__ */ jsx("div", { children: conditionalFormattingI18nController.tWithReactNode(
        "sheet.cf.panel.managerRuleSelect",
        /* @__PURE__ */ jsx(Select, { className: styles$3.select, options: selectOption, value: selectValue, onChange: /* @__PURE__ */ __name((v) => {
          selectValueSet(v);
        }, "onChange") })
      ).map((ele, index2) => /* @__PURE__ */ jsx("span", { children: ele }, index2)) }),
      /* @__PURE__ */ jsxs("div", { className: styles$3.btnList, children: [
        /* @__PURE__ */ jsx(Tooltip, { title: localeService.t("sheet.cf.panel.createRule"), placement: "bottom", children: /* @__PURE__ */ jsx(
          "div",
          {
            className: `
                              ${styles$3.icon}
                            `,
            onClick: handleCreate,
            children: /* @__PURE__ */ jsx(IncreaseSingle, {})
          }
        ) }),
        ruleList.length && isHasAllRuleEditPermission ? /* @__PURE__ */ jsx(Tooltip, { title: localeService.t("sheet.cf.panel.clear"), placement: "bottom", children: /* @__PURE__ */ jsx(
          "div",
          {
            className: `
                                      ${styles$3.gap}
                                      ${styles$3.icon}
                                    `,
            onClick: handleClear,
            children: /* @__PURE__ */ jsx(DeleteSingle, {})
          }
        ) }) : /* @__PURE__ */ jsx(
          "div",
          {
            className: `
                              ${styles$3.gap}
                              ${styles$3.disabled}
                            `,
            children: /* @__PURE__ */ jsx(DeleteSingle, {})
          }
        )
      ] })
    ] }),
    /* @__PURE__ */ jsx("div", { ref: layoutContainerRef, className: styles$3.gridLayoutWrap, children: layoutWidth ? /* @__PURE__ */ jsx(
      GridLayout,
      {
        onDragStop: handleDragStop,
        onDragStart: handleDragStart,
        layout,
        cols: 12,
        rowHeight: 60,
        width: layoutWidth,
        margin: [0, 10],
        draggableHandle: ".draggableHandle",
        children: ruleListByPermissionCheck == null ? void 0 : ruleListByPermissionCheck.map((rule, index2) => /* @__PURE__ */ jsx("div", { children: /* @__PURE__ */ jsxs(
          "div",
          {
            onMouseMove: /* @__PURE__ */ __name(() => {
              rule.ranges !== currentRuleRanges && currentRuleRangesSet(rule.ranges);
            }, "onMouseMove"),
            onMouseLeave: /* @__PURE__ */ __name(() => currentRuleRangesSet([]), "onMouseLeave"),
            onClick: /* @__PURE__ */ __name(() => {
              onClick(rule);
            }, "onClick"),
            className: `
                                              ${styles$3.ruleItem}
                                              ${draggingId === index2 ? styles$3.active : ""}
                                            `,
            children: [
              /* @__PURE__ */ jsx(
                "div",
                {
                  className: `
                                                  ${styles$3.draggableHandle}
                                                  draggableHandle
                                                `,
                  onClick: /* @__PURE__ */ __name((e) => e.stopPropagation(), "onClick"),
                  children: /* @__PURE__ */ jsx(SequenceSingle, {})
                }
              ),
              /* @__PURE__ */ jsxs("div", { className: styles$3.ruleDescribe, children: [
                /* @__PURE__ */ jsx("div", { className: styles$3.ruleType, children: getRuleDescribe(rule, localeService) }),
                /* @__PURE__ */ jsx("div", { className: styles$3.ruleRange, children: rule.ranges.map((range) => serializeRange(range)).join(",") })
              ] }),
              /* @__PURE__ */ jsx("div", { className: styles$3.preview, children: /* @__PURE__ */ jsx(Preview, { rule: rule.rule }) }),
              /* @__PURE__ */ jsx(
                "div",
                {
                  className: `
                                                  ${styles$3.deleteItem}
                                                  ${draggingId === index2 ? styles$3.active : ""}
                                                `,
                  onClick: /* @__PURE__ */ __name((e) => {
                    e.stopPropagation(), handleDelete(rule), currentRuleRangesSet([]);
                  }, "onClick"),
                  children: /* @__PURE__ */ jsx(DeleteSingle, {})
                }
              )
            ]
          }
        ) }, `${rule.cfId}`))
      }
    ) : null })
  ] });
}, "RuleList"), cfColorPicker = "univer-cf-color-picker", cfColorPickerIcon = "univer-cf-color-picker-icon", iconDropdown = "univer-icon-dropdown", styles$2 = {
  cfColorPicker,
  cfColorPickerIcon,
  iconDropdown
}, ColorPicker = /* @__PURE__ */ __name((props) => {
  const { color, onChange, disable = !1, iconId = "PaintBucket", className, isNeedDropdownIcon = !0 } = props, componentManager = useDependency(ComponentManager), colorKit = useMemo(() => new ColorKit(color), [color]), Icon = componentManager.get(iconId);
  return Icon && (disable ? /* @__PURE__ */ jsx(Icon, { className, extend: { colorChannel1: colorKit.isValid ? color : "rgb(var(--primary-color))" } }) : /* @__PURE__ */ jsx(
    DropdownLegacy,
    {
      overlay: /* @__PURE__ */ jsx(
        "div",
        {
          className: `
                      ${styles$2.cfColorPicker}
                    `,
          children: /* @__PURE__ */ jsx(ColorPicker$1, { value: color, onChange })
        }
      ),
      children: /* @__PURE__ */ jsxs(
        "span",
        {
          className: `
                  ${styles$2.cfColorPickerIcon}
                  ${className}
                `,
          children: [
            /* @__PURE__ */ jsx(Icon, { extend: { colorChannel1: colorKit.isValid ? color : "rgb(var(--primary-color))" } }),
            isNeedDropdownIcon && /* @__PURE__ */ jsx(MoreDownSingle, { className: styles$2.iconDropdown })
          ]
        }
      )
    }
  ));
}, "ColorPicker"), cfRuleStyleEditor = "univer-cf-rule-style-editor", cfPreviewWrap = "univer-cf-preview-wrap", text = "univer-text", positionRelative = "univer-position-relative", btnList = "univer-btn-list", utilItem = "univer-util-item", iconSet = "univer-icon-set", renderConfig = "univer-render-config", flex = "univer-flex", width45 = "univer-width45", iconWrap = "univer-icon-wrap", icon = "univer-icon", dropdownIcon = "univer-dropdown-icon", errorInput = "univer-error-input", errorText = "univer-error-text", iconGroupList = "univer-icon-group-list", title = "univer-title", group = "univer-group", itemContent = "univer-item-content", itemWrap = "univer-item-wrap", item = "univer-item", iconItemListWrap = "univer-icon-item-list-wrap", none = "univer-none", iconItemList = "univer-icon-item-list", width100 = "univer-width100", stress = "univer-stress", styles$1 = {
  cfRuleStyleEditor,
  cfPreviewWrap,
  text,
  positionRelative,
  btnList,
  utilItem,
  iconSet,
  renderConfig,
  flex,
  width45,
  iconWrap,
  icon,
  dropdownIcon,
  errorInput,
  errorText,
  iconGroupList,
  title,
  group,
  itemContent,
  itemWrap,
  item,
  iconItemListWrap,
  none,
  iconItemList,
  width100,
  stress
}, createOptionItem$2 = /* @__PURE__ */ __name((text2, localeService) => ({ label: localeService.t(`sheet.cf.valueType.${text2}`), value: text2 }), "createOptionItem$2"), TextInput$1 = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { type, className, onChange, id, value } = props, univerInstanceService = useDependency(IUniverInstanceService), unitId = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId(), subUnitId = (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet()) == null ? void 0 : _a15.getSheetId(), formulaInitValue = useMemo(() => String(value).startsWith("=") ? String(value) : "=", [value]), config = useMemo(() => [CFValueType.max, CFValueType.min, "none"].includes(type) ? { disabled: !0 } : [CFValueType.percent, CFValueType.percentile].includes(type) ? {
    min: 0,
    max: 100
  } : {
    min: Number.MIN_SAFE_INTEGER,
    max: Number.MAX_SAFE_INTEGER
  }, [type]), formulaEditorActionsRef = useRef({}), [isFocusFormulaEditor, isFocusFormulaEditorSet] = useState(!1);
  return useSidebarClick((e) => {
    var _a16;
    const handleOutClick = (_a16 = formulaEditorActionsRef.current) == null ? void 0 : _a16.handleOutClick;
    handleOutClick && handleOutClick(e, () => isFocusFormulaEditorSet(!1));
  }), type === CFValueType.formula ? /* @__PURE__ */ jsx("div", { style: { width: "100%", marginLeft: 4 }, children: /* @__PURE__ */ jsx(
    FormulaEditor,
    {
      initValue: formulaInitValue,
      unitId,
      subUnitId,
      isFocus: isFocusFormulaEditor,
      onChange: /* @__PURE__ */ __name((v = "") => {
        onChange(v || "");
      }, "onChange"),
      onFocus: /* @__PURE__ */ __name(() => isFocusFormulaEditorSet(!0), "onFocus"),
      actions: formulaEditorActionsRef.current
    }
  ) }) : /* @__PURE__ */ jsx(InputNumber, { className, value: Number(props.value) || 0, onChange: /* @__PURE__ */ __name((v) => props.onChange(v || 0), "onChange"), ...config });
}, "TextInput$1"), ColorScaleStyleEditor = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { interceptorManager } = props, localeService = useDependency(LocaleService), rule = ((_a15 = props.rule) == null ? void 0 : _a15.type) === CFRuleType.colorScale ? props.rule : void 0, commonOptions = [createOptionItem$2(CFValueType.num, localeService), createOptionItem$2(CFValueType.percent, localeService), createOptionItem$2(CFValueType.percentile, localeService), createOptionItem$2(CFValueType.formula, localeService)], minOptions = [createOptionItem$2(CFValueType.min, localeService), ...commonOptions], medianOptions = [createOptionItem$2("none", localeService), ...commonOptions], maxOptions = [createOptionItem$2(CFValueType.max, localeService), ...commonOptions], [minType, minTypeSet] = useState(() => {
    var _a16;
    const defaultV = CFValueType.min;
    return rule && ((_a16 = rule.config[0]) == null ? void 0 : _a16.value.type) || defaultV;
  }), [medianType, medianTypeSet] = useState(() => {
    var _a16;
    const defaultV = "none";
    return !rule || rule.config.length !== 3 ? defaultV : ((_a16 = rule.config[1]) == null ? void 0 : _a16.value.type) || defaultV;
  }), [maxType, maxTypeSet] = useState(() => {
    var _a16;
    const defaultV = CFValueType.max;
    return rule && ((_a16 = rule.config[rule.config.length - 1]) == null ? void 0 : _a16.value.type) || defaultV;
  }), [minValue, minValueSet] = useState(() => {
    if (!rule)
      return 10;
    const valueConfig = rule.config[0];
    return (valueConfig == null ? void 0 : valueConfig.value.value) === void 0 ? 10 : valueConfig == null ? void 0 : valueConfig.value.value;
  }), [medianValue, medianValueSet] = useState(() => {
    var _a16;
    if (!rule || rule.config.length !== 3)
      return 50;
    const v = (_a16 = rule.config[1]) == null ? void 0 : _a16.value.value;
    return v === void 0 ? 50 : v;
  }), [maxValue, maxValueSet] = useState(() => {
    var _a16;
    if (!rule)
      return 90;
    const v = (_a16 = rule.config[rule.config.length - 1]) == null ? void 0 : _a16.value.value;
    return v === void 0 ? 90 : v;
  }), [minColor, minColorSet] = useState(() => {
    var _a16;
    const defaultV = "#d0d9fb";
    return rule && ((_a16 = rule.config[0]) == null ? void 0 : _a16.color) || defaultV;
  }), [medianColor, medianColorSet] = useState(() => {
    var _a16;
    const defaultV = "#7790f3";
    return !rule || rule.config.length !== 3 ? defaultV : ((_a16 = rule.config[1]) == null ? void 0 : _a16.color) || defaultV;
  }), [maxColor, maxColorSet] = useState(() => {
    var _a16;
    const defaultV = "#2e55ef";
    return rule && ((_a16 = rule.config[rule.config.length - 1]) == null ? void 0 : _a16.color) || defaultV;
  }), getResult = useMemo(() => (option) => {
    const {
      minType: minType2,
      medianType: medianType2,
      maxType: maxType2,
      minValue: minValue2,
      medianValue: medianValue2,
      maxValue: maxValue2,
      minColor: minColor2,
      medianColor: medianColor2,
      maxColor: maxColor2
    } = option, list = [];
    return list.push({ color: minColor2, value: { type: minType2, value: minValue2 } }), medianType2 !== "none" && list.push({ color: medianColor2, value: { type: medianType2, value: medianValue2 } }), list.push({ color: maxColor2, value: { type: maxType2, value: maxValue2 } }), { config: list.map((item2, index2) => ({ ...item2, index: index2 })), type: CFRuleType.colorScale };
  }, []);
  useEffect(() => interceptorManager.intercept(interceptorManager.getInterceptPoints().submit, {
    handler() {
      return getResult({ minType, medianType, maxType, minValue, medianValue, maxValue, minColor, medianColor, maxColor });
    }
  }), [getResult, minType, medianType, maxType, minValue, medianValue, maxValue, minColor, medianColor, maxColor, interceptorManager]);
  const handleChange = /* @__PURE__ */ __name((option) => {
    props.onChange(getResult(option));
  }, "handleChange");
  return /* @__PURE__ */ jsxs("div", { children: [
    /* @__PURE__ */ jsx("div", { className: styles$5.title, children: localeService.t("sheet.cf.panel.styleRule") }),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$1.cfPreviewWrap}
            `,
        children: /* @__PURE__ */ jsx(Preview, { rule: getResult({ minType, medianType, maxType, minValue, medianValue, maxValue, minColor, medianColor, maxColor }) })
      }
    ),
    /* @__PURE__ */ jsx("div", { className: styles$5.label, children: localeService.t("sheet.cf.valueType.min") }),
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: `
              ${styles$5.labelContainer}
              ${styles$5.mTSm}
            `,
        children: [
          /* @__PURE__ */ jsx(
            Select,
            {
              style: { flexShrink: 0 },
              options: minOptions,
              value: minType,
              onChange: /* @__PURE__ */ __name((v) => {
                minTypeSet(v);
                const value = createDefaultValueByValueType(v, 10);
                minValueSet(value), handleChange({ minType: v, medianType, maxType, minValue: value, medianValue, maxValue, minColor, medianColor, maxColor });
              }, "onChange")
            }
          ),
          /* @__PURE__ */ jsx(
            TextInput$1,
            {
              id: "min",
              className: `
                      ${styles$5.mLXxs}
                    `,
              value: minValue,
              type: minType,
              onChange: /* @__PURE__ */ __name((v) => {
                minValueSet(v), handleChange({ minType, medianType, maxType, minValue: v, medianValue, maxValue, minColor, medianColor, maxColor });
              }, "onChange")
            }
          ),
          /* @__PURE__ */ jsx(
            ColorPicker,
            {
              className: styles$5.mLXxs,
              color: minColor,
              onChange: /* @__PURE__ */ __name((v) => {
                minColorSet(v), handleChange({ minType, medianType, maxType, minValue, medianValue, maxValue, minColor: v, medianColor, maxColor });
              }, "onChange")
            }
          )
        ]
      }
    ),
    /* @__PURE__ */ jsx("div", { className: styles$5.label, children: localeService.t("sheet.cf.panel.medianValue") }),
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: `
              ${styles$5.labelContainer}
              ${styles$5.mTSm}
            `,
        children: [
          /* @__PURE__ */ jsx(
            Select,
            {
              style: { flexShrink: 0 },
              options: medianOptions,
              value: medianType,
              onChange: /* @__PURE__ */ __name((v) => {
                medianTypeSet(v);
                const value = createDefaultValueByValueType(v, 50);
                medianValueSet(value), handleChange({ minType, medianType: v, maxType, minValue, medianValue: value, maxValue, minColor, medianColor, maxColor });
              }, "onChange")
            }
          ),
          /* @__PURE__ */ jsx(
            TextInput$1,
            {
              id: "median",
              className: `
                      ${styles$5.mLXxs}
                    `,
              value: medianValue,
              type: medianType,
              onChange: /* @__PURE__ */ __name((v) => {
                medianValueSet(v), handleChange({ minType, medianType, maxType, minValue, medianValue: v, maxValue, minColor, medianColor, maxColor });
              }, "onChange")
            }
          ),
          medianType !== "none" && /* @__PURE__ */ jsx(
            ColorPicker,
            {
              className: styles$5.mLXxs,
              color: medianColor,
              onChange: /* @__PURE__ */ __name((v) => {
                medianColorSet(v), handleChange({ minType, medianType, maxType, minValue, medianValue, maxValue, minColor, medianColor: v, maxColor });
              }, "onChange")
            }
          )
        ]
      }
    ),
    /* @__PURE__ */ jsx("div", { className: styles$5.label, children: localeService.t("sheet.cf.valueType.max") }),
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: `
              ${styles$5.labelContainer}
              ${styles$5.mTSm}
            `,
        children: [
          /* @__PURE__ */ jsx(
            Select,
            {
              style: { flexShrink: 0 },
              options: maxOptions,
              value: maxType,
              onChange: /* @__PURE__ */ __name((v) => {
                maxTypeSet(v);
                const value = createDefaultValueByValueType(v, 90);
                maxValueSet(value), handleChange({ minType, medianType, maxType: v, minValue, medianValue, maxValue: value, minColor, medianColor, maxColor });
              }, "onChange")
            }
          ),
          /* @__PURE__ */ jsx(
            TextInput$1,
            {
              id: "max",
              className: `
                      ${styles$5.mLXxs}
                    `,
              value: maxValue,
              type: maxType,
              onChange: /* @__PURE__ */ __name((v) => {
                maxValueSet(v), handleChange({ minType, medianType, maxType, minValue, medianValue, maxValue: v, minColor, medianColor, maxColor });
              }, "onChange")
            }
          ),
          /* @__PURE__ */ jsx(
            ColorPicker,
            {
              className: styles$5.mLXxs,
              color: maxColor,
              onChange: /* @__PURE__ */ __name((v) => {
                maxColorSet(v), handleChange({ minType, medianType, maxType, minValue, medianValue, maxValue, minColor, medianColor, maxColor: v });
              }, "onChange")
            }
          )
        ]
      }
    )
  ] });
}, "ColorScaleStyleEditor"), createOptionItem$1 = /* @__PURE__ */ __name((text2, localeService) => ({ label: localeService.t(`sheet.cf.valueType.${text2}`), value: text2 }), "createOptionItem$1"), InputText = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { onChange, className, value, type, id, disabled: disabled2 = !1 } = props, univerInstanceService = useDependency(IUniverInstanceService), unitId = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId(), subUnitId = (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet()) == null ? void 0 : _a15.getSheetId(), formulaEditorActionsRef = useRef({}), [isFocusFormulaEditor, isFocusFormulaEditorSet] = useState(!1);
  useSidebarClick((e) => {
    var _a16;
    const handleOutClick = (_a16 = formulaEditorActionsRef.current) == null ? void 0 : _a16.handleOutClick;
    handleOutClick && handleOutClick(e, () => isFocusFormulaEditorSet(!1));
  });
  const _value = useRef(value), config = useMemo(() => [CFValueType.percentile, CFValueType.percent].includes(type) ? {
    max: 100,
    min: 0
  } : {
    min: Number.MIN_SAFE_INTEGER,
    max: Number.MAX_SAFE_INTEGER
  }, [type]);
  if (type === CFValueType.formula) {
    const v = String(_value.current).startsWith("=") ? String(_value.current) || "" : "=";
    return /* @__PURE__ */ jsx("div", { style: { width: "100%", marginLeft: 12 }, children: /* @__PURE__ */ jsx(
      FormulaEditor,
      {
        initValue: v,
        unitId,
        subUnitId,
        isFocus: isFocusFormulaEditor,
        onChange: /* @__PURE__ */ __name((v2 = "") => {
          onChange(v2 || "");
        }, "onChange"),
        onFocus: /* @__PURE__ */ __name(() => isFocusFormulaEditorSet(!0), "onFocus"),
        actions: formulaEditorActionsRef.current
      }
    ) });
  }
  return /* @__PURE__ */ jsx(
    InputNumber,
    {
      className,
      value: Number(value) || 0,
      disabled: disabled2,
      onChange: /* @__PURE__ */ __name((v) => {
        onChange(v || 0);
      }, "onChange"),
      ...config
    }
  );
}, "InputText"), DataBarStyleEditor = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { interceptorManager } = props, localeService = useDependency(LocaleService), rule = ((_a15 = props.rule) == null ? void 0 : _a15.type) === CFRuleType.dataBar ? props.rule : void 0, [isGradient, isGradientSet] = useState(() => {
    var _a16;
    const defaultV = "0";
    return rule ? (_a16 = rule.config) != null && _a16.isGradient ? "1" : "0" : defaultV;
  }), [positiveColor, positiveColorSet] = useState(() => {
    var _a16;
    return rule ? ((_a16 = rule.config) == null ? void 0 : _a16.positiveColor) || defaultDataBarPositiveColor : defaultDataBarPositiveColor;
  }), [nativeColor, nativeColorSet] = useState(() => {
    var _a16;
    return rule ? ((_a16 = rule.config) == null ? void 0 : _a16.nativeColor) || defaultDataBarNativeColor : defaultDataBarNativeColor;
  }), commonOptions = [createOptionItem$1(CFValueType.num, localeService), createOptionItem$1(CFValueType.percent, localeService), createOptionItem$1(CFValueType.percentile, localeService), createOptionItem$1(CFValueType.formula, localeService)], minOptions = [createOptionItem$1(CFValueType.min, localeService), ...commonOptions], maxOptions = [createOptionItem$1(CFValueType.max, localeService), ...commonOptions], [minValueType, minValueTypeSet] = useState(() => {
    var _a16;
    const defaultV = minOptions[0].value;
    return rule && ((_a16 = rule.config) == null ? void 0 : _a16.min.type) || defaultV;
  }), [maxValueType, maxValueTypeSet] = useState(() => {
    var _a16;
    const defaultV = maxOptions[0].value;
    return rule && ((_a16 = rule.config) == null ? void 0 : _a16.max.type) || defaultV;
  }), [minValue, minValueSet] = useState(() => {
    var _a16;
    if (!rule)
      return 0;
    const value = ((_a16 = rule.config) == null ? void 0 : _a16.min) || {};
    return value.type === CFValueType.formula ? value.value || "=" : value.value || 0;
  }), [maxValue, maxValueSet] = useState(() => {
    var _a16;
    if (!rule)
      return 100;
    const value = ((_a16 = rule.config) == null ? void 0 : _a16.max) || {};
    return value.type === CFValueType.formula ? value.value || "=" : value.value === void 0 ? 100 : value.value;
  }), [isShowValue, isShowValueSet] = useState(() => rule ? rule.isShowValue === void 0 ? !0 : !!rule.isShowValue : !0), getResult = /* @__PURE__ */ __name((option) => ({ config: {
    min: { type: option.minValueType, value: option.minValue },
    max: { type: option.maxValueType, value: option.maxValue },
    isGradient: option.isGradient === "1",
    positiveColor: option.positiveColor || defaultDataBarPositiveColor,
    nativeColor: option.nativeColor || defaultDataBarNativeColor
  }, type: CFRuleType.dataBar, isShowValue: option.isShowValue }), "getResult");
  useEffect(() => interceptorManager.intercept(interceptorManager.getInterceptPoints().submit, {
    handler() {
      return getResult({ isGradient, minValue, minValueType, maxValue, maxValueType, positiveColor, nativeColor, isShowValue });
    }
  }), [isGradient, minValue, minValueType, maxValue, maxValueType, positiveColor, nativeColor, interceptorManager, isShowValue]);
  const _handleChange = /* @__PURE__ */ __name((option) => {
    props.onChange(getResult(option));
  }, "_handleChange"), handlePositiveColorChange = /* @__PURE__ */ __name((color) => {
    positiveColorSet(color), _handleChange({ isGradient, minValue, minValueType, maxValue, maxValueType, positiveColor: color, nativeColor, isShowValue });
  }, "handlePositiveColorChange"), handleNativeColorChange = /* @__PURE__ */ __name((color) => {
    nativeColorSet(color), _handleChange({ isGradient, minValue, minValueType, maxValue, maxValueType, positiveColor, nativeColor: color, isShowValue });
  }, "handleNativeColorChange"), isShowInput = /* @__PURE__ */ __name((type) => commonOptions.map((item2) => item2.value).includes(type), "isShowInput");
  return /* @__PURE__ */ jsxs("div", { children: [
    /* @__PURE__ */ jsx("div", { className: styles$5.title, children: localeService.t("sheet.cf.panel.styleRule") }),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$1.cfPreviewWrap}
            `,
        children: /* @__PURE__ */ jsx(Preview, { rule: getResult({ isGradient, minValue, minValueType, maxValue, maxValueType, positiveColor, nativeColor, isShowValue }) })
      }
    ),
    /* @__PURE__ */ jsxs("div", { children: [
      /* @__PURE__ */ jsx("div", { className: styles$5.label, children: localeService.t("sheet.cf.panel.fillType") }),
      /* @__PURE__ */ jsxs(
        "div",
        {
          className: `
                  ${styles$5.mTSm}
                  ${styles$5.mLXxs}
                  ${styles$5.labelContainer}
                `,
          children: [
            /* @__PURE__ */ jsxs(
              RadioGroup,
              {
                value: isGradient,
                onChange: /* @__PURE__ */ __name((v) => {
                  isGradientSet(v), _handleChange({ isGradient: v, minValue, minValueType, maxValue, maxValueType, positiveColor, nativeColor, isShowValue });
                }, "onChange"),
                children: [
                  /* @__PURE__ */ jsx(Radio, { value: "0", children: /* @__PURE__ */ jsx("span", { className: styles$1.text, children: localeService.t("sheet.cf.panel.pureColor") }) }),
                  /* @__PURE__ */ jsx(Radio, { value: "1", children: /* @__PURE__ */ jsx("span", { className: styles$1.text, children: localeService.t("sheet.cf.panel.gradient") }) })
                ]
              }
            ),
            /* @__PURE__ */ jsxs(
              "div",
              {
                className: `
                      ${styles$1.utilItem}
                      ${styles$5.mLXl}
                    `,
                children: [
                  /* @__PURE__ */ jsx(
                    Checkbox,
                    {
                      checked: !isShowValue,
                      onChange: /* @__PURE__ */ __name((v) => {
                        isShowValueSet(!v), _handleChange({ isGradient: v, minValue, minValueType, maxValue, maxValueType, positiveColor, nativeColor, isShowValue: !v });
                      }, "onChange")
                    }
                  ),
                  localeService.t("sheet.cf.panel.onlyShowDataBar")
                ]
              }
            )
          ]
        }
      )
    ] }),
    /* @__PURE__ */ jsxs("div", { children: [
      /* @__PURE__ */ jsx("div", { className: styles$5.label, children: localeService.t("sheet.cf.panel.colorSet") }),
      /* @__PURE__ */ jsxs(
        "div",
        {
          className: `
                  ${styles$5.labelContainer}
                  ${styles$5.mTSm}
                  ${styles$5.mLXxs}
                `,
          children: [
            /* @__PURE__ */ jsxs(
              "div",
              {
                className: `
                      ${styles$5.labelContainer}
                    `,
                children: [
                  /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: `
                          ${styles$1.text}
                        `,
                      children: localeService.t("sheet.cf.panel.native")
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    ColorPicker,
                    {
                      color: nativeColor,
                      onChange: handleNativeColorChange
                    }
                  )
                ]
              }
            ),
            /* @__PURE__ */ jsxs(
              "div",
              {
                className: `
                      ${styles$5.labelContainer}
                      ${styles$5.mLSm}
                    `,
                children: [
                  /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: `
                          ${styles$1.text}
                        `,
                      children: localeService.t("sheet.cf.panel.positive")
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    ColorPicker,
                    {
                      color: positiveColor,
                      onChange: handlePositiveColorChange
                    }
                  )
                ]
              }
            )
          ]
        }
      )
    ] }),
    /* @__PURE__ */ jsxs("div", { children: [
      /* @__PURE__ */ jsx("div", { className: styles$5.label, children: localeService.t("sheet.cf.valueType.min") }),
      /* @__PURE__ */ jsxs(
        "div",
        {
          className: `
                  ${styles$5.mTSm}
                  ${styles$5.labelContainer}
                `,
          children: [
            /* @__PURE__ */ jsx(
              Select,
              {
                style: { width: "50%", flexShrink: 0 },
                options: minOptions,
                value: minValueType,
                onChange: /* @__PURE__ */ __name((v) => {
                  minValueTypeSet(v);
                  const value = createDefaultValueByValueType(v, 10);
                  minValueSet(value), _handleChange({ isGradient, minValue: value, minValueType: v, maxValue, maxValueType, positiveColor, nativeColor, isShowValue });
                }, "onChange")
              }
            ),
            /* @__PURE__ */ jsx(
              InputText,
              {
                disabled: !isShowInput(minValueType),
                id: "min",
                type: minValueType,
                className: styles$5.mLSm,
                value: minValue,
                onChange: /* @__PURE__ */ __name((v) => {
                  minValueSet(v || 0), _handleChange({ isGradient, minValue: v || 0, minValueType, maxValue, maxValueType, positiveColor, nativeColor, isShowValue });
                }, "onChange")
              }
            )
          ]
        }
      ),
      /* @__PURE__ */ jsx("div", { className: styles$5.label, children: localeService.t("sheet.cf.valueType.max") }),
      /* @__PURE__ */ jsxs(
        "div",
        {
          className: `
                  ${styles$5.mTSm}
                  ${styles$5.labelContainer}
                `,
          children: [
            /* @__PURE__ */ jsx(
              Select,
              {
                style: { width: "50%", flexShrink: 0 },
                options: maxOptions,
                value: maxValueType,
                onChange: /* @__PURE__ */ __name((v) => {
                  maxValueTypeSet(v);
                  const value = createDefaultValueByValueType(v, 90);
                  maxValueSet(value), _handleChange({ isGradient, minValue, minValueType, maxValue: value, maxValueType: v, positiveColor, nativeColor, isShowValue });
                }, "onChange")
              }
            ),
            /* @__PURE__ */ jsx(
              InputText,
              {
                disabled: !isShowInput(maxValueType),
                id: "max",
                type: maxValueType,
                className: styles$5.mLSm,
                value: maxValue,
                onChange: /* @__PURE__ */ __name((v) => {
                  maxValueSet(v || 0), _handleChange({ isGradient, minValue, minValueType, maxValue: v || 0, maxValueType, positiveColor, nativeColor, isShowValue });
                }, "onChange")
              }
            )
          ]
        }
      )
    ] })
  ] });
}, "DataBarStyleEditor");
function r(e) {
  var t, f, n = "";
  if (typeof e == "string" || typeof e == "number") n += e;
  else if (typeof e == "object") if (Array.isArray(e)) {
    var o = e.length;
    for (t = 0; t < o; t++) e[t] && (f = r(e[t])) && (n && (n += " "), n += f);
  } else for (f in e) e[f] && (n && (n += " "), n += f);
  return n;
}
__name(r, "r");
function clsx() {
  for (var e, t, f = 0, n = "", o = arguments.length; f < o; f++) (e = arguments[f]) && (t = r(e)) && (n && (n += " "), n += t);
  return n;
}
__name(clsx, "clsx");
const cfStyleEdit = "univer-cf-style-edit", buttonItem = "univer-button-item", isActive = "univer-isActive", styles = {
  cfStyleEdit,
  buttonItem,
  isActive
}, getAnotherBooleanNumber = /* @__PURE__ */ __name((v) => [BooleanNumber.FALSE, void 0].includes(v) ? BooleanNumber.TRUE : BooleanNumber.FALSE, "getAnotherBooleanNumber"), getBooleanFromNumber = /* @__PURE__ */ __name((v) => v !== BooleanNumber.FALSE, "getBooleanFromNumber"), ConditionalStyleEditor = /* @__PURE__ */ __name((props) => {
  const { style, onChange, className } = props, componentManager = useDependency(ComponentManager), [isBold, isBoldSet] = useState(() => {
    if (style != null && style.bl)
      return style.bl;
  }), [isItalic, isItalicSet] = useState(() => {
    if (style != null && style.it)
      return style.it;
  }), [isUnderline, isUnderlineSet] = useState(() => {
    if (style != null && style.ul)
      return style.ul.s;
  }), [isStrikethrough, isStrikethroughSet] = useState(() => {
    if (style != null && style.st)
      return style.st.s;
  }), [fontColor, fontColorSet] = useState(() => {
    var _a15;
    const defaultV = "#2f56ef";
    return (_a15 = style == null ? void 0 : style.cl) != null && _a15.rgb ? style.cl.rgb : defaultV;
  }), [bgColor, bgColorSet] = useState(() => {
    var _a15;
    const defaultV = "#e8ecfc";
    return (_a15 = style == null ? void 0 : style.bg) != null && _a15.rgb ? style.bg.rgb : defaultV;
  }), BoldSingleIcon = componentManager.get("BoldSingle"), ItalicSingleIcon = componentManager.get("ItalicSingle"), UnderlineSingleIcon = componentManager.get("UnderlineSingle"), StrikethroughSingle = componentManager.get("StrikethroughSingle");
  return useEffect(() => {
    const resultStyle = {
      bl: isBold,
      it: isItalic
    };
    fontColor !== void 0 && (resultStyle.cl = { rgb: fontColor }), bgColor !== void 0 && (resultStyle.bg = { rgb: bgColor }), isStrikethrough !== void 0 && (resultStyle.st = { s: isStrikethrough }), isUnderline !== void 0 && (resultStyle.ul = { s: isUnderline }), onChange(removeUndefinedAttr(resultStyle));
  }, [isBold, isItalic, isUnderline, isStrikethrough, fontColor, bgColor]), /* @__PURE__ */ jsxs(
    "div",
    {
      className: `
          ${styles.cfStyleEdit}
          ${className}
        `,
      children: [
        BoldSingleIcon && /* @__PURE__ */ jsx("div", { className: clsx({ [styles.isActive]: getBooleanFromNumber(isBold || BooleanNumber.FALSE) }, styles.buttonItem), onClick: /* @__PURE__ */ __name(() => isBoldSet(getAnotherBooleanNumber(isBold)), "onClick"), children: /* @__PURE__ */ jsx(BoldSingleIcon, {}) }),
        ItalicSingleIcon && /* @__PURE__ */ jsx("div", { className: clsx({ [styles.isActive]: getBooleanFromNumber(isItalic || BooleanNumber.FALSE) }, styles.buttonItem), onClick: /* @__PURE__ */ __name(() => isItalicSet(getAnotherBooleanNumber(isItalic)), "onClick"), children: /* @__PURE__ */ jsx(ItalicSingleIcon, {}) }),
        UnderlineSingleIcon && /* @__PURE__ */ jsx("div", { className: clsx({ [styles.isActive]: getBooleanFromNumber(isUnderline || BooleanNumber.FALSE) }, styles.buttonItem), onClick: /* @__PURE__ */ __name(() => isUnderlineSet(getAnotherBooleanNumber(isUnderline)), "onClick"), children: /* @__PURE__ */ jsx(UnderlineSingleIcon, {}) }),
        StrikethroughSingle && /* @__PURE__ */ jsx("div", { className: clsx({ [styles.isActive]: getBooleanFromNumber(isStrikethrough || BooleanNumber.FALSE) }, styles.buttonItem), onClick: /* @__PURE__ */ __name(() => isStrikethroughSet(getAnotherBooleanNumber(isStrikethrough)), "onClick"), children: /* @__PURE__ */ jsx(StrikethroughSingle, {}) }),
        /* @__PURE__ */ jsx(ColorPicker, { color: fontColor, onChange: fontColorSet, iconId: "FontColor" }),
        /* @__PURE__ */ jsx(ColorPicker, { color: bgColor, onChange: bgColorSet, iconId: "PaintBucket" })
      ]
    }
  );
}, "ConditionalStyleEditor"), FormulaStyleEditor = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { onChange, interceptorManager } = props, localeService = useDependency(LocaleService), workbook = useDependency(IUniverInstanceService).getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), worksheet = workbook.getActiveSheet(), rule = ((_a15 = props.rule) == null ? void 0 : _a15.type) === CFRuleType.highlightCell ? props.rule : void 0, divEleRef = useRef(null), [isFocusFormulaEditor, isFocusFormulaEditorSet] = useState(!1), formulaEditorActionsRef = useRef({}), [style, styleSet] = useState({}), [formula, formulaSet] = useState(() => (rule == null ? void 0 : rule.subType) === CFSubRuleType.formula ? rule.value : "="), [formulaError, formulaErrorSet] = useState(void 0), getResult = /* @__PURE__ */ __name((config) => ({
    style: config.style,
    value: formula,
    type: CFRuleType.highlightCell,
    subType: CFSubRuleType.formula
  }), "getResult");
  useEffect(() => interceptorManager.intercept(interceptorManager.getInterceptPoints().submit, {
    handler() {
      return getResult({ style, formula });
    }
  }), [style, formula, interceptorManager]), useEffect(() => interceptorManager.intercept(interceptorManager.getInterceptPoints().beforeSubmit, {
    handler: /* @__PURE__ */ __name((v, _c, next) => formulaError || formula.length === 1 || !formula.startsWith("=") ? (formulaErrorSet(localeService.t("sheet.cf.errorMessage.formulaError")), !1) : next(v), "handler")
  }), [formulaError, formula]);
  const _onChange = /* @__PURE__ */ __name((config) => {
    onChange(getResult(config));
  }, "_onChange");
  return useSidebarClick((e) => {
    var _a16;
    const handleOutClick = (_a16 = formulaEditorActionsRef.current) == null ? void 0 : _a16.handleOutClick;
    handleOutClick && handleOutClick(e, () => isFocusFormulaEditorSet(!1));
  }), /* @__PURE__ */ jsxs("div", { ref: divEleRef, children: [
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$5.title}
              ${styles$5.mTBase}
            `,
        children: localeService.t("sheet.cf.panel.styleRule")
      }
    ),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$5.mTSm}
            `,
        children: /* @__PURE__ */ jsx(
          FormulaEditor,
          {
            onChange: /* @__PURE__ */ __name((formula2) => {
              formulaSet(formula2), _onChange({ style, formula: formula2 });
            }, "onChange"),
            onVerify: /* @__PURE__ */ __name((result, formula2) => {
              !result || formula2.length === 1 ? formulaErrorSet(localeService.t("sheet.cf.errorMessage.formulaError")) : formulaErrorSet(void 0);
            }, "onVerify"),
            errorText: formulaError,
            onFocus: /* @__PURE__ */ __name(() => {
              isFocusFormulaEditorSet(!0);
            }, "onFocus"),
            actions: formulaEditorActionsRef.current,
            isFocus: isFocusFormulaEditor,
            initValue: formula,
            unitId: workbook.getUnitId(),
            subUnitId: worksheet == null ? void 0 : worksheet.getSheetId()
          }
        )
      }
    ),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$1.cfPreviewWrap}
            `,
        children: /* @__PURE__ */ jsx(Preview, { rule: getResult({ style, formula }) })
      }
    ),
    /* @__PURE__ */ jsx(
      ConditionalStyleEditor,
      {
        style: rule == null ? void 0 : rule.style,
        className: `
                  ${styles$5.mTSm}
                `,
        onChange: /* @__PURE__ */ __name((v) => {
          styleSet(v), _onChange({ style: v, formula });
        }, "onChange")
      }
    )
  ] });
}, "FormulaStyleEditor"), WrapperError = /* @__PURE__ */ __name((props) => /* @__PURE__ */ jsxs("div", { style: { position: "relative" }, children: [
  /* @__PURE__ */ jsx(
    "div",
    {
      style: {
        position: "absolute",
        zIndex: 999,
        bottom: "-13px",
        fontSize: "10px",
        color: "red"
      },
      children: props.errorText
    }
  ),
  props.children
] }), "WrapperError"), createOptionItem = /* @__PURE__ */ __name((text2, localeService) => ({ label: localeService.t(`sheet.cf.operator.${text2}`), value: text2 }), "createOptionItem"), HighlightCellInput = /* @__PURE__ */ __name((props) => {
  const { type, operator, onChange, value, interceptorManager } = props, localeService = useDependency(LocaleService), [inputNumberValue, inputNumberValueSet] = useState(() => typeof value == "number" ? value : 0), [numberError, numberErrorSet] = useState(""), [inputTextValue, inputTextValueSet] = useState(() => typeof value == "string" ? value : ""), [textError, textErrorSet] = useState(""), [inputNumberMin, inputNumberMinSet] = useState(() => Array.isArray(value) ? value[0] === void 0 ? 0 : value[0] : 0), [numberMinError, numberMinErrorSet] = useState(""), [inputNumberMax, inputNumberMaxSet] = useState(() => Array.isArray(value) ? value[1] === void 0 ? 100 : value[1] : 100), [numberMaxError, numberMaxErrorSet] = useState("");
  switch (useEffect(() => {
    switch (type) {
      case CFSubRuleType.text: {
        [
          CFTextOperator.beginsWith,
          CFTextOperator.endsWith,
          CFTextOperator.containsText,
          CFTextOperator.notContainsText,
          CFTextOperator.equal,
          CFTextOperator.notEqual
        ].includes(operator) && onChange(inputTextValue);
        break;
      }
      case CFSubRuleType.number: {
        [
          CFNumberOperator.equal,
          CFNumberOperator.notEqual,
          CFNumberOperator.greaterThan,
          CFNumberOperator.greaterThanOrEqual,
          CFNumberOperator.lessThan,
          CFNumberOperator.lessThanOrEqual
        ].includes(operator) && onChange(inputNumberValue), [CFNumberOperator.between, CFNumberOperator.notBetween].includes(operator) && onChange([inputNumberMin, inputNumberMax]);
        break;
      }
    }
  }, [type]), useEffect(() => {
    const dispose = interceptorManager.intercept(interceptorManager.getInterceptPoints().beforeSubmit, {
      handler: /* @__PURE__ */ __name((v, _c, next) => {
        switch (type) {
          case CFSubRuleType.text:
            if ([
              CFTextOperator.beginsWith,
              CFTextOperator.containsText,
              CFTextOperator.endsWith,
              CFTextOperator.notEqual,
              CFTextOperator.notContainsText,
              CFTextOperator.equal
            ].includes(operator))
              return inputTextValue ? next(v) : (textErrorSet(localeService.t("sheet.cf.errorMessage.notBlank")), !1);
        }
        return next(v);
      }, "handler")
    });
    return () => {
      dispose();
    };
  }, [type, inputNumberValue, inputTextValue, operator]), type) {
    case CFSubRuleType.text: {
      if ([
        CFTextOperator.beginsWith,
        CFTextOperator.endsWith,
        CFTextOperator.containsText,
        CFTextOperator.notContainsText,
        CFTextOperator.equal,
        CFTextOperator.notEqual
      ].includes(operator)) {
        const _onChange = /* @__PURE__ */ __name((value2) => {
          inputTextValueSet(value2), onChange(value2);
        }, "_onChange");
        return /* @__PURE__ */ jsx(
          "div",
          {
            className: `
                      ${styles$5.mTSm}
                    `,
            children: /* @__PURE__ */ jsx(WrapperError, { errorText: textError, children: /* @__PURE__ */ jsx(
              Input,
              {
                className: styles$1.width100,
                value: inputTextValue,
                onChange: /* @__PURE__ */ __name((v) => {
                  textErrorSet(""), _onChange(v);
                }, "onChange")
              }
            ) })
          }
        );
      }
      break;
    }
    case CFSubRuleType.number: {
      if ([
        CFNumberOperator.equal,
        CFNumberOperator.notEqual,
        CFNumberOperator.greaterThan,
        CFNumberOperator.greaterThanOrEqual,
        CFNumberOperator.lessThan,
        CFNumberOperator.lessThanOrEqual
      ].includes(operator)) {
        const _onChange = /* @__PURE__ */ __name((value2) => {
          inputNumberValueSet(value2 || 0), onChange(value2 || 0), numberErrorSet("");
        }, "_onChange");
        return /* @__PURE__ */ jsx(
          "div",
          {
            className: `
                      ${styles$5.mTSm}
                    `,
            children: /* @__PURE__ */ jsx(WrapperError, { errorText: numberError, children: /* @__PURE__ */ jsx(InputNumber, { min: Number.MIN_SAFE_INTEGER, max: Number.MAX_SAFE_INTEGER, className: styles$1.width100, value: inputNumberValue, onChange: _onChange }) })
          }
        );
      }
      if ([CFNumberOperator.between, CFNumberOperator.notBetween].includes(operator)) {
        const onChangeMin = /* @__PURE__ */ __name((_value) => {
          inputNumberMinSet(_value || 0), onChange([_value || 0, inputNumberMax]), numberMinErrorSet("");
        }, "onChangeMin"), onChangeMax = /* @__PURE__ */ __name((_value) => {
          inputNumberMaxSet(_value || 0), onChange([inputNumberMin, _value || 0]), numberMaxErrorSet("");
        }, "onChangeMax");
        return /* @__PURE__ */ jsxs(
          "div",
          {
            className: `
                      ${styles$5.mTSm}
                      ${styles$5.labelContainer}
                    `,
            children: [
              /* @__PURE__ */ jsx(WrapperError, { errorText: numberMinError, children: /* @__PURE__ */ jsx(InputNumber, { min: Number.MIN_SAFE_INTEGER, max: Number.MAX_SAFE_INTEGER, value: inputNumberMin, onChange: onChangeMin }) }),
              /* @__PURE__ */ jsx(WrapperError, { errorText: numberMaxError, children: /* @__PURE__ */ jsx(
                InputNumber,
                {
                  min: Number.MIN_SAFE_INTEGER,
                  max: Number.MAX_SAFE_INTEGER,
                  className: `
                                  ${styles$5.mLSm}
                                `,
                  value: inputNumberMax,
                  onChange: onChangeMax
                }
              ) })
            ]
          }
        );
      }
    }
  }
  return null;
}, "HighlightCellInput"), getOperatorOptions = /* @__PURE__ */ __name((type, localeService) => {
  switch (type) {
    case CFSubRuleType.text:
      return [
        createOptionItem(CFTextOperator.containsText, localeService),
        createOptionItem(CFTextOperator.notContainsText, localeService),
        createOptionItem(CFTextOperator.beginsWith, localeService),
        createOptionItem(CFTextOperator.endsWith, localeService),
        createOptionItem(CFTextOperator.equal, localeService),
        createOptionItem(CFTextOperator.notEqual, localeService),
        createOptionItem(CFTextOperator.containsBlanks, localeService),
        createOptionItem(CFTextOperator.notContainsBlanks, localeService),
        createOptionItem(CFTextOperator.containsErrors, localeService),
        createOptionItem(CFTextOperator.notContainsErrors, localeService)
      ];
    case CFSubRuleType.number:
      return [
        createOptionItem(CFNumberOperator.between, localeService),
        createOptionItem(CFNumberOperator.notBetween, localeService),
        createOptionItem(CFNumberOperator.equal, localeService),
        createOptionItem(CFNumberOperator.notEqual, localeService),
        createOptionItem(CFNumberOperator.greaterThan, localeService),
        createOptionItem(CFNumberOperator.greaterThanOrEqual, localeService),
        createOptionItem(CFNumberOperator.lessThan, localeService),
        createOptionItem(CFNumberOperator.lessThanOrEqual, localeService)
      ];
    case CFSubRuleType.timePeriod:
      return [
        createOptionItem(CFTimePeriodOperator.yesterday, localeService),
        createOptionItem(CFTimePeriodOperator.today, localeService),
        createOptionItem(CFTimePeriodOperator.tomorrow, localeService),
        createOptionItem(CFTimePeriodOperator.last7Days, localeService),
        createOptionItem(CFTimePeriodOperator.lastWeek, localeService),
        createOptionItem(CFTimePeriodOperator.thisWeek, localeService),
        createOptionItem(CFTimePeriodOperator.nextWeek, localeService),
        createOptionItem(CFTimePeriodOperator.lastMonth, localeService),
        createOptionItem(CFTimePeriodOperator.thisMonth, localeService),
        createOptionItem(CFTimePeriodOperator.nextMonth, localeService)
      ];
  }
}, "getOperatorOptions"), HighlightCellStyleEditor = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { interceptorManager, onChange } = props, localeService = useDependency(LocaleService), rule = ((_a15 = props.rule) == null ? void 0 : _a15.type) === CFRuleType.highlightCell ? props.rule : void 0, [subType, subTypeSet] = useState(() => {
    const defaultV = CFSubRuleType.text;
    return rule && rule.subType || defaultV;
  }), typeOptions = [
    {
      value: CFSubRuleType.text,
      label: localeService.t("sheet.cf.subRuleType.text")
    },
    {
      value: CFSubRuleType.number,
      label: localeService.t("sheet.cf.subRuleType.number")
    },
    {
      value: CFSubRuleType.timePeriod,
      label: localeService.t("sheet.cf.subRuleType.timePeriod")
    },
    {
      value: CFSubRuleType.duplicateValues,
      label: localeService.t("sheet.cf.subRuleType.duplicateValues")
    },
    {
      value: CFSubRuleType.uniqueValues,
      label: localeService.t("sheet.cf.subRuleType.uniqueValues")
    }
  ], operatorOptions = useMemo(() => getOperatorOptions(subType, localeService), [subType]), [operator, operatorSet] = useState(() => {
    const defaultV = operatorOptions ? operatorOptions[0].value : void 0;
    return rule && rule.operator || defaultV;
  }), [value, valueSet] = useState(() => {
    var _a16;
    const defaultV = "";
    return rule ? (_a16 = rule.value) != null ? _a16 : createDefaultValue(rule.subType, rule.operator) : defaultV;
  }), [style, styleSet] = useState({}), getResult = useMemo(() => (option) => {
    var _a16, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o;
    switch (option.subType || subType) {
      case CFSubRuleType.text: {
        if ([
          CFTextOperator.beginsWith,
          CFTextOperator.endsWith,
          CFTextOperator.containsText,
          CFTextOperator.notContainsText,
          CFTextOperator.equal,
          CFTextOperator.notEqual
        ].includes(operator))
          return {
            type: CFRuleType.highlightCell,
            subType: (_a16 = option.subType) != null ? _a16 : subType,
            operator: (_b = option.operator) != null ? _b : operator,
            style: (_c = option.style) != null ? _c : style,
            value: (_d = option.value) != null ? _d : value
          };
        break;
      }
      case CFSubRuleType.number: {
        if ([
          CFNumberOperator.equal,
          CFNumberOperator.notEqual,
          CFNumberOperator.greaterThan,
          CFNumberOperator.greaterThanOrEqual,
          CFNumberOperator.lessThan,
          CFNumberOperator.lessThanOrEqual
        ].includes(operator))
          return {
            type: CFRuleType.highlightCell,
            subType: (_e = option.subType) != null ? _e : subType,
            operator: (_f = option.operator) != null ? _f : operator,
            style: (_g = option.style) != null ? _g : style,
            value: (_h = option.value) != null ? _h : value
          };
        if ([CFNumberOperator.between, CFNumberOperator.notBetween].includes(operator))
          return {
            type: CFRuleType.highlightCell,
            subType: (_i = option.subType) != null ? _i : subType,
            operator: (_j = option.operator) != null ? _j : operator,
            style: (_k = option.style) != null ? _k : style,
            value: (_l = option.value) != null ? _l : value
          };
        break;
      }
    }
    return {
      type: CFRuleType.highlightCell,
      subType: (_m = option.subType) != null ? _m : subType,
      operator: (_n = option.operator) != null ? _n : operator,
      style: (_o = option.style) != null ? _o : style
    };
  }, [subType, operator, value, style]);
  useEffect(() => interceptorManager.intercept(interceptorManager.getInterceptPoints().submit, {
    handler() {
      return getResult({});
    }
  }), [getResult, interceptorManager]), useEffect(() => {
    typeOptions.some((item2) => item2.value === subType) || subTypeSet(typeOptions[0].value);
  }, [typeOptions]);
  const onTypeChange = /* @__PURE__ */ __name((v) => {
    const _subType = v, operatorList = getOperatorOptions(_subType, localeService), _operator = operatorList && operatorList[0].value;
    subTypeSet(_subType), operatorSet(_operator), _operator && valueSet(createDefaultValue(_subType, _operator)), onChange(getResult({ subType: _subType, operator: _operator }));
  }, "onTypeChange"), onOperatorChange = /* @__PURE__ */ __name((v) => {
    const _operator = v;
    operatorSet(_operator), onChange(getResult({ operator: _operator }));
  }, "onOperatorChange"), onInputChange = /* @__PURE__ */ __name((value2) => {
    valueSet(value2), onChange(getResult({ value: value2 }));
  }, "onInputChange"), inputRenderKey = useMemo(() => `${subType}_${operator}_${Math.random()}`, [subType, operator]);
  return /* @__PURE__ */ jsxs("div", { children: [
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$5.title}
              ${styles$5.mTBase}
            `,
        children: localeService.t("sheet.cf.panel.styleRule")
      }
    ),
    /* @__PURE__ */ jsx(
      Select,
      {
        className: `
                  ${styles$5.mTSm}
                  ${styles$1.width100}
                `,
        onChange: onTypeChange,
        value: subType,
        options: typeOptions
      }
    ),
    (operatorOptions == null ? void 0 : operatorOptions.length) && /* @__PURE__ */ jsx(
      Select,
      {
        className: `
                      ${styles$5.mTSm}
                      ${styles$1.width100}
                    `,
        onChange: onOperatorChange,
        value: operator || "",
        options: operatorOptions
      }
    ),
    /* @__PURE__ */ jsx(HighlightCellInput, { value, interceptorManager, type: subType, operator, rule, onChange: onInputChange }, inputRenderKey),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$1.cfPreviewWrap}
            `,
        children: /* @__PURE__ */ jsx(Preview, { rule: getResult({}) })
      }
    ),
    /* @__PURE__ */ jsx(
      ConditionalStyleEditor,
      {
        style: rule == null ? void 0 : rule.style,
        className: `
                  ${styles$5.mLXxs}
                `,
        onChange: /* @__PURE__ */ __name((v) => {
          styleSet(v), onChange(getResult({ style: v }));
        }, "onChange")
      }
    )
  ] });
}, "HighlightCellStyleEditor"), getIcon = /* @__PURE__ */ __name((iconType, iconId) => (iconMap[iconType] || [])[Number(iconId)] || "", "getIcon"), TextInput = /* @__PURE__ */ __name((props) => {
  var _a15;
  const univerInstanceService = useDependency(IUniverInstanceService), unitId = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId(), subUnitId = (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet()) == null ? void 0 : _a15.getSheetId(), className = useMemo(() => props.error ? styles$1.errorInput : "", [props.error]), formulaEditorActionsRef = useRef({}), [isFocusFormulaEditor, isFocusFormulaEditorSet] = useState(!1);
  return useSidebarClick((e) => {
    var _a16;
    const handleOutClick = (_a16 = formulaEditorActionsRef.current) == null ? void 0 : _a16.handleOutClick;
    handleOutClick && handleOutClick(e, () => isFocusFormulaEditorSet(!1));
  }), /* @__PURE__ */ jsx("div", { className: styles$1.positionRelative, children: props.type !== CFValueType.formula ? /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(InputNumber, { className, value: Number(props.value) || 0, onChange: /* @__PURE__ */ __name((v) => props.onChange(v != null ? v : 0), "onChange") }),
    props.error && /* @__PURE__ */ jsx("div", { className: styles$1.errorText, children: props.error })
  ] }) : /* @__PURE__ */ jsx("div", { style: { width: "100%" }, children: /* @__PURE__ */ jsx(
    FormulaEditor,
    {
      initValue: String(props.value),
      unitId,
      subUnitId,
      isFocus: isFocusFormulaEditor,
      onChange: /* @__PURE__ */ __name((v = "") => {
        const formula = v || "";
        props.onChange(formula);
      }, "onChange"),
      onFocus: /* @__PURE__ */ __name(() => isFocusFormulaEditorSet(!0), "onFocus"),
      actions: formulaEditorActionsRef.current
    }
  ) }) });
}, "TextInput"), createDefaultConfigItem = /* @__PURE__ */ __name((iconType, index2, list) => ({
  operator: CFNumberOperator.greaterThan,
  value: { type: CFValueType.num, value: (list.length - 1 - index2) * 10 },
  iconType,
  iconId: String(index2)
}), "createDefaultConfigItem"), IconGroupList = forwardRef((props, ref) => {
  const localeService = useDependency(LocaleService), handleClick = /* @__PURE__ */ __name((iconType) => {
    props.onClick(iconType);
  }, "handleClick");
  return /* @__PURE__ */ jsx("div", { ref, className: styles$1.iconGroupList, children: iconGroup.map((group2, index2) => /* @__PURE__ */ jsxs("div", { className: styles$1.group, children: [
    /* @__PURE__ */ jsx("div", { className: styles$1.title, children: localeService.t(group2.title) }),
    /* @__PURE__ */ jsx("div", { className: styles$1.itemContent, children: group2.group.map((groupItem) => /* @__PURE__ */ jsx("div", { className: styles$1.itemWrap, onClick: /* @__PURE__ */ __name(() => {
      handleClick(groupItem.name);
    }, "onClick"), children: /* @__PURE__ */ jsx("div", { className: styles$1.item, children: groupItem.list.map((base64, index22) => /* @__PURE__ */ jsx("img", { className: styles$1.icon, src: base64 }, index22)) }) }, groupItem.name)) })
  ] }, index2)) });
}), IconItemList = /* @__PURE__ */ __name((props) => {
  const list = useMemo(() => {
    const result = [];
    for (const key in iconMap) {
      const list2 = iconMap[key], iconType = key;
      list2.forEach((base64, index2) => {
        result.push({
          iconType,
          base64,
          iconId: String(index2)
        });
      });
    }
    return result;
  }, []), handleClick = /* @__PURE__ */ __name((item2) => {
    props.onClick(item2.iconType, item2.iconId);
  }, "handleClick");
  return /* @__PURE__ */ jsxs("div", { className: styles$1.iconItemListWrap, children: [
    /* @__PURE__ */ jsxs("div", { className: styles$1.none, onClick: /* @__PURE__ */ __name(() => handleClick({ iconType: EMPTY_ICON_TYPE, iconId: "", base64: "" }), "onClick"), children: [
      /* @__PURE__ */ jsx(SlashSingle, { className: styles$1.icon }),
      /* @__PURE__ */ jsx("span", { children: "无单元格图标" })
    ] }),
    /* @__PURE__ */ jsx("div", { className: styles$1.iconItemList, children: list.map((item2) => /* @__PURE__ */ jsx("div", { className: styles$1.item, children: /* @__PURE__ */ jsx(
      "img",
      {
        onClick: /* @__PURE__ */ __name(() => handleClick(item2), "onClick"),
        className: `
                              ${styles$1.icon}
                            `,
        src: item2.base64
      }
    ) }, `${item2.iconType}_${item2.iconId}`)) })
  ] });
}, "IconItemList"), IconSetRuleEdit = /* @__PURE__ */ __name((props) => {
  const { onChange, configList, errorMap = {} } = props, localeService = useDependency(LocaleService), options = [
    { label: localeService.t(`sheet.cf.symbol.${CFNumberOperator.greaterThan}`), value: CFNumberOperator.greaterThan },
    { label: localeService.t(`sheet.cf.symbol.${CFNumberOperator.greaterThanOrEqual}`), value: CFNumberOperator.greaterThanOrEqual }
  ], valueTypeOptions = [
    { label: localeService.t(`sheet.cf.valueType.${CFValueType.num}`), value: CFValueType.num },
    { label: localeService.t(`sheet.cf.valueType.${CFValueType.percent}`), value: CFValueType.percent },
    { label: localeService.t(`sheet.cf.valueType.${CFValueType.percentile}`), value: CFValueType.percentile },
    { label: localeService.t(`sheet.cf.valueType.${CFValueType.formula}`), value: CFValueType.formula }
  ], handleValueValueChange = /* @__PURE__ */ __name((v, index2) => {
    onChange([String(index2), "value", "value"], v);
  }, "handleValueValueChange"), handleOperatorChange = /* @__PURE__ */ __name((operator, index2) => {
    onChange([String(index2), "operator"], operator);
    const defaultValue = createDefaultValue(CFSubRuleType.number, operator);
    handleValueValueChange(defaultValue, index2);
  }, "handleOperatorChange"), handleValueTypeChange = /* @__PURE__ */ __name((v, index2) => {
    onChange([String(index2), "value", "type"], v);
    const item2 = configList[index2], defaultValue = createDefaultValue(CFSubRuleType.number, item2.operator);
    handleValueValueChange(defaultValue, index2);
  }, "handleValueTypeChange");
  return useMemo(() => configList.map((item2, index2) => {
    const error = errorMap[index2], icon2 = getIcon(item2.iconType, item2.iconId), isEnd = index2 === configList.length - 1, isFirst = index2 === 0, preItem = configList[index2 - 1], lessThanText = (preItem == null ? void 0 : preItem.value.type) === CFValueType.formula ? localeService.t("sheet.cf.valueType.formula") : preItem == null ? void 0 : preItem.value.value, handleIconClick = /* @__PURE__ */ __name((iconType, iconId) => {
      const value = { ...item2, iconId, iconType };
      onChange([String(index2)], value);
    }, "handleIconClick");
    return /* @__PURE__ */ jsxs(
      "div",
      {
        className: `
                      ${index2 ? styles$5.mTXl : styles$5.mTSm}
                    `,
        children: [
          /* @__PURE__ */ jsxs(
            "div",
            {
              className: `
                      ${styles$5.label}
                      ${styles$1.flex}
                    `,
              children: [
                /* @__PURE__ */ jsxs(
                  "div",
                  {
                    className: `
                          ${styles$1.width45}
                        `,
                    children: [
                      localeService.t("sheet.cf.iconSet.icon"),
                      index2 + 1
                    ]
                  }
                ),
                /* @__PURE__ */ jsx(
                  "div",
                  {
                    className: `
                          ${styles$1.width45}
                        `,
                    children: /* @__PURE__ */ jsxs(Fragment, { children: [
                      !isFirst && !isEnd && localeService.t("sheet.cf.iconSet.rule"),
                      !isFirst && !isEnd && /* @__PURE__ */ jsxs("span", { className: styles$1.stress, children: [
                        "(",
                        localeService.t("sheet.cf.iconSet.when"),
                        localeService.t(`sheet.cf.symbol.${getOppositeOperator(preItem.operator)}`),
                        lessThanText,
                        isEnd ? "" : ` ${localeService.t("sheet.cf.iconSet.and")} `,
                        ")"
                      ] })
                    ] })
                  }
                )
              ]
            }
          ),
          /* @__PURE__ */ jsxs(
            "div",
            {
              className: `
                      ${styles$1.flex}
                      ${styles$5.mTSm}
                    `,
              children: [
                /* @__PURE__ */ jsx(
                  "div",
                  {
                    className: `
                          ${styles$1.iconWrap}
                          ${styles$1.width45}
                        `,
                    children: /* @__PURE__ */ jsx(DropdownLegacy, { overlay: /* @__PURE__ */ jsx(IconItemList, { onClick: handleIconClick, iconId: item2.iconId, iconType: item2.iconType }), children: /* @__PURE__ */ jsxs("div", { className: styles$1.dropdownIcon, children: [
                      icon2 ? /* @__PURE__ */ jsx("img", { src: icon2, className: styles$1.icon }) : /* @__PURE__ */ jsx(SlashSingle, { className: styles$1.icon }),
                      /* @__PURE__ */ jsx(MoreDownSingle, {})
                    ] }) })
                  }
                ),
                isEnd ? /* @__PURE__ */ jsxs(
                  "div",
                  {
                    className: `
                                      ${styles$1.width45}
                                      ${styles$5.label}
                                    `,
                    style: { marginTop: 0 },
                    children: [
                      localeService.t("sheet.cf.iconSet.rule"),
                      /* @__PURE__ */ jsxs("span", { className: styles$1.stress, children: [
                        "(",
                        localeService.t("sheet.cf.iconSet.when"),
                        localeService.t(`sheet.cf.symbol.${getOppositeOperator(preItem.operator)}`),
                        lessThanText,
                        isEnd ? "" : ` ${localeService.t("sheet.cf.iconSet.and")} `,
                        ")"
                      ] })
                    ]
                  }
                ) : /* @__PURE__ */ jsx(
                  Select,
                  {
                    className: `
                                      ${styles$5.mL0}
                                      ${styles$1.width45}
                                      ${styles$5.mR0}
                                    `,
                    options,
                    value: item2.operator,
                    onChange: /* @__PURE__ */ __name((v) => {
                      handleOperatorChange(v, index2);
                    }, "onChange")
                  }
                )
              ]
            }
          ),
          isEnd ? /* @__PURE__ */ jsx("div", {}) : /* @__PURE__ */ jsxs(Fragment, { children: [
            /* @__PURE__ */ jsxs(
              "div",
              {
                className: `
                                  ${styles$5.mTSm}
                                  ${styles$5.label}
                                  ${styles$1.flex}
                                `,
                children: [
                  /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: `
                                      ${styles$1.width45}
                                    `,
                      children: localeService.t("sheet.cf.iconSet.type")
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: `
                                      ${styles$1.width45}
                                    `,
                      children: localeService.t("sheet.cf.iconSet.value")
                    }
                  )
                ]
              }
            ),
            /* @__PURE__ */ jsxs(
              "div",
              {
                className: `
                                  ${styles$5.mTSm}
                                  ${styles$1.flex}
                                `,
                children: [
                  /* @__PURE__ */ jsx(
                    Select,
                    {
                      style: { flexShrink: 0 },
                      className: `
                                          ${styles$1.width45}
                                          ${styles$5.mL0}
                                        `,
                      options: valueTypeOptions,
                      value: item2.value.type,
                      onChange: /* @__PURE__ */ __name((v) => {
                        handleValueTypeChange(v, index2);
                      }, "onChange")
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: `
                                      ${styles$5.mL0}
                                      ${styles$1.width45}
                                    `,
                      children: /* @__PURE__ */ jsx(
                        TextInput,
                        {
                          id: index2,
                          type: item2.value.type,
                          error,
                          value: item2.value.value || "",
                          onChange: /* @__PURE__ */ __name((v) => handleValueValueChange(v, index2), "onChange")
                        }
                      )
                    }
                  )
                ]
              }
            )
          ] })
        ]
      },
      index2
    );
  }), [configList, errorMap]);
}, "IconSetRuleEdit"), IconSet = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { interceptorManager } = props, rule = ((_a15 = props.rule) == null ? void 0 : _a15.type) === CFRuleType.iconSet ? props.rule : void 0, localeService = useDependency(LocaleService), [errorMap, errorMapSet] = useState({}), [currentIconType, currentIconTypeSet] = useState(() => {
    const defaultV = Object.keys(iconMap)[0];
    if (rule && rule.config.length) {
      const type = rule.config[0].iconType;
      if (!rule.config.some((item2) => item2.iconType !== type))
        return type;
    }
    return defaultV;
  }), [configList, configListSet] = useState(() => {
    if (rule && rule.config.length)
      return Tools.deepClone(rule == null ? void 0 : rule.config);
    const list = iconMap[currentIconType] || [];
    return new Array(list.length).fill("").map((_e, index2, list2) => index2 === list2.length - 1 ? {
      operator: CFNumberOperator.lessThanOrEqual,
      value: { type: CFValueType.num, value: Number.MAX_SAFE_INTEGER },
      iconType: currentIconType,
      iconId: String(index2)
    } : createDefaultConfigItem(currentIconType, index2, list2));
  }), [isShowValue, isShowValueSet] = useState(() => rule ? !!rule.isShowValue : !0), previewIcon = useMemo(() => {
    const list = configList.map((item2) => getIcon(item2.iconType, item2.iconId));
    return /* @__PURE__ */ jsx("div", { className: styles$1.iconWrap, children: list.map((icon2, index2) => icon2 ? /* @__PURE__ */ jsx(
      "img",
      {
        className: styles$1.icon,
        src: icon2
      },
      index2
    ) : /* @__PURE__ */ jsx(SlashSingle, { className: styles$1.icon }, index2)) });
  }, [configList]), checkResult = /* @__PURE__ */ __name((_configList) => {
    if (_configList.reduce((pre, cur, index2) => pre.preType && !pre.result || _configList.length - 1 === index2 ? pre : cur.value.type === CFValueType.formula ? {
      preType: CFValueType.formula,
      result: !1
    } : pre.preType ? {
      result: pre.preType === cur.value.type,
      preType: cur.value.type
    } : {
      result: !0,
      preType: cur.value.type
    }, { result: !0, preType: "" }).result && [CFValueType.num, CFValueType.percent, CFValueType.percentile].includes(_configList[0].value.type)) {
      const result = {};
      return _configList.forEach((item2, index2, arr) => {
        if (index2 - 1 < 0 || index2 === arr.length - 1)
          return;
        const preItem = _configList[index2 - 1], preOperator = getOppositeOperator(preItem.operator);
        compareWithNumber({ operator: preOperator, value: preItem.value.value }, item2.value.value) || (result[index2] = `${localeService.t(`sheet.cf.form.${preOperator}`, String(preItem.value.value))} `);
      }), result;
    }
    return {};
  }, "checkResult"), handleChange = /* @__PURE__ */ __name((keys, v) => {
    get(configList, keys) !== v && (set(configList, keys, v), configListSet([...configList]), errorMapSet(checkResult(configList)));
  }, "handleChange"), handleClickIconList = /* @__PURE__ */ __name((iconType) => {
    currentIconTypeSet(iconType);
    const list = iconMap[iconType] || [], config = new Array(list.length).fill("").map((_e, index2, list2) => createDefaultConfigItem(iconType, index2, list2));
    configListSet(config), errorMapSet(checkResult(config));
  }, "handleClickIconList");
  useEffect(() => {
    const dispose = interceptorManager.intercept(interceptorManager.getInterceptPoints().submit, {
      handler() {
        return { type: CFRuleType.iconSet, isShowValue, config: configList };
      }
    });
    return () => {
      dispose();
    };
  }, [isShowValue, configList, interceptorManager]), useEffect(() => {
    const dispose = interceptorManager.intercept(interceptorManager.getInterceptPoints().beforeSubmit, {
      handler() {
        return Object.keys(errorMap).length === 0;
      }
    });
    return () => {
      dispose();
    };
  }, [isShowValue, configList, interceptorManager, errorMap]);
  const reverseIcon = /* @__PURE__ */ __name(() => {
    const iconList = configList.map((item2) => ({ ...item2 }));
    configList.forEach((item2, index2) => {
      const mirrorIndex = configList.length - 1 - index2, newIcon = iconList[mirrorIndex];
      item2.iconId = newIcon.iconId, item2.iconType = newIcon.iconType;
    }), configListSet([...configList]);
  }, "reverseIcon"), layoutService = useDependency(ILayoutService), [iconGroupListEl, setIconGroupListEl] = useState();
  return useScrollYOverContainer(iconGroupListEl, layoutService.rootContainerElement), /* @__PURE__ */ jsxs("div", { className: styles$1.iconSet, children: [
    /* @__PURE__ */ jsx("div", { className: styles$5.title, children: localeService.t("sheet.cf.panel.styleRule") }),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$5.mTSm}
            `,
        children: /* @__PURE__ */ jsx(
          DropdownLegacy,
          {
            placement: "bottomLeft",
            overlay: /* @__PURE__ */ jsx(
              IconGroupList,
              {
                ref: /* @__PURE__ */ __name((el) => {
                  !iconGroupListEl && el && setIconGroupListEl(el);
                }, "ref"),
                iconType: currentIconType,
                onClick: handleClickIconList
              }
            ),
            children: /* @__PURE__ */ jsxs("div", { className: styles$1.dropdownIcon, style: { width: "unset" }, children: [
              previewIcon,
              /* @__PURE__ */ jsx(MoreDownSingle, {})
            ] })
          }
        )
      }
    ),
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: `
              ${styles$5.mTSm}
              ${styles$1.renderConfig}
            `,
        children: [
          /* @__PURE__ */ jsxs("div", { className: styles$1.utilItem, children: [
            /* @__PURE__ */ jsx(Checkbox, { onChange: reverseIcon }),
            localeService.t("sheet.cf.iconSet.reverseIconOrder")
          ] }),
          /* @__PURE__ */ jsxs(
            "div",
            {
              className: `
                  ${styles$1.utilItem}
                  ${styles$5.mLXl}
                `,
              children: [
                /* @__PURE__ */ jsx(Checkbox, { checked: !isShowValue, onChange: /* @__PURE__ */ __name((v) => {
                  isShowValueSet(!v);
                }, "onChange") }),
                localeService.t("sheet.cf.iconSet.onlyShowIcon")
              ]
            }
          )
        ]
      }
    ),
    /* @__PURE__ */ jsx(IconSetRuleEdit, { errorMap, onChange: handleChange, configList })
  ] });
}, "IconSet"), RankStyleEditor = /* @__PURE__ */ __name((props) => {
  var _a15;
  const { onChange, interceptorManager } = props, localeService = useDependency(LocaleService), rule = ((_a15 = props.rule) == null ? void 0 : _a15.type) === CFRuleType.highlightCell ? props.rule : void 0, options = [
    { label: localeService.t("sheet.cf.panel.isNotBottom"), value: "isNotBottom" },
    { label: localeService.t("sheet.cf.panel.isBottom"), value: "isBottom" },
    { label: localeService.t("sheet.cf.panel.greaterThanAverage"), value: "greaterThanAverage" },
    { label: localeService.t("sheet.cf.panel.lessThanAverage"), value: "lessThanAverage" }
  ], [type, typeSet] = useState(() => {
    const defaultV = options[0].value, type2 = rule == null ? void 0 : rule.type;
    if (!rule)
      return defaultV;
    switch (type2) {
      case CFRuleType.highlightCell:
        switch (rule.subType) {
          case CFSubRuleType.average:
            return [CFNumberOperator.greaterThan, CFNumberOperator.greaterThanOrEqual].includes(rule.operator) ? "greaterThanAverage" : [CFNumberOperator.lessThan, CFNumberOperator.lessThanOrEqual].includes(rule.operator) ? "lessThanAverage" : defaultV;
          case CFSubRuleType.rank:
            return rule.isBottom ? "isBottom" : "isNotBottom";
        }
    }
    return defaultV;
  }), [value, valueSet] = useState(() => {
    const type2 = rule == null ? void 0 : rule.type;
    if (!rule)
      return 10;
    switch (type2) {
      case CFRuleType.highlightCell:
        switch (rule.subType) {
          case CFSubRuleType.rank:
            return rule.value || 10;
        }
    }
    return 10;
  }), [isPercent, isPercentSet] = useState(() => {
    const type2 = rule == null ? void 0 : rule.type;
    if (!rule)
      return !1;
    switch (type2) {
      case CFRuleType.highlightCell:
        switch (rule.subType) {
          case CFSubRuleType.rank:
            return rule.isPercent || !1;
        }
    }
    return !1;
  }), [style, styleSet] = useState({}), getResult = /* @__PURE__ */ __name((config) => {
    const { type: type2, isPercent: isPercent2, value: value2, style: style2 } = config;
    if (type2 === "isNotBottom")
      return { type: CFRuleType.highlightCell, subType: CFSubRuleType.rank, isPercent: isPercent2, isBottom: !1, value: value2, style: style2 };
    if (type2 === "isBottom")
      return { type: CFRuleType.highlightCell, subType: CFSubRuleType.rank, isPercent: isPercent2, isBottom: !0, value: value2, style: style2 };
    if (type2 === "greaterThanAverage")
      return { type: CFRuleType.highlightCell, subType: CFSubRuleType.average, operator: CFNumberOperator.greaterThan, style: style2 };
    if (type2 === "lessThanAverage")
      return { type: CFRuleType.highlightCell, subType: CFSubRuleType.average, operator: CFNumberOperator.lessThan, style: style2 };
  }, "getResult");
  useEffect(() => interceptorManager.intercept(interceptorManager.getInterceptPoints().submit, {
    handler() {
      return getResult({ type, isPercent, value, style });
    }
  }), [type, isPercent, value, style, interceptorManager]);
  const _onChange = /* @__PURE__ */ __name((config) => {
    onChange(getResult(config));
  }, "_onChange");
  return /* @__PURE__ */ jsxs("div", { children: [
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$5.title}
              ${styles$5.mTBase}
            `,
        children: localeService.t("sheet.cf.panel.styleRule")
      }
    ),
    /* @__PURE__ */ jsx(
      Select,
      {
        className: `
                  ${styles$1.width100}
                  ${styles$5.mTSm}
                `,
        value: type,
        options,
        onChange: /* @__PURE__ */ __name((v) => {
          typeSet(v), _onChange({ type: v, isPercent, value, style });
        }, "onChange")
      }
    ),
    ["isNotBottom", "isBottom"].includes(type) && /* @__PURE__ */ jsxs(
      "div",
      {
        className: `
                  ${styles$5.labelContainer}
                  ${styles$5.mTSm}
                `,
        children: [
          /* @__PURE__ */ jsx(
            InputNumber,
            {
              min: 1,
              max: 1e3,
              value,
              onChange: /* @__PURE__ */ __name((v) => {
                const value2 = v || 0;
                valueSet(value2), _onChange({ type, isPercent, value: value2, style });
              }, "onChange")
            }
          ),
          /* @__PURE__ */ jsxs(
            "div",
            {
              className: `
                      ${styles$5.mLSm}
                      ${styles$5.labelContainer}
                      ${styles$1.text}
                    `,
              children: [
                /* @__PURE__ */ jsx(
                  Checkbox,
                  {
                    checked: isPercent,
                    onChange: /* @__PURE__ */ __name((v) => {
                      isPercentSet(!!v), _onChange({ type, isPercent: !!v, value, style });
                    }, "onChange")
                  }
                ),
                localeService.t("sheet.cf.valueType.percent")
              ]
            }
          )
        ]
      }
    ),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$1.cfPreviewWrap}
            `,
        children: /* @__PURE__ */ jsx(Preview, { rule: getResult({ type, isPercent, value, style }) })
      }
    ),
    /* @__PURE__ */ jsx(
      ConditionalStyleEditor,
      {
        style: rule == null ? void 0 : rule.style,
        className: `
                  ${styles$5.mTSm}
                `,
        onChange: /* @__PURE__ */ __name((v) => {
          styleSet(v), _onChange({ type, isPercent, value, style: v });
        }, "onChange")
      }
    )
  ] });
}, "RankStyleEditor"), beforeSubmit = createInterceptorKey("beforeSubmit"), submit = createInterceptorKey("submit"), getUnitId = /* @__PURE__ */ __name((univerInstanceService) => univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId(), "getUnitId"), getSubUnitId = /* @__PURE__ */ __name((univerInstanceService) => {
  var _a15;
  return (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet()) == null ? void 0 : _a15.getSheetId();
}, "getSubUnitId"), RuleEdit = /* @__PURE__ */ __name((props) => {
  var _a15, _b, _c;
  const localeService = useDependency(LocaleService), commandService = useDependency(ICommandService), univerInstanceService = useDependency(IUniverInstanceService), conditionalFormattingRuleModel = useDependency(ConditionalFormattingRuleModel), selectionManagerService = useDependency(SheetsSelectionsService), unitId = getUnitId(univerInstanceService), subUnitId = getSubUnitId(univerInstanceService), [isFocusRangeSelector, isFocusRangeSelectorSet] = useState(!0), rangeSelectorActionsRef = useRef({}), [errorText2, errorTextSet] = useState(void 0), rangeResult = useRef((_b = (_a15 = props.rule) == null ? void 0 : _a15.ranges) != null ? _b : []), rangeString = useMemo(() => {
    var _a16, _b2, _c2;
    let ranges = (_a16 = props.rule) == null ? void 0 : _a16.ranges;
    return ranges != null && ranges.length || (ranges = (_c2 = (_b2 = selectionManagerService.getCurrentSelections()) == null ? void 0 : _b2.map((s) => s.range)) != null ? _c2 : []), rangeResult.current = ranges, ranges != null && ranges.length ? ranges.map((range) => {
      const v = serializeRange(range);
      return v === "NaN" ? "" : v;
    }).filter((r2) => !!r2).join(",") : "";
  }, [props.rule]), options = [
    { label: localeService.t("sheet.cf.ruleType.highlightCell"), value: "1" },
    { label: localeService.t("sheet.cf.panel.rankAndAverage"), value: "2" },
    { label: localeService.t("sheet.cf.ruleType.dataBar"), value: "3" },
    { label: localeService.t("sheet.cf.ruleType.colorScale"), value: "4" },
    { label: localeService.t("sheet.cf.ruleType.formula"), value: "5" },
    { label: localeService.t("sheet.cf.ruleType.iconSet"), value: "6" }
  ], [ruleType2, ruleTypeSet] = useState(() => {
    var _a16, _b2;
    const type = (_a16 = props.rule) == null ? void 0 : _a16.rule.type, defaultType = options[0].value;
    if (!type)
      return defaultType;
    switch (type) {
      case CFRuleType.highlightCell: {
        switch ((_b2 = props.rule) == null ? void 0 : _b2.rule.subType) {
          case CFSubRuleType.number:
          case CFSubRuleType.text:
          case CFSubRuleType.duplicateValues:
          case CFSubRuleType.uniqueValues:
          case CFSubRuleType.timePeriod:
            return "1";
          case CFSubRuleType.average:
          case CFSubRuleType.rank:
            return "2";
          case CFSubRuleType.formula:
            return "5";
        }
        break;
      }
      case CFRuleType.dataBar:
        return "3";
      case CFRuleType.colorScale:
        return "4";
      case CFRuleType.iconSet:
        return "6";
    }
    return defaultType;
  }), result = useRef(void 0), interceptorManager = useMemo(() => new InterceptorManager({ beforeSubmit, submit }), []), StyleEditor = useMemo(() => {
    switch (ruleType2) {
      case "1":
        return HighlightCellStyleEditor;
      case "2":
        return RankStyleEditor;
      case "3":
        return DataBarStyleEditor;
      case "4":
        return ColorScaleStyleEditor;
      case "5":
        return FormulaStyleEditor;
      case "6":
        return IconSet;
      default:
        return HighlightCellStyleEditor;
    }
  }, [ruleType2]);
  useEffect(() => {
    const disposable = commandService.onCommandExecuted((commandInfo) => {
      if (commandInfo.id === RemoveSheetMutation.id) {
        const params = commandInfo.params;
        params.subUnitId === subUnitId && params.unitId === unitId && props.onCancel();
      }
      commandInfo.id === SetWorksheetActiveOperation.id && props.onCancel();
    });
    return () => disposable.dispose();
  }, []);
  const onStyleChange = /* @__PURE__ */ __name((config) => {
    result.current = config;
  }, "onStyleChange"), onRangeSelectorChange = /* @__PURE__ */ __name((rangeString2) => {
    const result2 = rangeString2.split(",").filter((e) => !!e).map(deserializeRangeWithSheet).map((item2) => item2.range);
    rangeResult.current = result2;
  }, "onRangeSelectorChange"), handleSubmit = /* @__PURE__ */ __name(() => {
    if (errorText2)
      return;
    const ranges = (/* @__PURE__ */ __name(() => {
      const worksheet = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet();
      if (!worksheet)
        throw new Error("No active sheet found");
      return rangeResult.current.map((range) => setEndForRange(range, worksheet.getRowCount(), worksheet.getColumnCount())).filter((range) => !(Number.isNaN(range.startRow) || Number.isNaN(range.startColumn)));
    }, "getRanges"))();
    if (interceptorManager.fetchThroughInterceptors(interceptorManager.getInterceptPoints().beforeSubmit)(!0, null)) {
      const result2 = interceptorManager.fetchThroughInterceptors(interceptorManager.getInterceptPoints().submit)(null, null);
      if (result2) {
        const unitId2 = getUnitId(univerInstanceService), subUnitId2 = getSubUnitId(univerInstanceService);
        if (!unitId2 || !subUnitId2)
          throw new Error("No active sheet found");
        let rule = {};
        props.rule && props.rule.cfId ? (rule = { ...props.rule, ranges, rule: result2 }, commandService.executeCommand(SetCfCommand.id, { unitId: unitId2, subUnitId: subUnitId2, rule }), props.onCancel()) : (rule = { cfId: conditionalFormattingRuleModel.createCfId(unitId2, subUnitId2), ranges, rule: result2, stopIfTrue: !1 }, commandService.executeCommand(AddCfCommand.id, { unitId: unitId2, subUnitId: subUnitId2, rule }), props.onCancel());
      }
    }
  }, "handleSubmit"), handleCancel = /* @__PURE__ */ __name(() => {
    props.onCancel();
  }, "handleCancel"), handleVerify = /* @__PURE__ */ __name((v, rangeText) => {
    v ? rangeText.length < 1 ? errorTextSet(localeService.t("sheet.cf.errorMessage.rangeError")) : errorTextSet(void 0) : errorTextSet(localeService.t("sheet.cf.errorMessage.rangeError"));
  }, "handleVerify");
  return useSidebarClick((e) => {
    var _a16;
    const handleOutClick = (_a16 = rangeSelectorActionsRef.current) == null ? void 0 : _a16.handleOutClick;
    handleOutClick && handleOutClick(e, () => isFocusRangeSelectorSet(!1));
  }), /* @__PURE__ */ jsxs("div", { className: styles$1.cfRuleStyleEditor, children: [
    /* @__PURE__ */ jsx("div", { className: styles$5.title, children: localeService.t("sheet.cf.panel.range") }),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: `
              ${styles$5.mTBase}
            `,
        children: /* @__PURE__ */ jsx(
          RangeSelector,
          {
            unitId,
            errorText: errorText2,
            subUnitId,
            initValue: rangeString,
            onChange: onRangeSelectorChange,
            onVerify: handleVerify,
            onFocus: /* @__PURE__ */ __name(() => isFocusRangeSelectorSet(!0), "onFocus"),
            isFocus: isFocusRangeSelector,
            actions: rangeSelectorActionsRef.current
          }
        )
      }
    ),
    /* @__PURE__ */ jsx("div", { className: styles$5.title, children: localeService.t("sheet.cf.panel.styleType") }),
    /* @__PURE__ */ jsx("div", { className: styles$5.mTBase, children: /* @__PURE__ */ jsx(Select, { className: styles$1.width100, value: ruleType2, options, onChange: /* @__PURE__ */ __name((e) => ruleTypeSet(e), "onChange") }) }),
    /* @__PURE__ */ jsx(StyleEditor, { interceptorManager, rule: (_c = props.rule) == null ? void 0 : _c.rule, onChange: onStyleChange }),
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: `
              ${styles$5.mTBase}
              ${styles$1.btnList}
            `,
        children: [
          /* @__PURE__ */ jsx(Button, { size: "small", onClick: handleCancel, children: localeService.t("sheet.cf.panel.cancel") }),
          /* @__PURE__ */ jsx(Button, { className: styles$5.mLSm, size: "small", type: "primary", onClick: handleSubmit, children: localeService.t("sheet.cf.panel.submit") })
        ]
      }
    )
  ] });
}, "RuleEdit"), ConditionFormattingPanel = /* @__PURE__ */ __name((props) => {
  const [currentEditRule, currentEditRuleSet] = useState(props.rule), [isShowRuleEditor, isShowRuleEditorSet] = useState(!!props.rule), createCfRule = /* @__PURE__ */ __name(() => {
    isShowRuleEditorSet(!0);
  }, "createCfRule"), handleCancel = /* @__PURE__ */ __name(() => {
    isShowRuleEditorSet(!1), currentEditRuleSet(void 0);
  }, "handleCancel"), handleRuleClick = /* @__PURE__ */ __name((rule) => {
    currentEditRuleSet(rule), isShowRuleEditorSet(!0);
  }, "handleRuleClick");
  return /* @__PURE__ */ jsx("div", { className: styles$5.conditionalFormattingWrap, children: isShowRuleEditor ? /* @__PURE__ */ jsx(RuleEdit, { onCancel: handleCancel, rule: currentEditRule }) : /* @__PURE__ */ jsx(RuleList, { onClick: handleRuleClick, onCreate: createCfRule }) });
}, "ConditionFormattingPanel");
var __defProp$c = Object.defineProperty, __getOwnPropDesc$c = Object.getOwnPropertyDescriptor, __decorateClass$c = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$c(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$c(target, key, result), result;
}, "__decorateClass$c"), __decorateParam$c = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$c");
const CF_PANEL_KEY = "sheet.conditional.formatting.panel";
var _a2;
let ConditionalFormattingPanelController = (_a2 = class extends Disposable {
  constructor(_univerInstanceService, _injector, _componentManager, _sidebarService, _localeService) {
    super();
    __publicField(this, "_sidebarDisposable", null);
    this._univerInstanceService = _univerInstanceService, this._injector = _injector, this._componentManager = _componentManager, this._sidebarService = _sidebarService, this._localeService = _localeService, this._initPanel(), this.disposeWithMe(
      this._univerInstanceService.getCurrentTypeOfUnit$(UniverInstanceType.UNIVER_SHEET).subscribe((sheet) => {
        var _a15;
        sheet || (_a15 = this._sidebarDisposable) == null || _a15.dispose();
      })
    ), this.disposeWithMe(this._sidebarService.sidebarOptions$.subscribe((info) => {
      info.id === CF_PANEL_KEY && (info.visible || setTimeout(() => {
        this._sidebarService.sidebarOptions$.next({ visible: !1 });
      }));
    }));
  }
  openPanel(rule) {
    const props = {
      id: CF_PANEL_KEY,
      header: { title: this._localeService.t("sheet.cf.title") },
      children: {
        label: CF_PANEL_KEY,
        rule,
        key: generateRandomId(4)
      },
      onClose: /* @__PURE__ */ __name(() => this._sidebarDisposable = null, "onClose")
    };
    this._sidebarDisposable = this._sidebarService.open(props);
  }
  _initPanel() {
    this._componentManager.register(CF_PANEL_KEY, ConditionFormattingPanel);
  }
}, __name(_a2, "ConditionalFormattingPanelController"), _a2);
ConditionalFormattingPanelController = __decorateClass$c([
  __decorateParam$c(0, IUniverInstanceService),
  __decorateParam$c(1, Inject(Injector)),
  __decorateParam$c(2, Inject(ComponentManager)),
  __decorateParam$c(3, Inject(ISidebarService)),
  __decorateParam$c(4, Inject(LocaleService))
], ConditionalFormattingPanelController);
var CF_MENU_OPERATION = /* @__PURE__ */ ((CF_MENU_OPERATION2) => (CF_MENU_OPERATION2[CF_MENU_OPERATION2.createRule = 1] = "createRule", CF_MENU_OPERATION2[CF_MENU_OPERATION2.viewRule = 2] = "viewRule", CF_MENU_OPERATION2[CF_MENU_OPERATION2.highlightCell = 3] = "highlightCell", CF_MENU_OPERATION2[CF_MENU_OPERATION2.rank = 4] = "rank", CF_MENU_OPERATION2[CF_MENU_OPERATION2.formula = 5] = "formula", CF_MENU_OPERATION2[CF_MENU_OPERATION2.colorScale = 6] = "colorScale", CF_MENU_OPERATION2[CF_MENU_OPERATION2.dataBar = 7] = "dataBar", CF_MENU_OPERATION2[CF_MENU_OPERATION2.icon = 8] = "icon", CF_MENU_OPERATION2[CF_MENU_OPERATION2.clearRangeRules = 9] = "clearRangeRules", CF_MENU_OPERATION2[CF_MENU_OPERATION2.clearWorkSheetRules = 10] = "clearWorkSheetRules", CF_MENU_OPERATION2))(CF_MENU_OPERATION || {});
const OpenConditionalFormattingOperator = {
  id: "sheet.operation.open.conditional.formatting.panel",
  type: CommandType.OPERATION,
  handler: /* @__PURE__ */ __name((accessor, params) => {
    var _a15;
    const conditionalFormattingMenuController = accessor.get(ConditionalFormattingPanelController), selectionManagerService = accessor.get(SheetsSelectionsService), commandService = accessor.get(ICommandService), ranges = ((_a15 = selectionManagerService.getCurrentSelections()) == null ? void 0 : _a15.map((s) => s.range)) || [];
    switch (params.value) {
      case 3: {
        conditionalFormattingMenuController.openPanel({ ...createDefaultRule(), ranges });
        break;
      }
      case 4: {
        const rule = {
          ...createDefaultRule,
          ranges,
          rule: {
            type: CFRuleType.highlightCell,
            subType: CFSubRuleType.rank
          }
        };
        conditionalFormattingMenuController.openPanel(rule);
        break;
      }
      case 5: {
        const rule = {
          ...createDefaultRule,
          ranges,
          rule: {
            type: CFRuleType.highlightCell,
            subType: CFSubRuleType.formula,
            value: "="
          }
        };
        conditionalFormattingMenuController.openPanel(rule);
        break;
      }
      case 6: {
        const rule = {
          ...createDefaultRule,
          ranges,
          rule: {
            type: CFRuleType.colorScale,
            config: []
          }
        };
        conditionalFormattingMenuController.openPanel(rule);
        break;
      }
      case 7: {
        const rule = {
          ...createDefaultRule,
          ranges,
          rule: {
            type: CFRuleType.dataBar,
            isShowValue: !0
          }
        };
        conditionalFormattingMenuController.openPanel(rule);
        break;
      }
      case 8: {
        const rule = {
          ...createDefaultRule,
          ranges,
          rule: {
            type: CFRuleType.iconSet,
            config: [],
            isShowValue: !0
          }
        };
        conditionalFormattingMenuController.openPanel(rule);
        break;
      }
      case 2: {
        conditionalFormattingMenuController.openPanel();
        break;
      }
      case 1: {
        conditionalFormattingMenuController.openPanel({ ...createDefaultRule(), ranges });
        break;
      }
      case 9: {
        commandService.executeCommand(ClearRangeCfCommand.id, { ranges });
        break;
      }
      case 10: {
        commandService.executeCommand(ClearWorksheetCfCommand.id);
        break;
      }
    }
    return !0;
  }, "handler")
};
var __defProp$b = Object.defineProperty, __getOwnPropDesc$b = Object.getOwnPropertyDescriptor, __decorateClass$b = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$b(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$b(target, key, result), result;
}, "__decorateClass$b"), __decorateParam$b = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$b"), _a3;
let ConditionalFormattingCopyPasteController = (_a3 = class extends Disposable {
  constructor(_sheetClipboardService, _conditionalFormattingRuleModel, _injector, _conditionalFormattingViewModel, _univerInstanceService) {
    super();
    __publicField(this, "_copyInfo");
    this._sheetClipboardService = _sheetClipboardService, this._conditionalFormattingRuleModel = _conditionalFormattingRuleModel, this._injector = _injector, this._conditionalFormattingViewModel = _conditionalFormattingViewModel, this._univerInstanceService = _univerInstanceService, this._initClipboardHook();
  }
  _initClipboardHook() {
    this.disposeWithMe(
      this._sheetClipboardService.addClipboardHook({
        id: SHEET_CONDITIONAL_FORMATTING_PLUGIN,
        onBeforeCopy: /* @__PURE__ */ __name((unitId, subUnitId, range) => this._collectConditionalRule(unitId, subUnitId, range), "onBeforeCopy"),
        onPasteCells: /* @__PURE__ */ __name((pasteFrom, pasteTo, data, payload) => {
          const { copyType = COPY_TYPE.COPY, pasteType } = payload, { range: copyRange } = pasteFrom || {}, { range: pastedRange } = pasteTo;
          return this._generateConditionalFormattingMutations(pastedRange, { copyType, pasteType, copyRange });
        }, "onPasteCells")
      })
    );
  }
  _collectConditionalRule(unitId, subUnitId, range) {
    const matrix = new ObjectMatrix(), cfMap = {};
    this._copyInfo = {
      matrix,
      info: {
        unitId,
        subUnitId,
        cfMap
      }
    };
    const discreteRange = this._injector.invoke((accessor) => rangeToDiscreteRange(range, accessor, unitId, subUnitId));
    if (!discreteRange)
      return;
    const { rows, cols } = discreteRange, cfIdSet = /* @__PURE__ */ new Set();
    rows.forEach((row, rowIndex) => {
      cols.forEach((col, colIndex) => {
        const cellCfList = this._conditionalFormattingViewModel.getCellCfs(unitId, subUnitId, row, col);
        cellCfList && (cellCfList.forEach((item2) => cfIdSet.add(item2.cfId)), matrix.setValue(rowIndex, colIndex, cellCfList.map((item2) => item2.cfId)));
      });
    }), cfIdSet.forEach((cfId) => {
      const rule = this._conditionalFormattingRuleModel.getRule(unitId, subUnitId, cfId);
      rule && (cfMap[cfId] = rule.rule);
    });
  }
  // eslint-disable-next-line max-lines-per-function
  _generateConditionalFormattingMutations(pastedRange, copyInfo) {
    const workbook = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), sheet = workbook.getActiveSheet(), unitId = workbook.getUnitId();
    if (!sheet) return { redos: [], undos: [] };
    const subUnitId = sheet.getSheetId();
    if (copyInfo.copyType === COPY_TYPE.CUT)
      return this._copyInfo = null, { redos: [], undos: [] };
    if (!this._copyInfo || !copyInfo.copyRange)
      return { redos: [], undos: [] };
    if (![
      PREDEFINED_HOOK_NAME.SPECIAL_PASTE_FORMAT,
      PREDEFINED_HOOK_NAME.DEFAULT_PASTE,
      PREDEFINED_HOOK_NAME.SPECIAL_PASTE_BESIDES_BORDER
    ].includes(
      copyInfo.pasteType
    ))
      return { redos: [], undos: [] };
    const { ranges: [vCopyRange, vPastedRange], mapFunc } = virtualizeDiscreteRanges([copyInfo.copyRange, pastedRange]), repeatRange = getRepeatRange(vCopyRange, vPastedRange, !0), effectedConditionalFormattingRuleMatrix = {};
    Range.foreach(vPastedRange, (row, col) => {
      const { row: realRow, col: realCol } = mapFunc(row, col), cellCfList = this._conditionalFormattingViewModel.getCellCfs(unitId, subUnitId, realRow, realCol);
      cellCfList && cellCfList.forEach((item2) => {
        if (!effectedConditionalFormattingRuleMatrix[item2.cfId]) {
          const ruleMatrix = new ObjectMatrix();
          effectedConditionalFormattingRuleMatrix[item2.cfId] = ruleMatrix;
          const rule = this._conditionalFormattingRuleModel.getRule(unitId, subUnitId, item2.cfId);
          rule == null || rule.ranges.forEach((range) => {
            Range.foreach(range, (row2, col2) => {
              ruleMatrix.setValue(row2, col2, 1);
            });
          });
        }
        effectedConditionalFormattingRuleMatrix[item2.cfId].realDeleteValue(realRow, realCol);
      });
    });
    const { matrix, info } = this._copyInfo, waitAddRule = [];
    let nextCfId = this._conditionalFormattingRuleModel.createCfId(unitId, subUnitId);
    const cacheCfIdMap = {}, getCurrentSheetCfRule = /* @__PURE__ */ __name((copyRangeCfId) => {
      if (cacheCfIdMap[copyRangeCfId])
        return cacheCfIdMap[copyRangeCfId];
      const oldRule = info == null ? void 0 : info.cfMap[copyRangeCfId], targetRule = [...this._conditionalFormattingRuleModel.getSubunitRules(unitId, subUnitId) || [], ...waitAddRule].find((rule) => Tools.diffValue(rule.rule, oldRule));
      if (targetRule)
        return cacheCfIdMap[copyRangeCfId] = targetRule, targetRule;
      {
        const rule = {
          rule: oldRule,
          cfId: nextCfId,
          ranges: [],
          stopIfTrue: !1
        };
        return cacheCfIdMap[copyRangeCfId] = rule, waitAddRule.push(rule), nextCfId = `${Number(nextCfId) + 1}`, rule;
      }
    }, "getCurrentSheetCfRule");
    repeatRange.forEach((item2) => {
      matrix && matrix.forValue((row, col, copyRangeCfIdList) => {
        const range = Rectangle.getPositionRange(
          {
            startRow: row,
            endRow: row,
            startColumn: col,
            endColumn: col
          },
          item2.startRange
        ), { row: _row, col: _col } = mapFunc(range.startRow, range.startColumn);
        copyRangeCfIdList.forEach((cfId) => {
          if (!effectedConditionalFormattingRuleMatrix[cfId]) {
            const rule = getCurrentSheetCfRule(cfId), ruleMatrix = new ObjectMatrix();
            effectedConditionalFormattingRuleMatrix[cfId] = ruleMatrix, rule.ranges.forEach((range2) => {
              Range.foreach(range2, (row2, col2) => {
                ruleMatrix.setValue(row2, col2, 1);
              });
            });
          }
          effectedConditionalFormattingRuleMatrix[cfId].setValue(_row, _col, 1);
        });
      });
    });
    const redos = [], undos = [];
    for (const cfId in effectedConditionalFormattingRuleMatrix) {
      const matrix2 = effectedConditionalFormattingRuleMatrix[cfId], ranges = findAllRectangle(createTopMatrixFromMatrix(matrix2));
      if (!ranges.length) {
        const deleteParams = {
          unitId,
          subUnitId,
          cfId
        };
        redos.push({ id: DeleteConditionalRuleMutation.id, params: deleteParams }), undos.push(...DeleteConditionalRuleMutationUndoFactory(this._injector, deleteParams));
      }
      if (waitAddRule.some((rule) => rule.cfId === cfId)) {
        const rule = getCurrentSheetCfRule(cfId), addParams = {
          unitId,
          subUnitId,
          rule: { ...rule, ranges }
        };
        redos.push({ id: AddConditionalRuleMutation.id, params: addParams }), undos.push(AddConditionalRuleMutationUndoFactory(this._injector, addParams));
      } else {
        const rule = this._conditionalFormattingRuleModel.getRule(unitId, subUnitId, cfId);
        if (!rule)
          continue;
        const setParams = {
          unitId,
          subUnitId,
          rule: { ...rule, ranges }
        };
        redos.push({ id: SetConditionalRuleMutation.id, params: setParams }), undos.push(...setConditionalRuleMutationUndoFactory(this._injector, setParams));
      }
    }
    return {
      redos,
      undos
    };
  }
}, __name(_a3, "ConditionalFormattingCopyPasteController"), _a3);
ConditionalFormattingCopyPasteController = __decorateClass$b([
  __decorateParam$b(0, Inject(ISheetClipboardService)),
  __decorateParam$b(1, Inject(ConditionalFormattingRuleModel)),
  __decorateParam$b(2, Inject(Injector)),
  __decorateParam$b(3, Inject(ConditionalFormattingViewModel)),
  __decorateParam$b(4, Inject(IUniverInstanceService))
], ConditionalFormattingCopyPasteController);
var __defProp$a = Object.defineProperty, __getOwnPropDesc$a = Object.getOwnPropertyDescriptor, __decorateClass$a = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$a(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$a(target, key, result), result;
}, "__decorateClass$a"), __decorateParam$a = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$a"), _a4;
let ConditionalFormattingPermissionController = (_a4 = class extends Disposable {
  constructor(_localeService, _commandService, _sheetPermissionCheckController) {
    super(), this._localeService = _localeService, this._commandService = _commandService, this._sheetPermissionCheckController = _sheetPermissionCheckController, this._commandExecutedListener();
  }
  _commandExecutedListener() {
    this.disposeWithMe(
      this._commandService.beforeCommandExecuted((command) => {
        command.id === AddCfCommand.id && (this._sheetPermissionCheckController.permissionCheckWithRanges({
          workbookTypes: [WorkbookEditablePermission],
          rangeTypes: [RangeProtectionPermissionEditPoint],
          worksheetTypes: [WorksheetEditPermission, WorksheetSetCellStylePermission]
        }, command.params.rule.ranges) || this._sheetPermissionCheckController.blockExecuteWithoutPermission(this._localeService.t("permission.dialog.setStyleErr")));
      })
    );
  }
}, __name(_a4, "ConditionalFormattingPermissionController"), _a4);
ConditionalFormattingPermissionController = __decorateClass$a([
  __decorateParam$a(0, Inject(LocaleService)),
  __decorateParam$a(1, ICommandService),
  __decorateParam$a(2, Inject(SheetPermissionCheckController))
], ConditionalFormattingPermissionController);
var __defProp$9 = Object.defineProperty, __getOwnPropDesc$9 = Object.getOwnPropertyDescriptor, __decorateClass$9 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$9(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$9(target, key, result), result;
}, "__decorateClass$9"), __decorateParam$9 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$9"), _a5;
let SheetsCfRefRangeController = (_a5 = class extends Disposable {
  constructor(_conditionalFormattingRuleModel, _univerInstanceService, _injector, _refRangeService) {
    super(), this._conditionalFormattingRuleModel = _conditionalFormattingRuleModel, this._univerInstanceService = _univerInstanceService, this._injector = _injector, this._refRangeService = _refRangeService, this._initRefRange();
  }
  _initRefRange() {
    const disposableMap = /* @__PURE__ */ new Map(), getCfIdWithUnitId = /* @__PURE__ */ __name((unitID, subUnitId, cfId) => `${unitID}_${subUnitId}_${cfId}`, "getCfIdWithUnitId"), register = /* @__PURE__ */ __name((unitId, subUnitId, rule) => {
      const handleRangeChange = /* @__PURE__ */ __name((commandInfo) => {
        const oldRanges = [...rule.ranges], resultRanges = oldRanges.map((range) => handleDefaultRangeChangeWithEffectRefCommands(range, commandInfo)).filter((range) => !!range);
        if (isRangesEqual(resultRanges, oldRanges))
          return { redos: [], undos: [] };
        if (resultRanges.length) {
          const redoParams = { unitId, subUnitId, rule: { ...rule, ranges: resultRanges } }, redos = [{ id: SetConditionalRuleMutation.id, params: redoParams }], undos = setConditionalRuleMutationUndoFactory(this._injector, redoParams);
          return { redos, undos };
        } else {
          const redoParams = { unitId, subUnitId, cfId: rule.cfId }, redos = [{ id: DeleteConditionalRuleMutation.id, params: redoParams }], undos = DeleteConditionalRuleMutationUndoFactory(this._injector, redoParams);
          return { redos, undos };
        }
      }, "handleRangeChange"), disposeList = [];
      rule.ranges.forEach((range) => {
        const disposable = this._refRangeService.registerRefRange(range, handleRangeChange);
        disposeList.push(() => disposable.dispose());
      }), disposableMap.set(getCfIdWithUnitId(unitId, subUnitId, rule.cfId), () => disposeList.forEach((dispose) => dispose()));
    }, "register");
    this.disposeWithMe(this._conditionalFormattingRuleModel.$ruleChange.subscribe((option) => {
      const { unitId, subUnitId, rule } = option, workbook = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), worksheet = workbook.getActiveSheet();
      if (!(option.unitId !== workbook.getUnitId() || option.subUnitId !== (worksheet == null ? void 0 : worksheet.getSheetId())))
        switch (option.type) {
          case "add": {
            register(option.unitId, option.subUnitId, option.rule);
            break;
          }
          case "delete": {
            const dispose = disposableMap.get(getCfIdWithUnitId(unitId, subUnitId, rule.cfId));
            dispose && dispose();
            break;
          }
          case "set": {
            const dispose = disposableMap.get(getCfIdWithUnitId(unitId, subUnitId, rule.cfId));
            dispose && dispose(), register(option.unitId, option.subUnitId, option.rule);
          }
        }
    })), this.disposeWithMe(toDisposable(() => {
      disposableMap.forEach((item2) => {
        item2();
      }), disposableMap.clear();
    }));
  }
}, __name(_a5, "SheetsCfRefRangeController"), _a5);
SheetsCfRefRangeController = __decorateClass$9([
  __decorateParam$9(0, Inject(ConditionalFormattingRuleModel)),
  __decorateParam$9(1, Inject(IUniverInstanceService)),
  __decorateParam$9(2, Inject(Injector)),
  __decorateParam$9(3, Inject(RefRangeService))
], SheetsCfRefRangeController);
var __defProp$8 = Object.defineProperty, __getOwnPropDesc$8 = Object.getOwnPropertyDescriptor, __decorateClass$8 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$8(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$8(target, key, result), result;
}, "__decorateClass$8"), __decorateParam$8 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$8"), _a6;
let SheetsCfRenderController = (_a6 = class extends Disposable {
  constructor(_sheetInterceptorService, _conditionalFormattingService, _univerInstanceService, _renderManagerService, _conditionalFormattingViewModel, _conditionalFormattingRuleModel) {
    super();
    /**
     * When a set operation is triggered multiple times over a short period of time, it may result in some callbacks not being disposed,and caused a render cache exception.
     * The solution here is to store all the asynchronous tasks and focus on processing after the last callback
     */
    __publicField(this, "_ruleChangeCacheMap", /* @__PURE__ */ new Map());
    this._sheetInterceptorService = _sheetInterceptorService, this._conditionalFormattingService = _conditionalFormattingService, this._univerInstanceService = _univerInstanceService, this._renderManagerService = _renderManagerService, this._conditionalFormattingViewModel = _conditionalFormattingViewModel, this._conditionalFormattingRuleModel = _conditionalFormattingRuleModel, this._initViewModelInterceptor(), this._initSkeleton(), this.disposeWithMe(() => {
      this._ruleChangeCacheMap.clear();
    });
  }
  _markDirtySkeleton() {
    var _a15, _b, _c;
    const unitId = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId();
    (_a15 = this._renderManagerService.getRenderById(unitId)) == null || _a15.with(SheetSkeletonManagerService).reCalculate(), (_c = (_b = this._renderManagerService.getRenderById(unitId)) == null ? void 0 : _b.mainComponent) == null || _c.makeDirty();
  }
  _initSkeleton() {
    this.disposeWithMe(merge(this._conditionalFormattingRuleModel.$ruleChange, this._conditionalFormattingViewModel.markDirty$).pipe(
      bufferTime(16),
      filter((v) => !!v.length),
      filter((v) => {
        const workbook = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET);
        if (!workbook) return !1;
        const worksheet = workbook.getActiveSheet();
        return worksheet ? v.filter((item2) => item2.unitId === workbook.getUnitId() && item2.subUnitId === worksheet.getSheetId()).length > 0 : !1;
      })
    ).subscribe(() => this._markDirtySkeleton()));
  }
  _initViewModelInterceptor() {
    this.disposeWithMe(this._sheetInterceptorService.intercept(INTERCEPTOR_POINT.CELL_CONTENT, {
      effect: InterceptorEffectEnum.Style,
      handler: /* @__PURE__ */ __name((cell, context, next) => {
        const result = this._conditionalFormattingService.composeStyle(context.unitId, context.subUnitId, context.row, context.col);
        if (!result)
          return next(cell);
        const styleMap = context.workbook.getStyles(), s = { ...(typeof (cell == null ? void 0 : cell.s) == "string" ? styleMap.get(cell == null ? void 0 : cell.s) : cell == null ? void 0 : cell.s) || {} }, cloneCell = { ...cell, s };
        return result.style && Object.assign(s, result.style), cloneCell.fontRenderExtension || (cloneCell.fontRenderExtension = {}, result.isShowValue !== void 0 && (cloneCell.fontRenderExtension.isSkip = !result.isShowValue)), result.dataBar && (cloneCell.dataBar = result.dataBar), result.iconSet && (cloneCell.iconSet = result.iconSet, cloneCell.fontRenderExtension.leftOffset = DEFAULT_PADDING + DEFAULT_WIDTH), next(cloneCell);
      }, "handler"),
      priority: 10
    }));
  }
}, __name(_a6, "SheetsCfRenderController"), _a6);
SheetsCfRenderController = __decorateClass$8([
  __decorateParam$8(0, Inject(SheetInterceptorService)),
  __decorateParam$8(1, Inject(ConditionalFormattingService)),
  __decorateParam$8(2, Inject(IUniverInstanceService)),
  __decorateParam$8(3, Inject(IRenderManagerService)),
  __decorateParam$8(4, Inject(ConditionalFormattingViewModel)),
  __decorateParam$8(5, Inject(ConditionalFormattingRuleModel))
], SheetsCfRenderController);
const SHEETS_CONDITIONAL_FORMATTING_UI_PLUGIN_CONFIG_KEY = "sheets-conditional-formatting-ui.config", defaultPluginConfig = {};
var __defProp$7 = Object.defineProperty, __getOwnPropDesc$7 = Object.getOwnPropertyDescriptor, __defNormalProp$1 = /* @__PURE__ */ __name((obj, key, value) => key in obj ? __defProp$7(obj, key, { enumerable: !0, configurable: !0, writable: !0, value }) : obj[key] = value, "__defNormalProp$1"), __decorateClass$7 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$7(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$7(target, key, result), result;
}, "__decorateClass$7"), __decorateParam$7 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$7"), __publicField$1 = /* @__PURE__ */ __name((obj, key, value) => __defNormalProp$1(obj, typeof key != "symbol" ? key + "" : key, value), "__publicField$1"), _a7;
let UniverSheetsConditionalFormattingMobileUIPlugin = (_a7 = class extends Plugin {
  constructor(_config = defaultPluginConfig, _injector, _commandService, _configService) {
    super(), this._config = _config, this._injector = _injector, this._commandService = _commandService, this._configService = _configService;
    const { menu, ...rest } = merge$1(
      {},
      defaultPluginConfig,
      this._config
    );
    menu && this._configService.setConfig("menu", menu, { merge: !0 }), this._configService.setConfig(SHEETS_CONDITIONAL_FORMATTING_UI_PLUGIN_CONFIG_KEY, rest), this._initCommand(), this._injector.add([SheetsCfRenderController]), this._injector.add([SheetsCfRefRangeController]), this._injector.add([ConditionalFormattingCopyPasteController]), this._injector.add([ConditionalFormattingPermissionController]), this._injector.add([ConditionalFormattingI18nController]);
  }
  _initCommand() {
    [
      AddAverageCfCommand,
      AddColorScaleConditionalRuleCommand,
      AddDataBarConditionalRuleCommand,
      AddDuplicateValuesCfCommand,
      AddNumberCfCommand,
      AddRankCfCommand,
      AddTextCfCommand,
      AddTimePeriodCfCommand,
      AddUniqueValuesCfCommand,
      OpenConditionalFormattingOperator,
      DeleteCfCommand,
      SetCfCommand,
      MoveCfCommand,
      AddCfCommand,
      ClearRangeCfCommand,
      ClearWorksheetCfCommand
    ].forEach((m) => {
      this._commandService.registerCommand(m);
    });
  }
}, __name(_a7, "UniverSheetsConditionalFormattingMobileUIPlugin"), _a7);
__publicField$1(UniverSheetsConditionalFormattingMobileUIPlugin, "pluginName", `${SHEET_CONDITIONAL_FORMATTING_PLUGIN}_MOBILE_UI_PLUGIN`);
__publicField$1(UniverSheetsConditionalFormattingMobileUIPlugin, "type", UniverInstanceType.UNIVER_SHEET);
UniverSheetsConditionalFormattingMobileUIPlugin = __decorateClass$7([
  DependentOn(UniverSheetsConditionalFormattingPlugin),
  __decorateParam$7(1, Inject(Injector)),
  __decorateParam$7(2, Inject(ICommandService)),
  __decorateParam$7(3, IConfigService)
], UniverSheetsConditionalFormattingMobileUIPlugin);
var __defProp$6 = Object.defineProperty, __getOwnPropDesc$6 = Object.getOwnPropertyDescriptor, __decorateClass$6 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$6(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$6(target, key, result), result;
}, "__decorateClass$6"), __decorateParam$6 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$6"), _a8;
let ConditionalFormattingAutoFillController = (_a8 = class extends Disposable {
  constructor(_injector, _univerInstanceService, _autoFillService, _conditionalFormattingRuleModel, _conditionalFormattingViewModel) {
    super(), this._injector = _injector, this._univerInstanceService = _univerInstanceService, this._autoFillService = _autoFillService, this._conditionalFormattingRuleModel = _conditionalFormattingRuleModel, this._conditionalFormattingViewModel = _conditionalFormattingViewModel, this._initAutoFill();
  }
  // eslint-disable-next-line max-lines-per-function
  _initAutoFill() {
    const noopReturnFunc = /* @__PURE__ */ __name(() => ({ redos: [], undos: [] }), "noopReturnFunc"), loopFunc = /* @__PURE__ */ __name((sourceStartCell, targetStartCell, relativeRange, matrixMap, mapFunc) => {
      var _a15;
      const unitId = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getUnitId(), subUnitId = (_a15 = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET).getActiveSheet()) == null ? void 0 : _a15.getSheetId();
      if (!unitId || !subUnitId)
        return;
      const sourceRange = {
        startRow: sourceStartCell.row,
        startColumn: sourceStartCell.col,
        endColumn: sourceStartCell.col,
        endRow: sourceStartCell.row
      }, targetRange = {
        startRow: targetStartCell.row,
        startColumn: targetStartCell.col,
        endColumn: targetStartCell.col,
        endRow: targetStartCell.row
      };
      Range.foreach(relativeRange, (row, col) => {
        const sourcePositionRange = Rectangle.getPositionRange(
          {
            startRow: row,
            startColumn: col,
            endColumn: col,
            endRow: row
          },
          sourceRange
        ), targetPositionRange = Rectangle.getPositionRange(
          {
            startRow: row,
            startColumn: col,
            endColumn: col,
            endRow: row
          },
          targetRange
        ), { row: sourceRow, col: sourceCol } = mapFunc(sourcePositionRange.startRow, sourcePositionRange.startColumn), sourceCellCf = this._conditionalFormattingViewModel.getCellCfs(
          unitId,
          subUnitId,
          sourceRow,
          sourceCol
        ), { row: targetRow, col: targetCol } = mapFunc(targetPositionRange.startRow, targetPositionRange.startColumn), targetCellCf = this._conditionalFormattingViewModel.getCellCfs(
          unitId,
          subUnitId,
          targetRow,
          targetCol
        );
        targetCellCf && targetCellCf.forEach((cf) => {
          let matrix = matrixMap.get(cf.cfId);
          if (!matrixMap.get(cf.cfId)) {
            const rule = this._conditionalFormattingRuleModel.getRule(unitId, subUnitId, cf.cfId);
            if (!rule)
              return;
            matrix = new ObjectMatrix(), rule.ranges.forEach((range) => {
              Range.foreach(range, (row2, col2) => {
                matrix.setValue(row2, col2, 1);
              });
            }), matrixMap.set(cf.cfId, matrix);
          }
          matrix.realDeleteValue(targetRow, targetCol);
        }), sourceCellCf && sourceCellCf.forEach((cf) => {
          let matrix = matrixMap.get(cf.cfId);
          if (!matrixMap.get(cf.cfId)) {
            const rule = this._conditionalFormattingRuleModel.getRule(unitId, subUnitId, cf.cfId);
            if (!rule)
              return;
            matrix = new ObjectMatrix(), rule.ranges.forEach((range) => {
              Range.foreach(range, (row2, col2) => {
                matrix.setValue(row2, col2, 1);
              });
            }), matrixMap.set(cf.cfId, matrix);
          }
          matrix.setValue(targetRow, targetCol, 1);
        });
      });
    }, "loopFunc"), generalApplyFunc = /* @__PURE__ */ __name((sourceRange, targetRange) => {
      var _a15, _b, _c;
      const unitId = (_a15 = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET)) == null ? void 0 : _a15.getUnitId(), subUnitId = (_c = (_b = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET)) == null ? void 0 : _b.getActiveSheet()) == null ? void 0 : _c.getSheetId(), matrixMap = /* @__PURE__ */ new Map(), redos = [], undos = [];
      if (!unitId || !subUnitId)
        return noopReturnFunc();
      const virtualRange = virtualizeDiscreteRanges([sourceRange, targetRange]), [vSourceRange, vTargetRange] = virtualRange.ranges, { mapFunc } = virtualRange, sourceStartCell = {
        row: vSourceRange.startRow,
        col: vSourceRange.startColumn
      };
      return getAutoFillRepeatRange(vSourceRange, vTargetRange).forEach((repeat) => {
        loopFunc(sourceStartCell, repeat.repeatStartCell, repeat.relativeRange, matrixMap, mapFunc);
      }), matrixMap.forEach((item2, cfId) => {
        const rule = this._conditionalFormattingRuleModel.getRule(unitId, subUnitId, cfId);
        if (!rule)
          return;
        const ranges = findAllRectangle(createTopMatrixFromMatrix(item2));
        if (ranges.length) {
          const params = {
            unitId,
            subUnitId,
            rule: { ...rule, ranges }
          };
          redos.push({ id: SetConditionalRuleMutation.id, params }), undos.push(...setConditionalRuleMutationUndoFactory(this._injector, params));
        } else {
          const params = {
            unitId,
            subUnitId,
            cfId: rule.cfId
          };
          redos.push({ id: DeleteConditionalRuleMutation.id, params }), undos.push(...DeleteConditionalRuleMutationUndoFactory(this._injector, params));
        }
      }), {
        undos,
        redos
      };
    }, "generalApplyFunc"), hook = {
      id: SHEET_CONDITIONAL_FORMATTING_PLUGIN,
      onFillData: /* @__PURE__ */ __name((location, direction, applyType) => {
        if (applyType === APPLY_TYPE.COPY || applyType === APPLY_TYPE.ONLY_FORMAT || applyType === APPLY_TYPE.SERIES) {
          const { source, target } = location;
          return generalApplyFunc(source, target);
        }
        return noopReturnFunc();
      }, "onFillData")
    };
    this.disposeWithMe(this._autoFillService.addHook(hook));
  }
}, __name(_a8, "ConditionalFormattingAutoFillController"), _a8);
ConditionalFormattingAutoFillController = __decorateClass$6([
  __decorateParam$6(0, Inject(Injector)),
  __decorateParam$6(1, Inject(IUniverInstanceService)),
  __decorateParam$6(2, Inject(IAutoFillService)),
  __decorateParam$6(3, Inject(ConditionalFormattingRuleModel)),
  __decorateParam$6(4, Inject(ConditionalFormattingViewModel))
], ConditionalFormattingAutoFillController);
var __defProp$5 = Object.defineProperty, __getOwnPropDesc$5 = Object.getOwnPropertyDescriptor, __decorateClass$5 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$5(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$5(target, key, result), result;
}, "__decorateClass$5"), __decorateParam$5 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$5"), _a9;
let ConditionalFormattingClearController = (_a9 = class extends Disposable {
  constructor(_injector, _univerInstanceService, _sheetInterceptorService, _selectionManagerService, _conditionalFormattingRuleModel) {
    super(), this._injector = _injector, this._univerInstanceService = _univerInstanceService, this._sheetInterceptorService = _sheetInterceptorService, this._selectionManagerService = _selectionManagerService, this._conditionalFormattingRuleModel = _conditionalFormattingRuleModel, this._init();
  }
  _init() {
    this.disposeWithMe(this._sheetInterceptorService.interceptCommand({
      getMutations: /* @__PURE__ */ __name((commandInfo) => {
        var _a15;
        const redos = [], undos = [], defaultV = { redos, undos };
        if ([ClearSelectionFormatCommand.id, ClearSelectionAllCommand.id].includes(commandInfo.id)) {
          const ranges = (_a15 = this._selectionManagerService.getCurrentSelections()) == null ? void 0 : _a15.map((s) => s.range);
          if (!ranges)
            return defaultV;
          const workbook = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), worksheet = workbook.getActiveSheet();
          if (!worksheet)
            return defaultV;
          const unitId = workbook.getUnitId(), subUnitId = worksheet.getSheetId(), allRules = this._conditionalFormattingRuleModel.getSubunitRules(unitId, subUnitId);
          if (!allRules || !allRules.length)
            return defaultV;
          const { redos: interceptRedos, undos: interceptUndos } = generateClearCfMutations(this._injector, allRules, ranges, unitId, subUnitId);
          redos.push(...interceptRedos), undos.push(...interceptUndos);
        }
        return defaultV;
      }, "getMutations")
    })), this.disposeWithMe(this._sheetInterceptorService.interceptRanges({
      getMutations: /* @__PURE__ */ __name(({ unitId, subUnitId, ranges }) => {
        const redos = [], undos = [], emptyInterceptorArr = { redos, undos };
        if (!ranges || !ranges.length)
          return emptyInterceptorArr;
        const allRules = this._conditionalFormattingRuleModel.getSubunitRules(unitId, subUnitId);
        if (!allRules || !allRules.length)
          return emptyInterceptorArr;
        const { redos: interceptRedos, undos: interceptUndos } = generateClearCfMutations(this._injector, allRules, ranges, unitId, subUnitId);
        return redos.push(...interceptRedos), undos.push(...interceptUndos), emptyInterceptorArr;
      }, "getMutations")
    }));
  }
}, __name(_a9, "ConditionalFormattingClearController"), _a9);
ConditionalFormattingClearController = __decorateClass$5([
  __decorateParam$5(0, Inject(Injector)),
  __decorateParam$5(1, Inject(IUniverInstanceService)),
  __decorateParam$5(2, Inject(SheetInterceptorService)),
  __decorateParam$5(3, Inject(SheetsSelectionsService)),
  __decorateParam$5(4, Inject(ConditionalFormattingRuleModel))
], ConditionalFormattingClearController);
function generateClearCfMutations(injector, allRules, ranges, unitId, subUnitId) {
  const redos = [], undos = [];
  return allRules.filter((rule) => ranges.some((range) => rule.ranges.some((ruleRange2) => Rectangle.getIntersects(ruleRange2, range)))).forEach((rule) => {
    const mergeRanges = new RangeMergeUtil().add(...rule.ranges).subtract(...ranges).merge();
    if (mergeRanges.length) {
      const redo = {
        id: SetConditionalRuleMutation.id,
        params: {
          unitId,
          subUnitId,
          rule: { ...rule, ranges: mergeRanges }
        }
      }, undo = setConditionalRuleMutationUndoFactory(injector, redo.params);
      redos.push(redo), undos.push(...undo);
    } else {
      const redo = {
        id: DeleteConditionalRuleMutation.id,
        params: {
          unitId,
          subUnitId,
          cfId: rule.cfId
        }
      }, undo = DeleteConditionalRuleMutationUndoFactory(injector, redo.params);
      redos.push(redo), undos.push(...undo);
    }
  }), { redos, undos };
}
__name(generateClearCfMutations, "generateClearCfMutations");
var __defProp$4 = Object.defineProperty, __getOwnPropDesc$4 = Object.getOwnPropertyDescriptor, __decorateClass$4 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$4(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$4(target, key, result), result;
}, "__decorateClass$4"), __decorateParam$4 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$4"), _a10;
let ConditionalFormattingEditorController = (_a10 = class extends Disposable {
  constructor(_sheetInterceptorService, _conditionalFormattingService) {
    super(), this._sheetInterceptorService = _sheetInterceptorService, this._conditionalFormattingService = _conditionalFormattingService, this._initInterceptorEditorEnd();
  }
  /**
   * Process the  values after  edit
   * @private
   * @memberof NumfmtService
   */
  _initInterceptorEditorEnd() {
    this.disposeWithMe(
      toDisposable(
        this._sheetInterceptorService.writeCellInterceptor.intercept(
          AFTER_CELL_EDIT,
          {
            handler: /* @__PURE__ */ __name((value, context, next) => {
              var _a15, _b, _c;
              value || next(value);
              const result = this._conditionalFormattingService.composeStyle(context.unitId, context.subUnitId, context.row, context.col), cfStyle = (_a15 = result == null ? void 0 : result.style) != null ? _a15 : {}, keys = Object.keys(cfStyle);
              if (value != null && value.p)
                return (_c = (_b = value.p.body) == null ? void 0 : _b.textRuns) == null || _c.forEach((item2) => {
                  item2.ts && keys.forEach((key) => {
                    var _a16;
                    (_a16 = item2.ts) == null || delete _a16[key];
                  });
                }), next(value);
              {
                const s = { ...(typeof (value == null ? void 0 : value.s) == "string" ? context.workbook.getStyles().get(value.s) : value == null ? void 0 : value.s) || {} };
                keys.forEach((key) => {
                  delete s[key];
                });
                const cellData = { ...value, s: { ...s } };
                return next(cellData);
              }
            }, "handler")
          }
        )
      )
    );
  }
}, __name(_a10, "ConditionalFormattingEditorController"), _a10);
ConditionalFormattingEditorController = __decorateClass$4([
  __decorateParam$4(0, Inject(SheetInterceptorService)),
  __decorateParam$4(1, Inject(ConditionalFormattingService))
], ConditionalFormattingEditorController);
const commandList = [
  SetWorksheetActiveOperation.id,
  AddConditionalRuleMutation.id,
  SetConditionalRuleMutation.id,
  DeleteConditionalRuleMutation.id,
  MoveConditionalRuleMutation.id
], commonSelections = [
  {
    label: "sheet.cf.ruleType.highlightCell",
    value: CF_MENU_OPERATION.highlightCell
  },
  {
    label: "sheet.cf.panel.rankAndAverage",
    value: CF_MENU_OPERATION.rank
  },
  {
    label: "sheet.cf.ruleType.formula",
    value: CF_MENU_OPERATION.formula
  },
  {
    label: "sheet.cf.ruleType.colorScale",
    value: CF_MENU_OPERATION.colorScale
  },
  {
    label: "sheet.cf.ruleType.dataBar",
    value: CF_MENU_OPERATION.dataBar
  },
  {
    label: "sheet.cf.ruleType.iconSet",
    value: CF_MENU_OPERATION.icon
  },
  {
    label: "sheet.cf.menu.manageConditionalFormatting",
    value: CF_MENU_OPERATION.viewRule
  },
  {
    label: "sheet.cf.menu.createConditionalFormatting",
    value: CF_MENU_OPERATION.createRule
  },
  {
    label: "sheet.cf.menu.clearRangeRules",
    value: CF_MENU_OPERATION.clearRangeRules,
    disabled: !1
  },
  {
    label: "sheet.cf.menu.clearWorkSheetRules",
    value: CF_MENU_OPERATION.clearWorkSheetRules
  }
], FactoryManageConditionalFormattingRule = /* @__PURE__ */ __name((accessor) => {
  const selectionManagerService = accessor.get(SheetsSelectionsService), commandService = accessor.get(ICommandService), univerInstanceService = accessor.get(IUniverInstanceService), conditionalFormattingRuleModel = accessor.get(ConditionalFormattingRuleModel), clearRangeEnable$ = new Observable((subscriber) => merge(
    selectionManagerService.selectionMoveEnd$,
    selectionManagerService.selectionSet$,
    new Observable((commandSubscribe) => {
      const disposable = commandService.onCommandExecuted((commandInfo) => {
        var _a15;
        const { id, params } = commandInfo, unitId = (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET)) == null ? void 0 : _a15.getUnitId();
        commandList.includes(id) && params.unitId === unitId && commandSubscribe.next(null);
      });
      return () => disposable.dispose();
    })
  ).pipe(debounceTime$1(16)).subscribe(() => {
    var _a15;
    const ranges = ((_a15 = selectionManagerService.getCurrentSelections()) == null ? void 0 : _a15.map((selection) => selection.range)) || [], workbook = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET);
    if (!workbook) return;
    const worksheet = workbook.getActiveSheet();
    if (!worksheet) return;
    const hasPermission = (conditionalFormattingRuleModel.getSubunitRules(workbook.getUnitId(), worksheet.getSheetId()) || []).filter((rule) => rule.ranges.some((ruleRange2) => ranges.some((range) => Rectangle.intersects(range, ruleRange2)))).map((rule) => rule.ranges).every((ranges2) => checkRangesEditablePermission(accessor, workbook.getUnitId(), worksheet.getSheetId(), ranges2));
    subscriber.next(hasPermission);
  })), clearSheetEnable$ = new Observable(
    (subscriber) => new Observable((commandSubscribe) => {
      const disposable = commandService.onCommandExecuted((commandInfo) => {
        var _a15;
        const { id, params } = commandInfo, unitId = (_a15 = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET)) == null ? void 0 : _a15.getUnitId();
        commandList.includes(id) && params.unitId === unitId && commandSubscribe.next(null);
      });
      return () => disposable.dispose();
    }).pipe(debounceTime$1(16)).subscribe(() => {
      const workbook = univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET);
      if (!workbook) return;
      const worksheet = workbook.getActiveSheet();
      if (!worksheet) return;
      const allRule = conditionalFormattingRuleModel.getSubunitRules(workbook.getUnitId(), worksheet.getSheetId()) || [];
      if (!allRule.length)
        return subscriber.next(!1), !1;
      const hasPermission = allRule.map((rule) => rule.ranges).every((ranges) => checkRangesEditablePermission(accessor, workbook.getUnitId(), worksheet.getSheetId(), ranges));
      subscriber.next(hasPermission);
    })
  ), selections$ = new Observable((subscriber) => {
    clearRangeEnable$.subscribe((v) => {
      const item2 = commonSelections.find((item22) => item22.value === CF_MENU_OPERATION.clearRangeRules);
      item2 && (item2.disabled = !v, subscriber.next(commonSelections));
    }), clearSheetEnable$.subscribe((v) => {
      const item2 = commonSelections.find((item22) => item22.value === CF_MENU_OPERATION.clearWorkSheetRules);
      item2 && (item2.disabled = !v, subscriber.next(commonSelections));
    }), subscriber.next(commonSelections);
  });
  return {
    id: OpenConditionalFormattingOperator.id,
    type: MenuItemType.SELECTOR,
    icon: "Conditions",
    tooltip: "sheet.cf.title",
    selections: selections$,
    hidden$: getMenuHiddenObservable(accessor, UniverInstanceType.UNIVER_SHEET),
    disabled$: getCurrentRangeDisable$(accessor, { workbookTypes: [WorkbookEditablePermission], worksheetTypes: [WorksheetSetCellStylePermission, WorksheetEditPermission], rangeTypes: [RangeProtectionPermissionEditPoint] })
  };
}, "FactoryManageConditionalFormattingRule"), menuSchema = {
  [RibbonStartGroup.FORMULAS_INSERT]: {
    [OpenConditionalFormattingOperator.id]: {
      order: 0,
      menuItemFactory: FactoryManageConditionalFormattingRule
    }
  }
};
var __defProp$3 = Object.defineProperty, __getOwnPropDesc$3 = Object.getOwnPropertyDescriptor, __decorateClass$3 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$3(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$3(target, key, result), result;
}, "__decorateClass$3"), __decorateParam$3 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$3"), _a11;
let ConditionalFormattingMenuController = (_a11 = class extends Disposable {
  constructor(_injector, _menuManagerService) {
    super();
    __publicField(this, "_sidebarDisposable", null);
    this._injector = _injector, this._menuManagerService = _menuManagerService, this._menuManagerService.mergeMenu(menuSchema);
  }
}, __name(_a11, "ConditionalFormattingMenuController"), _a11);
ConditionalFormattingMenuController = __decorateClass$3([
  __decorateParam$3(0, Inject(Injector)),
  __decorateParam$3(1, IMenuManagerService)
], ConditionalFormattingMenuController);
var __defProp$2 = Object.defineProperty, __getOwnPropDesc$2 = Object.getOwnPropertyDescriptor, __decorateClass$2 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$2(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$2(target, key, result), result;
}, "__decorateClass$2"), __decorateParam$2 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$2");
const repeatByRange = /* @__PURE__ */ __name((sourceRange, targetRange) => {
  const getRowLength = /* @__PURE__ */ __name((range) => range.endRow - range.startRow + 1, "getRowLength"), getColLength = /* @__PURE__ */ __name((range) => range.endColumn - range.startColumn + 1, "getColLength"), rowMod = getRowLength(targetRange) % getRowLength(sourceRange), colMod = getColLength(targetRange) % getColLength(sourceRange), repeatRow = Math.floor(getRowLength(targetRange) / getRowLength(sourceRange)), repeatCol = Math.floor(getColLength(targetRange) / getColLength(sourceRange)), repeatList = [], repeatRelativeRange = {
    startRow: 0,
    endRow: getRowLength(sourceRange) - 1,
    startColumn: 0,
    endColumn: getColLength(sourceRange) - 1
  };
  if (getRowLength(targetRange) === 1 && getColLength(targetRange) === 1) {
    const startRange = {
      startRow: targetRange.startRow,
      endRow: targetRange.startRow,
      startColumn: targetRange.startColumn,
      endColumn: targetRange.startColumn
    };
    return repeatList.push({ repeatRelativeRange, startRange }), repeatList;
  }
  for (let countRow = 0; countRow < repeatRow + (rowMod ? 0.1 : 0); countRow++)
    for (let countCol = 0; countCol < repeatCol + (colMod ? 0.1 : 0); countCol++) {
      const row = getRowLength(sourceRange) * countRow, col = getColLength(sourceRange) * countCol, startRange = {
        startRow: row + targetRange.startRow,
        endRow: row + targetRange.startRow,
        startColumn: col + targetRange.startColumn,
        endColumn: col + targetRange.startColumn
      };
      let _repeatRelativeRange = repeatRelativeRange;
      countRow === repeatRow && rowMod && (_repeatRelativeRange = { ..._repeatRelativeRange }, _repeatRelativeRange.endRow = _repeatRelativeRange.endRow - (getRowLength(sourceRange) - rowMod)), countCol === repeatCol && colMod && (_repeatRelativeRange = { ..._repeatRelativeRange }, _repeatRelativeRange.endColumn = _repeatRelativeRange.endColumn - (getColLength(sourceRange) - colMod)), repeatList.push({ repeatRelativeRange: _repeatRelativeRange, startRange });
    }
  return repeatList;
}, "repeatByRange");
var _a12;
let ConditionalFormattingPainterController = (_a12 = class extends Disposable {
  constructor(_injector, _univerInstanceService, _formatPainterService, _sheetsSelectionsService, _conditionalFormattingRuleModel, _conditionalFormattingViewModel) {
    super();
    __publicField(this, "_painterConfig", null);
    this._injector = _injector, this._univerInstanceService = _univerInstanceService, this._formatPainterService = _formatPainterService, this._sheetsSelectionsService = _sheetsSelectionsService, this._conditionalFormattingRuleModel = _conditionalFormattingRuleModel, this._conditionalFormattingViewModel = _conditionalFormattingViewModel, this._initFormattingPainter();
  }
  // eslint-disable-next-line max-lines-per-function
  _initFormattingPainter() {
    const noopReturnFunc = /* @__PURE__ */ __name(() => ({ redos: [], undos: [] }), "noopReturnFunc"), loopFunc = /* @__PURE__ */ __name((sourceStartCell, targetStartCell, relativeRange, matrixMap, config) => {
      const { unitId: sourceUnitId, subUnitId: sourceSubUnitId } = this._painterConfig, { targetUnitId, targetSubUnitId } = config, sourceRange = {
        startRow: sourceStartCell.row,
        startColumn: sourceStartCell.col,
        endColumn: sourceStartCell.col,
        endRow: sourceStartCell.row
      }, targetRange = {
        startRow: targetStartCell.row,
        startColumn: targetStartCell.col,
        endColumn: targetStartCell.col,
        endRow: targetStartCell.row
      };
      Range.foreach(relativeRange, (row, col) => {
        const sourcePositionRange = Rectangle.getPositionRange(
          {
            startRow: row,
            startColumn: col,
            endColumn: col,
            endRow: row
          },
          sourceRange
        ), targetPositionRange = Rectangle.getPositionRange(
          {
            startRow: row,
            startColumn: col,
            endColumn: col,
            endRow: row
          },
          targetRange
        ), sourceCellCf = this._conditionalFormattingViewModel.getCellCfs(
          sourceUnitId,
          sourceSubUnitId,
          sourcePositionRange.startRow,
          sourcePositionRange.startColumn
        ), targetCellCf = this._conditionalFormattingViewModel.getCellCfs(
          targetUnitId,
          targetSubUnitId,
          targetPositionRange.startRow,
          targetPositionRange.startColumn
        );
        targetCellCf && targetCellCf.forEach((cf) => {
          let matrix = matrixMap.get(cf.cfId);
          if (!matrixMap.get(cf.cfId)) {
            const rule = this._conditionalFormattingRuleModel.getRule(targetUnitId, targetSubUnitId, cf.cfId);
            if (!rule)
              return;
            matrix = new ObjectMatrix(), rule.ranges.forEach((range) => {
              Range.foreach(range, (row2, col2) => {
                matrix.setValue(row2, col2, 1);
              });
            }), matrixMap.set(cf.cfId, matrix);
          }
          matrix.realDeleteValue(targetPositionRange.startRow, targetPositionRange.startColumn);
        }), sourceCellCf && sourceCellCf.forEach((cf) => {
          const matrix = matrixMap.get(cf.cfId);
          matrix && matrix.setValue(targetPositionRange.startRow, targetPositionRange.startColumn, 1);
        });
      });
    }, "loopFunc"), generalApplyFunc = /* @__PURE__ */ __name((targetUnitId, targetSubUnitId, targetRange) => {
      var _a15;
      const { range: sourceRange, unitId: sourceUnitId, subUnitId: sourceSubUnitId } = this._painterConfig, isSkipSheet = targetUnitId !== sourceUnitId || sourceSubUnitId !== targetSubUnitId, matrixMap = /* @__PURE__ */ new Map(), redos = [], undos = [];
      if (!targetUnitId || !targetSubUnitId || !sourceUnitId || !sourceSubUnitId)
        return noopReturnFunc();
      const ruleList = (_a15 = this._conditionalFormattingRuleModel.getSubunitRules(sourceUnitId, sourceSubUnitId)) != null ? _a15 : [];
      ruleList == null || ruleList.forEach((rule) => {
        const { ranges, cfId } = rule;
        if (ranges.some((range) => Rectangle.intersects(sourceRange, range))) {
          const matrix = new ObjectMatrix();
          isSkipSheet || ranges.forEach((range) => {
            Range.foreach(range, (row, col) => {
              matrix.setValue(row, col, 1);
            });
          }), matrixMap.set(cfId, matrix);
        }
      });
      const sourceStartCell = {
        row: sourceRange.startRow,
        col: sourceRange.startColumn
      };
      return repeatByRange(sourceRange, targetRange).forEach((repeat) => {
        loopFunc(sourceStartCell, { row: repeat.startRange.startRow, col: repeat.startRange.startColumn }, repeat.repeatRelativeRange, matrixMap, { targetUnitId, targetSubUnitId });
      }), matrixMap.forEach((item2, cfId) => {
        if (isSkipSheet) {
          const rule = this._conditionalFormattingRuleModel.getRule(targetUnitId, targetSubUnitId, cfId), ranges = findAllRectangle(createTopMatrixFromMatrix(item2));
          if (rule)
            if (ranges.length) {
              const params = {
                unitId: targetUnitId,
                subUnitId: targetSubUnitId,
                rule: { ...rule, ranges }
              };
              redos.push({ id: SetConditionalRuleMutation.id, params }), undos.push(...setConditionalRuleMutationUndoFactory(this._injector, params));
            } else {
              const params = {
                unitId: targetUnitId,
                subUnitId: targetSubUnitId,
                cfId: rule.cfId
              };
              redos.push({ id: DeleteConditionalRuleMutation.id, params }), undos.push(...DeleteConditionalRuleMutationUndoFactory(this._injector, params));
            }
          else if (ranges.length) {
            const sourceRule = this._conditionalFormattingRuleModel.getRule(sourceUnitId, sourceSubUnitId, cfId);
            if (sourceRule) {
              const params = {
                unitId: targetUnitId,
                subUnitId: targetSubUnitId,
                rule: {
                  ...Tools.deepClone(sourceRule),
                  cfId: this._conditionalFormattingRuleModel.createCfId(targetUnitId, targetSubUnitId),
                  ranges
                }
              };
              redos.push({ id: AddConditionalRuleMutation.id, params }), undos.push(AddConditionalRuleMutationUndoFactory(this._injector, params));
            }
          }
        } else {
          const rule = this._conditionalFormattingRuleModel.getRule(sourceUnitId, sourceSubUnitId, cfId);
          if (!rule)
            return;
          const ranges = findAllRectangle(createTopMatrixFromMatrix(item2));
          if (ranges.length) {
            const params = {
              unitId: sourceUnitId,
              subUnitId: sourceSubUnitId,
              rule: { ...rule, ranges }
            };
            redos.push({ id: SetConditionalRuleMutation.id, params }), undos.push(...setConditionalRuleMutationUndoFactory(this._injector, params));
          } else {
            const params = {
              unitId: sourceUnitId,
              subUnitId: sourceSubUnitId,
              cfId: rule.cfId
            };
            redos.push({ id: DeleteConditionalRuleMutation.id, params }), undos.push(...DeleteConditionalRuleMutationUndoFactory(this._injector, params));
          }
        }
      }), {
        undos,
        redos
      };
    }, "generalApplyFunc"), hook = {
      id: SHEET_CONDITIONAL_FORMATTING_PLUGIN,
      onStatusChange: /* @__PURE__ */ __name((status) => {
        var _a15, _b, _c;
        switch (status) {
          case FormatPainterStatus.INFINITE:
          case FormatPainterStatus.ONCE: {
            const unitId = (_a15 = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET)) == null ? void 0 : _a15.getUnitId(), subUnitId = (_c = (_b = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET)) == null ? void 0 : _b.getActiveSheet()) == null ? void 0 : _c.getSheetId(), selection = this._sheetsSelectionsService.getCurrentLastSelection(), range = selection == null ? void 0 : selection.range;
            unitId && subUnitId && range && (this._painterConfig = { unitId, subUnitId, range });
            break;
          }
          case FormatPainterStatus.OFF: {
            this._painterConfig = null;
            break;
          }
        }
      }, "onStatusChange"),
      onApply: /* @__PURE__ */ __name((unitId, subUnitId, targetRange) => this._painterConfig ? generalApplyFunc(unitId, subUnitId, targetRange) : {
        redos: [],
        undos: []
      }, "onApply")
    };
    this._formatPainterService.addHook(hook);
  }
}, __name(_a12, "ConditionalFormattingPainterController"), _a12);
ConditionalFormattingPainterController = __decorateClass$2([
  __decorateParam$2(0, Inject(Injector)),
  __decorateParam$2(1, Inject(IUniverInstanceService)),
  __decorateParam$2(2, Inject(IFormatPainterService)),
  __decorateParam$2(3, Inject(SheetsSelectionsService)),
  __decorateParam$2(4, Inject(ConditionalFormattingRuleModel)),
  __decorateParam$2(5, Inject(ConditionalFormattingViewModel))
], ConditionalFormattingPainterController);
var __defProp$1 = Object.defineProperty, __getOwnPropDesc$1 = Object.getOwnPropertyDescriptor, __decorateClass$1 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$1(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$1(target, key, result), result;
}, "__decorateClass$1"), __decorateParam$1 = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam$1"), _a13;
let ConditionalFormattingViewportController = (_a13 = class extends Disposable {
  constructor(_conditionalFormattingViewModel, _univerInstanceService, _renderManagerService) {
    super(), this._conditionalFormattingViewModel = _conditionalFormattingViewModel, this._univerInstanceService = _univerInstanceService, this._renderManagerService = _renderManagerService, this._init();
  }
  _init() {
    const unit = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), bindUnit = /* @__PURE__ */ __name((unit2) => {
      const unitId = unit2.getUnitId(), render2 = this._renderManagerService.getRenderById(unitId);
      if (!render2)
        return;
      const sheetSkeletonManagerService = render2.with(SheetSkeletonManagerService);
      this.disposeWithMe(sheetSkeletonManagerService.currentSkeleton$.subscribe((s) => {
        if (s) {
          const range = s.skeleton.rowColumnSegment, col = range.endColumn - range.startColumn + 1, length = (range.endRow - range.startRow + 1) * col * 9, result = Math.max(CONDITIONAL_FORMATTING_VIEWPORT_CACHE_LENGTH, length);
          this._conditionalFormattingViewModel.setCacheLength(result);
        }
      }));
    }, "bindUnit");
    unit && bindUnit(unit), this._univerInstanceService.getCurrentTypeOfUnit$(UniverInstanceType.UNIVER_SHEET).subscribe((unit2) => {
      unit2 && bindUnit(unit2);
    });
  }
}, __name(_a13, "ConditionalFormattingViewportController"), _a13);
ConditionalFormattingViewportController = __decorateClass$1([
  __decorateParam$1(0, Inject(ConditionalFormattingViewModel)),
  __decorateParam$1(1, IUniverInstanceService),
  __decorateParam$1(2, IRenderManagerService)
], ConditionalFormattingViewportController);
var __defProp2 = Object.defineProperty, __getOwnPropDesc = Object.getOwnPropertyDescriptor, __defNormalProp2 = /* @__PURE__ */ __name((obj, key, value) => key in obj ? __defProp2(obj, key, { enumerable: !0, configurable: !0, writable: !0, value }) : obj[key] = value, "__defNormalProp"), __decorateClass = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp2(target, key, result), result;
}, "__decorateClass"), __decorateParam = /* @__PURE__ */ __name((index2, decorator) => (target, key) => decorator(target, key, index2), "__decorateParam"), __publicField2 = /* @__PURE__ */ __name((obj, key, value) => __defNormalProp2(obj, typeof key != "symbol" ? key + "" : key, value), "__publicField"), _a14;
let UniverSheetsConditionalFormattingUIPlugin = (_a14 = class extends Plugin {
  constructor(_config = defaultPluginConfig, _injector, _commandService, _configService) {
    super(), this._config = _config, this._injector = _injector, this._commandService = _commandService, this._configService = _configService;
    const { menu, ...rest } = merge$1(
      {},
      defaultPluginConfig,
      this._config
    );
    menu && this._configService.setConfig("menu", menu, { merge: !0 }), this._configService.setConfig(SHEETS_CONDITIONAL_FORMATTING_UI_PLUGIN_CONFIG_KEY, rest), this._initCommand();
  }
  onStarting() {
    registerDependencies(this._injector, [
      [SheetsCfRenderController],
      [SheetsCfRefRangeController],
      [ConditionalFormattingCopyPasteController],
      [ConditionalFormattingAutoFillController],
      [ConditionalFormattingPermissionController],
      [ConditionalFormattingPanelController],
      [ConditionalFormattingMenuController],
      [ConditionalFormattingI18nController],
      [ConditionalFormattingEditorController],
      [ConditionalFormattingClearController],
      [ConditionalFormattingPainterController],
      [ConditionalFormattingViewportController]
    ]), touchDependencies(this._injector, [
      [SheetsCfRenderController]
    ]);
  }
  onReady() {
    touchDependencies(this._injector, [
      [ConditionalFormattingMenuController],
      [ConditionalFormattingPanelController]
    ]);
  }
  onRendered() {
    touchDependencies(this._injector, [
      [ConditionalFormattingAutoFillController],
      [ConditionalFormattingClearController],
      [ConditionalFormattingCopyPasteController],
      [ConditionalFormattingEditorController],
      [ConditionalFormattingI18nController],
      [ConditionalFormattingPainterController],
      [ConditionalFormattingPermissionController],
      [SheetsCfRefRangeController],
      [ConditionalFormattingViewportController]
    ]);
  }
  _initCommand() {
    [
      AddAverageCfCommand,
      AddColorScaleConditionalRuleCommand,
      AddDataBarConditionalRuleCommand,
      AddDuplicateValuesCfCommand,
      AddNumberCfCommand,
      AddRankCfCommand,
      AddTextCfCommand,
      AddTimePeriodCfCommand,
      AddUniqueValuesCfCommand,
      OpenConditionalFormattingOperator,
      DeleteCfCommand,
      SetCfCommand,
      MoveCfCommand,
      AddCfCommand,
      ClearRangeCfCommand,
      ClearWorksheetCfCommand
    ].forEach((m) => {
      this._commandService.registerCommand(m);
    });
  }
}, __name(_a14, "UniverSheetsConditionalFormattingUIPlugin"), _a14);
__publicField2(UniverSheetsConditionalFormattingUIPlugin, "pluginName", `${SHEET_CONDITIONAL_FORMATTING_PLUGIN}_UI_PLUGIN`);
__publicField2(UniverSheetsConditionalFormattingUIPlugin, "type", UniverInstanceType.UNIVER_SHEET);
UniverSheetsConditionalFormattingUIPlugin = __decorateClass([
  DependentOn(UniverSheetsConditionalFormattingPlugin),
  __decorateParam(1, Inject(Injector)),
  __decorateParam(2, Inject(ICommandService)),
  __decorateParam(3, IConfigService)
], UniverSheetsConditionalFormattingUIPlugin);
export {
  AddAverageCfCommand,
  AddCfCommand,
  AddColorScaleConditionalRuleCommand,
  AddDataBarConditionalRuleCommand,
  AddDuplicateValuesCfCommand,
  AddNumberCfCommand,
  AddRankCfCommand,
  AddTextCfCommand,
  AddTimePeriodCfCommand,
  AddUniqueValuesCfCommand,
  ClearRangeCfCommand,
  ClearWorksheetCfCommand,
  ConditionalFormattingClearController,
  DeleteCfCommand,
  MoveCfCommand,
  OpenConditionalFormattingOperator,
  SetCfCommand,
  UniverSheetsConditionalFormattingMobileUIPlugin,
  UniverSheetsConditionalFormattingUIPlugin
};
